# Snek5000-cbox

<div align="center">

[![PyPI](https://img.shields.io/pypi/v/snek5000-cbox)](https://pypi.org/project/snek5000-cbox/)
[![Tests Status](https://github.com/snek5000/snek5000-cbox/workflows/Tests/badge.svg)](https://github.com/snek5000/snek5000-cbox/actions?workflow=Tests)

<!-- badges -->

</div>

A [Snek5000](https://github.com/snek5000/snek5000) solver for simulating
differentially heated and cooled convective box with
[NEK5000](https://nek5000.github.io/NekDoc/).

## Install

```bash
pip install snek5000-cbox
```

For more details, see https://snek5000.readthedocs.io/en/latest/install.html

# KTH Toolbox

This directory contains the [turbulence statistics tools](https://github.com/KTH-Nek5000/KTH_Toolbox/).

## Tool list:
* [frame](https://kth-nek5000.github.io/KTH_Framework/group__frame.html) - backbone of the toolbox
* [monitor](https://kth-nek5000.github.io/KTH_Framework/group__monitor.html) - monitoring tool: logging and timing
* [runparam](https://kth-nek5000.github.io/KTH_Framework/group__runparam.html) - runtime parameters
* [io_tool](https://kth-nek5000.github.io/KTH_Framework/group__io__tools.html) - simple I/O tools
* [checkpoint](https://kth-nek5000.github.io/KTH_Framework/group__chkpoint.html) - checkpointing main interface
* [mstep](https://kth-nek5000.github.io/KTH_Framework/group__chkpoint__mstep.html) - multi-step checkpointing
* [math](https://kth-nek5000.github.io/KTH_Framework/group__math.html) - simple math tools
* [map2D] - 3D to 2D grid mapping for 2D-extruded meshes
* [stat] - turbulence statistics tool

!> @file mntrtmr.f
!! @ingroup monitor
!! @brief Set of timer database routines for KTH framework
!! @author Adam Peplinski
!! @date Oct 13, 2017
!=======================================================================
!> @brief Register new timer
!! @ingroup monitor
!! @param[out] mid      new timer id
!! @param[in]  pmid     parent timer id
!! @param[in]  modid    registerring module id
!! @param[in]  mname    timer name
!! @param[in]  mdscr    timer description
!! @param[in]  ifsum    add timer to parent
      subroutine mntr_tmr_reg(mid,pmid,modid,mname,mdscr,ifsum)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'MNTRLOGD'
      include 'MNTRTMRD'
      include 'FRAMELP'

      ! argument list
      integer mid, pmid, modid
      character*(*) mname, mdscr
      logical ifsum

      ! local variables
      character*10  lname
      character*132 ldscr
      integer slen,slena

      integer il, ipos
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(mname))
      ! remove trailing blanks
      slen = len_trim(mname) - slena + 1
      if (slena.gt.mntr_lstl_mnm) then
         call mntr_log(mntr_id,lp_deb,
     $        'too long timer name; shortenning')
         slena = min(slena,mntr_lstl_mnm)
      endif
      call blank(lname,mntr_lstl_mnm)
      lname= mname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! check description length
      slena = len_trim(adjustl(mdscr))
      ! remove trailing blanks
      slen = len_trim(mdscr) - slena + 1
      if (slena.ge.mntr_lstl_mds) then
         call mntr_log(mntr_id,lp_deb,
     $        'too long timer description; shortenning')
         slena = min(slena,mntr_lstl_mnm)
      endif
      call blank(ldscr,mntr_lstl_mds)
      ldscr= mdscr(slen:slen + slena - 1)

      ! find empty space
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.mntr_pid0) then

         ! check if module is already registered
         do il=1,mntr_tmr_mpos
            if (mntr_tmr_id(mntr_tmr_mark,il).ge.0.and.
     $         mntr_tmr_name(il).eq.lname) then
               ipos = -il
               exit
            endif
         enddo

         ! find empty spot
         if (ipos.eq.0) then
            do il=1,mntr_tmr_id_max
               if (mntr_tmr_id(mntr_tmr_mark,il).eq.-1) then
                  ipos = il
                  exit
               endif
            enddo
         endif
      endif

      ! broadcast mid
      call bcast(ipos,isize)

      ! error; no free space found
      if (ipos.eq.0) then
         mid = ipos
         call mntr_abort(mntr_id,
     $        'timer ['//trim(lname)//'] cannot be registered')
      ! module already registered
      elseif (ipos.lt.0) then
         mid = abs(ipos)
         call mntr_abort(mntr_id,
     $    'timer ['//trim(lname)//'] is already registered')
      ! new module
      else
         mid = ipos
         ! check if parent timer is registered
         if (pmid.gt.0) then
            if (mntr_tmr_id(mntr_tmr_mark,pmid).ge.0) then
               mntr_tmr_id(mntr_tmr_mark,ipos) = pmid
            else
               mntr_tmr_id(mntr_tmr_mark,ipos) = 0
               call mntr_log(mntr_id,lp_inf,
     $       "timer's ["//trim(lname)//"] parent not registered.")
            endif
         else
            mntr_tmr_id(mntr_tmr_mark,ipos) = 0
         endif

         ! check if registerring module is registered
         if (modid.gt.0) then
            if (mntr_mod_id(modid).ge.0) then
               mntr_tmr_id(mntr_tmr_mod,ipos) = modid
            else
               mntr_tmr_id(mntr_tmr_mod,ipos) = 0
               call mntr_log(mntr_id,lp_inf,
     $       "timer's ["//trim(lname)//"] module not registered.")
            endif
         else
            mntr_tmr_id(mntr_tmr_mod,ipos) = 0
         endif

         mntr_tmr_name(ipos)=lname
         mntr_tmr_dscr(ipos)=ldscr
         mntr_tmr_sum(ipos)=ifsum
         mntr_tmr_num = mntr_tmr_num + 1
         if (mntr_tmr_mpos.lt.ipos) mntr_tmr_mpos = ipos
         call mntr_log(mntr_id,lp_inf,
     $       'Registered timer ['//trim(lname)//']: '//trim(ldscr))
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if timer name is registered and return its id.
!! @ingroup monitor
!! @param[out] mid      timer id
!! @param[in]  mname    timer name
      subroutine mntr_tmr_is_name_reg(mid,mname)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'MNTRLOGD'
      include 'MNTRTMRD'
      include 'FRAMELP'

      ! argument list
      integer mid
      character*(*) mname

      ! local variables
      character*10  lname
      character*3 str
      integer slen,slena

      integer il, ipos
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(mname))
      ! remove trailing blanks
      slen = len_trim(mname) - slena + 1
      if (slena.gt.mntr_lstl_mnm) then
         call mntr_log(mntr_id,lp_deb,
     $          'too long timer name; shortenning')
         slena = min(slena,mntr_lstl_mnm)
      endif
      call blank(lname,mntr_lstl_mnm)
      lname= mname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! find module
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.mntr_pid0) then
         ! check if module is already registered
         do il=1,mntr_tmr_mpos
            if (mntr_tmr_id(mntr_tmr_mark,il).ge.0.and.
     $         mntr_tmr_name(il).eq.lname) then
               ipos = il
               exit
            endif
         enddo
      endif

      ! broadcast ipos
      call bcast(ipos,isize)

      if (ipos.eq.0) then
         mid = -1
         call mntr_log(mntr_id,lp_inf,
     $        'timer ['//trim(lname)//'] not registered')
      else
         mid = ipos
         write(str,'(I3)') ipos
         call mntr_log(mntr_id,lp_vrb,
     $        'timer ['//trim(lname)//'] registered with id='//str)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if timer id is registered. This operation is performed locally
!! @ingroup monitor
!! @param[in] mid      timer id
!! @return mntr_tmr_is_id_reg
      logical function mntr_tmr_is_id_reg(mid)
      implicit none

      include 'SIZE'
      include 'PARALLEL'
      include 'MNTRLOGD'
      include 'MNTRTMRD'
      include 'FRAMELP'

      ! argument list
      integer mid
!-----------------------------------------------------------------------
      mntr_tmr_is_id_reg = mntr_tmr_id(mntr_tmr_mark,mid).ge.0

      return
      end function
!=======================================================================
!> @brief Check if timer id is registered. This operation is performed locally
!! @ingroup monitor
!! @param[in] mid       timer id
!! @param[in] icount    count increase
!! @param[in] time      time increase
      subroutine mntr_tmr_add(mid,icount,time)
      implicit none

      include 'SIZE'
      include 'MNTRLOGD'
      include 'MNTRTMRD'
      include 'FRAMELP'

      ! argument list
      integer mid, icount
      real time

      ! local variables
      character*3 str
!-----------------------------------------------------------------------
      if (mntr_tmr_id(mntr_tmr_mark,mid).ge.0) then
         mntr_tmrv_timer(mntr_tmr_count,mid) =
     $        mntr_tmrv_timer(mntr_tmr_count,mid) + icount

         mntr_tmrv_timer(mntr_tmr_time,mid) =
     $        mntr_tmrv_timer(mntr_tmr_time,mid) + time
      else
         write(str,'(I3)') mid
         call mntr_log(mntr_id,lp_inf,
     $       'timer id='//trim(str)//' in mntr_tmr_add not registered')
      endif

      return
      end subroutine
!=======================================================================
!> @brief Print registered timers showing tree structure
!! @ingroup monitor
      subroutine mntr_tmr_summary_print()
      implicit none

      include 'SIZE'
      include 'MNTRLOGD'
      include 'MNTRTMRD'
      include 'FRAMELP'

      ! local variables
      integer il, jl, maxlev, stride
      parameter (stride=2)
      integer olist(2,mntr_tmr_id_max), ierr, itmp
      real timmin(mntr_tmr_id_max),timmax(mntr_tmr_id_max)
      character*35 ftm
      character*3 str

      ! functions
      integer iglmax
      real glmax, glmin, dnekclock
!-----------------------------------------------------------------------
      call mntr_log(mntr_id,lp_prd,
     $         'Summary of registered timers')

      ! finalise framework timing
      mntr_frame_tmini = dnekclock() - mntr_frame_tmini
      call mntr_tmr_add(mntr_frame_tmr_id,1,mntr_frame_tmini)

      ! get ordered list
      call mntr_tmr_get_olist(olist, ierr)
      ierr = iglmax(ierr,1)
      if (ierr.gt.0) then
         call mntr_error(mntr_id,"Inconsistent timer tree.")
         return
      endif

      ! sum contributions from children if they are marked with mntr_tmr_sum
      ! find max level for this run
      maxlev = 1
      do il=1,mntr_tmr_num
         maxlev = max(maxlev,olist(2,il))
      enddo

      do il=maxlev,1,-1
         do jl=1,mntr_tmr_num
            if (olist(2,jl).eq.il.and.mntr_tmr_sum(olist(1,jl))) then
               itmp = mntr_tmr_id(mntr_tmr_mark,olist(1,jl))
               ! sum iteration count
               mntr_tmrv_timer(mntr_tmr_count,itmp) =
     $             mntr_tmrv_timer(mntr_tmr_count,itmp) +
     $             mntr_tmrv_timer(mntr_tmr_count,olist(1,jl))
               ! sum timer
               mntr_tmrv_timer(mntr_tmr_time,itmp) =
     $             mntr_tmrv_timer(mntr_tmr_time,itmp) +
     $             mntr_tmrv_timer(mntr_tmr_time,olist(1,jl))
            endif
         enddo
      enddo


      ! get max, min timers
      do il=1,mntr_tmr_mpos
         if (mntr_tmr_id(mntr_tmr_mark,il).ge.0) then
            timmin(il) = glmin(mntr_tmrv_timer(mntr_tmr_time,il),1)
            timmax(il) = glmax(mntr_tmrv_timer(mntr_tmr_time,il),1)
         endif
      enddo

      if (nid.eq.mntr_pid0) then

         if(ierr.eq.0.and.mntr_lp_def.le.lp_prd) then

            ! modify max level
            maxlev = maxlev + 1

            ! print description
            if (mntr_iftdsc) then
               write (*,*) ' '
               do il=1,mntr_tmr_num
                  write(str,'(I3)') stride*(olist(2,il))
                  ftm = '("[",A,"]",'//trim(str)//'X,A,'
                  write(str,'(I3)') stride*(maxlev-olist(2,il))
                  ftm = trim(ftm)//trim(str)//'X,": ",A)'
                  jl = olist(1,il)
                  write(*,ftm)
     $               mntr_mod_name(mntr_tmr_id(mntr_tmr_mod,jl)),
     $               mntr_tmr_name(jl), trim(mntr_tmr_dscr(jl))
               enddo
            endif

            ! print values
            write(*,*) ' '
            write(str,'(I3)') mntr_lstl_mnm +stride*maxlev-1
            ftm='(A11,1X,A'//trim(adjustl(str))//',1X,":",4A15)'
            write(*,ftm) 'Module name','Timer name','Count','Min time',
     $                   'Max time', 'Max/count'
            do il=1,mntr_tmr_num
               write(str,'(I3)') stride*(olist(2,il))
               ftm = '("[",A,"]",'//trim(str)//'X,A,'
               write(str,'(I3)') stride*(maxlev-olist(2,il))
               ftm = trim(ftm)//trim(str)//'X,":",4E15.8)'
               jl = olist(1,il)
               write(*,ftm) mntr_mod_name(mntr_tmr_id(mntr_tmr_mod,jl)),
     $           mntr_tmr_name(jl), mntr_tmrv_timer(mntr_tmr_count,jl),
     $           timmin(jl),timmax(jl),
     $           timmax(jl)/max(1.0,mntr_tmrv_timer(mntr_tmr_count,jl))
            enddo
            write(*,*) ' '
         endif
      endif

      return
      end subroutine
!=======================================================================
!> @brief Provide ordered list of registered timers for printing.
!! @ingroup monitor
!! @param[out]   olist    ordered list
!! @param[out]   ierr     error flag
      subroutine mntr_tmr_get_olist(olist,ierr)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'
      include 'MNTRTMRD'

      ! argument list
      integer olist(2,mntr_tmr_id_max), ierr

      ! local variables
      integer ind(mntr_tmr_id_max), level, parent, ipos
      integer slist(2,mntr_tmr_id_max), itmp1(2)
      integer npos, key
      integer il, jl
      integer istart, in, itest
!-----------------------------------------------------------------------
      ierr = 0

      ! sort timer index array
      ! copy data removing possible empty slots
      npos=0
      do il=1,mntr_tmr_mpos
         if (mntr_tmr_id(mntr_tmr_mark,il).ge.0) then
            npos = npos + 1
            slist(1,npos) = mntr_tmr_id(mntr_tmr_mark,il)
            slist(2,npos) = il
         endif
      enddo
      if(npos.ne.mntr_tmr_num) then
         ierr = 1
         call mntr_log(mntr_id,lp_inf,
     $         'Inconsistent timer number; return')
         return
      endif

      ! sort with respect to parent id
      key = 1
      call ituple_sort(slist,2,npos,key,1,ind,itmp1)

      ! sort within children of single parent with respect to child id
      istart = 1
      itest = slist(1,istart)
      do il=1,npos
         if(itest.ne.slist(1,il).or.il.eq.npos) then
           if (il.eq.npos.and.itest.eq.slist(1,il)) then
              jl = npos + 1
           else
              jl = il
           endif
           in = jl - istart
           if (itest.eq.0.and.in.ne.1) then
              call mntr_log(mntr_id,lp_inf,
     $         'Must be single root of the graph; return')
              ierr = 2
              return
           endif
           if (in.gt.1) then
              key = 2
              call ituple_sort(slist(1,istart),2,in,key,1,ind,itmp1)
           endif
           if (il.ne.npos) then
              itest = slist(1,il)
              istart = il
           endif
         endif
      enddo

      parent = 0
      level = 0
      ipos = 1
      call mntr_build_ord_list(olist,slist,npos,ipos,parent,level)

      return
      end subroutine
!=======================================================================

!> @file rprm.f
!! @ingroup runparam
!! @brief Set of subroutines related to module's runtime parameters.
!! @author Adam Peplinski
!! @date Feb 5, 2017
!=======================================================================
!> @brief Register runtime parameters database
!! @ingroup runparam
      subroutine rprm_register
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! local variables
      integer itmp

      ! functions
      integer frame_get_master
!-----------------------------------------------------------------------
      rprm_pid0 = frame_get_master()

      ! check if the current module was already registered
      call mntr_mod_is_name_reg(itmp,rprm_name)
      if (itmp.gt.0) then
         call mntr_warn(itmp,
     $        'module ['//trim(rprm_name)//'] already registered')
         return
      endif

      ! find parent module
      call mntr_mod_is_name_reg(itmp,'FRAME')
      if (itmp.le.0) then
         itmp = 1
         call mntr_abort(itmp,
     $        'parent module ['//'FRAME'//'] not registered')
      endif

      ! register module
      call mntr_mod_reg(rprm_id,itmp,rprm_name,'Runtime parameters')

      ! register and set active section
      call rprm_sec_reg(rprm_lsec_id,rprm_id,'_'//adjustl(rprm_name),
     $     'Runtime parameter section for rprm module')
      call rprm_sec_set_act(.true.,rprm_lsec_id)

      ! register parameters
      call rprm_rp_reg(rprm_ifparf_id,rprm_lsec_id,'PARFWRITE',
     $     'Do we write runtime parameter file',rpar_log,0,
     $      0.0,.false.,' ')

      call rprm_rp_reg(rprm_parfnm_id,rprm_lsec_id,'PARFNAME',
     $   'Runtime parameter file name for output (without .par)',
     $   rpar_str,0,0.0,.false.,'outparfile')

      return
      end subroutine
!=======================================================================
!> @brief Initialise modules runtime parameters and write summary
!! @ingroup runparam
      subroutine rprm_init
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! local variables
      integer itmp
      real rtmp
      logical ltmp
      character*20 ctmp
      integer iunit, ierr
      character*30 fname
!-----------------------------------------------------------------------
      ! check if the module was already initialised
      if (rprm_ifinit) then
         call mntr_warn(rprm_id,
     $        'module ['//trim(rprm_name)//'] already initiaised.')
         return
      endif

      ! get runtime parameters
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,rprm_ifparf_id,rpar_log)
      rprm_ifparf = ltmp
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,rprm_parfnm_id,rpar_str)
      rprm_parfnm = ctmp

      ! write summary
      iunit = 6
      call rprm_rp_summary_print(iunit)

      ! save .par file
      if (rprm_ifparf) then
         call io_file_freeid(iunit, ierr)
         if (ierr.eq.0) then
           fname=trim(adjustl(rprm_parfnm))//'.par'
           open(unit=iunit,file=fname,status='new',iostat=ierr)
           if (ierr.eq.0) then
             call rprm_rp_summary_print(iunit)
             close (iunit)
           else
             call mntr_log(rprm_id,lp_inf,
     $        'ERROR: cannot open output .par file')
           endif
         else
           call mntr_log(rprm_id,lp_inf,
     $        'ERROR: cannot allocate iunit for output .par file')
         endif
      endif

      ! everything is initialised
      rprm_ifinit = .true.

      return
      end subroutine
!=======================================================================
!> @brief Check if module was initialised
!! @ingroup runparam
!! @return rprm_is_initialised
      logical function rprm_is_initialised()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'
!-----------------------------------------------------------------------
      rprm_is_initialised = rprm_ifinit

      return
      end function
!=======================================================================
!> @brief Register new parameter section
!! @ingroup runparam
!! @param[out] rpid     current section id
!! @param[in]  mid      registering module id
!! @param[in]  pname    section name
!! @param[in]  pdscr    section description
      subroutine rprm_sec_reg(rpid,mid,pname,pdscr)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, mid
      character*(*) pname, pdscr

      ! local variables
      character*10  mname
      character*20  lname
      character*132 ldscr
      character*200 llog
      integer slen,slena

      integer il, ipos
      integer lval

      ! functions
      logical mntr_mod_is_id_reg
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(pname))
      ! remove trailing blanks
      slen = len_trim(pname) - slena + 1
      if (slena.gt.rprm_lstl_mnm) then
         call mntr_log(rprm_id,lp_deb,
     $        'too long section name; shortenning')
         slena = min(slena,rprm_lstl_mnm)
      endif
      call blank(lname,rprm_lstl_mnm)
      lname= pname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! check description length
      slena = len_trim(adjustl(pdscr))
      ! remove trailing blanks
      slen = len_trim(pdscr) - slena + 1
      if (slena.ge.rprm_lstl_mds) then
         call mntr_log(rprm_id,lp_deb,
     $        'too long section description; shortenning')
         slena = min(slena,rprm_lstl_mnm)
      endif
      call blank(ldscr,rprm_lstl_mds)
      ldscr= pdscr(slen:slen + slena - 1)

      ! find empty space
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.rprm_pid0) then

         ! check if parameter name is already registered
         do il=1,rprm_sec_mpos
            if (rprm_sec_id(il).gt.0.and.
     $          rprm_sec_name(il).eq.lname) then
               ipos = -il
               exit
            endif
         enddo

         ! find empty spot
         if (ipos.eq.0) then
            do il=1,rprm_sec_id_max
               if (rprm_sec_id(il).eq.-1) then
                  ipos = il
                  exit
               endif
            enddo
         endif
      endif

      ! broadcast ipos
      call bcast(ipos,isize)

      ! error; no free space found
      if (ipos.eq.0) then
         rpid = ipos
         call mntr_abort(rprm_id,
     $        'Section '//trim(lname)//' cannot be registered')
      ! section already registered
      elseif (ipos.lt.0) then
         rpid = abs(ipos)
         call mntr_abort(rprm_id,
     $    'Section '//trim(lname)//' is already registered')
      ! new section
      else
         rpid = ipos
         ! check if module is registered
         if (mntr_mod_is_id_reg(mid)) then
            rprm_sec_id(ipos) = mid
         else
            call mntr_abort(rprm_id,
     $          "Sections's "//trim(lname)//" module not registered")
         endif
         rprm_sec_name(ipos)=lname
         rprm_sec_dscr(ipos)=ldscr
         rprm_sec_num = rprm_sec_num + 1
         if (rprm_sec_mpos.lt.ipos) rprm_sec_mpos = ipos

         ! logging
         call mntr_mod_get_info(mname,ipos,mid)
         llog='Module ['//trim(mname)//'] registered section '
         llog=trim(llog)//' '//trim(lname)//': '//trim(ldscr)
         call mntr_log(rprm_id,lp_inf,trim(llog))
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if section name is registered and return its id. Check mid as well.
!! @ingroup runparam
!! @param[out] rpid     section id
!! @param[in]  mid      registering module id
!! @param[in]  pname    section name
      subroutine rprm_sec_is_name_reg(rpid,mid,pname)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, mid
      character*(*) pname

      ! local variables
      character*3 str
      character*10  mname
      character*20  lname
      character*132 llog
      integer slen,slena

      integer il, ipos
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(pname))
      ! remove trailing blanks
      slen = len_trim(pname) - slena + 1
      if (slena.gt.rprm_lstl_mnm) then
         call mntr_log(rprm_id,lp_deb,
     $        'too long section name; shortenning')
         slena = min(slena,rprm_lstl_mnm)
      endif
      call blank(lname,rprm_lstl_mnm)
      lname= pname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! find parameter
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.rprm_pid0) then

         ! check if parameter name is already registered
         do il=1,rprm_sec_mpos
            if (rprm_sec_id(il).gt.0.and.
     $          rprm_sec_name(il).eq.lname) then
               ipos = il
               exit
            endif
         enddo

      endif

      ! broadcast ipos
      call bcast(ipos,isize)

      if (ipos.eq.0) then
         rpid = -1
         call mntr_log(rprm_id,lp_inf,
     $        'Section '//trim(lname)//' not registered')
      else
         rpid = ipos
         write(str,'(I3)') ipos
         call mntr_log(rprm_id,lp_vrb,
     $   'Section '//trim(lname)//' registered with id = '//trim(str))
         ! check module
         if (mid.ne.rprm_sec_id(ipos)) then
            call mntr_log(rprm_id,lp_inf,
     $      "Section's "//trim(lname)//" module inconsistent")
            rpid = -1
         endif
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if section id is registered. This operation is performed locally
!! @ingroup runparam
!! @param[in]  rpid     section id
!! @return rprm_sec_is_id_reg
      logical function rprm_sec_is_id_reg(rpid)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid
!-----------------------------------------------------------------------
      rprm_sec_is_id_reg = rprm_sec_id(rpid).gt.0

      return
      end function
!=======================================================================
!> @brief Get section info based on its id. This operation is performed locally
!! @ingroup runparam
!! @param[out]    pname    section name
!! @param[out]    mid      registering module id
!! @param[out]    ifact    activation flag
!! @param[inout]  rpid     section id
      subroutine rprm_sec_get_info(pname,mid,ifact,rpid)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, mid
      character*20 pname
      logical ifact

      ! local variables
      character*5 str
!-----------------------------------------------------------------------
      if (rprm_sec_id(rpid).gt.0) then
         pname = rprm_sec_name(rpid)
         mid = rprm_sec_id(rpid)
         ifact = rprm_sec_act(rpid)
      else
         write(str,'(I3)') rpid
         call mntr_log(rprm_id,lp_inf,
     $        'Section id'//trim(str)//' not registered')
         rpid = -1
      endif

      return
      end subroutine
!=======================================================================
!> @brief Set section's activation flag. Master value is broadcasted.
!! @details This routine is added because Nek5000 uses existence of
!!    section in .par file itself as a variable, what introduces problem
!!    with their registration as sections should be registered before reading
!!    runtime parameter file. That is why I decided to split registration
!!    and activation stages. One can register all the possible sections
!!    and activate those present in .par
!! @ingroup runparam
!! @param[in]  ifact    activation flag
!! @param[in]  rpid     runtime parameter id
      subroutine rprm_sec_set_act(ifact,rpid)
      implicit none

      include 'SIZE'
      include 'PARALLEL'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid
      logical ifact

      ! local variables
      logical lval
      character*5 str
!-----------------------------------------------------------------------
      if (rprm_sec_id(rpid).gt.0) then
         ! broadcast pval; to keep consistency
         lval = ifact
         call bcast(lval,lsize)
         rprm_sec_act(rpid) = lval
      else
         write(str,'(I3)') rpid
         call mntr_abort(rprm_id,
     $          "Section "//trim(str)//" activation error")
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if section id is registered and activated. This operation is performed locally
!! @ingroup runparam
!! @param[in]  rpid     section id
!! @return rprm_sec_id_id_act
      logical function rprm_sec_is_id_act(rpid)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid
!-----------------------------------------------------------------------
      rprm_sec_is_id_act = rprm_sec_id(rpid).gt.0.and.
     $                     rprm_sec_act(rpid)

      return
      end function
!=======================================================================
!> @brief Register new runtime parameter
!! @ingroup runparam
!! @param[out] rpid     current runtime parameter id
!! @param[in]  mid      section id
!! @param[in]  pname    parameter name
!! @param[in]  pdscr    paramerer description
!! @param[in]  ptype    parameter type
!! @param[in]  ipval    integer default value
!! @param[in]  rpval    real default value
!! @param[in]  lpval    logical default value
!! @param[in]  cpval    string default value
!! @callergraph
      subroutine rprm_rp_reg(rpid,mid,pname,pdscr,ptype ,
     $ ipval, rpval, lpval, cpval)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'FRAMELP'
      include 'RPRMD'


      ! argument list
      integer rpid, mid, ptype, ipval
      real rpval
      logical lpval
      character*(*) pname, pdscr, cpval

      ! local variables
      character*10  mname
      character*20  lname
      character*132 ldscr
      character*200 llog
      integer slen,slena

      integer il, ipos
      integer ivall
      real rvall
      logical lvall
      character*20 cvall

      ! functions
      logical rprm_sec_is_id_reg
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(pname))
      ! remove trailing blanks
      slen = len_trim(pname) - slena + 1
      if (slena.gt.rprm_lstl_mnm) then
         call mntr_log(rprm_id,lp_deb,
     $        'too long parameter name; shortenning')
         slena = min(slena,rprm_lstl_mnm)
      endif
      call blank(lname,rprm_lstl_mnm)
      lname= pname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! check description length
      slena = len_trim(adjustl(pdscr))
      ! remove trailing blanks
      slen = len_trim(pdscr) - slena + 1
      if (slena.ge.rprm_lstl_mds) then
         call mntr_log(rprm_id,lp_deb,
     $        'too long parameter description; shortenning')
         slena = min(slena,rprm_lstl_mnm)
      endif
      call blank(ldscr,rprm_lstl_mds)
      ldscr= pdscr(slen:slen + slena - 1)

      ! find empty space
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.rprm_pid0) then

         ! check if parameter name is already registered
         do il=1,rprm_par_mpos
            if (rprm_par_id(rprm_par_mark,il).gt.0.and.
     $          rprm_par_name(il).eq.lname) then
               ipos = -il
               exit
            endif
         enddo

         ! find empty spot
         if (ipos.eq.0) then
            do il=1,rprm_par_id_max
               if (rprm_par_id(rprm_par_mark,il).eq.-1) then
                  ipos = il
                  exit
               endif
            enddo
         endif
      endif

      ! broadcast ipos
      call bcast(ipos,isize)

      ! error; no free space found
      if (ipos.eq.0) then
         rpid = ipos
         call mntr_abort(rprm_id,
     $        'Parameter '//trim(lname)//' cannot be registered')
      ! parameter already registered
      elseif (ipos.lt.0) then
         rpid = abs(ipos)
         call mntr_abort(rprm_id,
     $    'Parameter '//trim(lname)//' is already registered')
         ! new parameter
      else
         rpid = ipos
         ! check if section is registered
         if (rprm_sec_is_id_reg(mid)) then
            rprm_par_id(rprm_par_mark,ipos) = mid
         else
            call mntr_abort(rprm_id,
     $          "Parameter's "//trim(lname)//" section not registered")
         endif
         rprm_par_id(rprm_par_type,ipos) = ptype
         rprm_par_name(ipos)=lname
         rprm_par_dscr(ipos)=ldscr
         rprm_par_num = rprm_par_num + 1
         if (rprm_par_mpos.lt.ipos) rprm_par_mpos = ipos

         ! broadcast pval; to keep consistency
         if (ptype.eq.rpar_int) then
            ivall = ipval
            call bcast(ivall,isize)
            rprm_parv_int(ipos) = ivall
         elseif (ptype.eq.rpar_real) then
            rvall = rpval
            call bcast(rvall,wdsize)
            rprm_parv_real(ipos) = rvall
         elseif (ptype.eq.rpar_log) then
            lvall = lpval
            call bcast(lvall,lsize)
            rprm_parv_log(ipos) = lvall
         elseif (ptype.eq.rpar_str) then
            ! check value length
            slena = len_trim(adjustl(cpval))
            ! remove trailing blanks
            slen = len_trim(cpval) - slena + 1
            if (slena.gt.rprm_lstl_mnm) then
               call mntr_log(rprm_id,lp_deb,
     $           'too long parameter default value; shortenning')
               slena = min(slena,rprm_lstl_mnm)
            endif
            call blank(cvall,rprm_lstl_mnm)
            cvall= cpval(slen:slen+slena- 1)
            ! broadcast pval; to keep consistency
            call bcast(cvall,rprm_lstl_mnm*csize)
            rprm_parv_str(ipos) = cvall
         else
            call mntr_abort(rprm_id,
     $      "Parameter's "//trim(lname)//" wrong type")
         endif

         ! logging
         mname = trim(rprm_sec_name(mid))
         llog='Section '//trim(mname)//' registered parameter '
         llog=trim(llog)//' '//trim(lname)//': '//trim(ldscr)
         call mntr_log(rprm_id,lp_inf,trim(llog))
         if (ptype.eq.rpar_int) then
            call mntr_logi(rprm_id,lp_vrb,
     $       'Default value '//trim(lname)//' = ',ivall)
         elseif (ptype.eq.rpar_real) then
            call mntr_logr(rprm_id,lp_vrb,
     $       'Default value '//trim(lname)//' = ',rvall)
         elseif (ptype.eq.rpar_log) then
            call mntr_logl(rprm_id,lp_vrb,
     $       'Default value '//trim(lname)//' = ',lvall)
         elseif (ptype.eq.rpar_str) then
            call mntr_log(rprm_id,lp_vrb,
     $       'Default value '//trim(lname)//' = '//trim(cvall))
         endif
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if parameter name is registered and return its id. Check flags as well.
!! @ingroup runparam
!! @param[out] rpid     runtime parameter id
!! @param[in]  mid      section id
!! @param[in]  pname    parameter name
!! @param[in]  ptype    parameter type
      subroutine rprm_rp_is_name_reg(rpid,mid,pname,ptype)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, mid, ptype
      character*(*) pname

      ! local variables
      character*3 str
      character*10  mname
      character*20  lname
      character*132 llog
      integer slen,slena

      integer il, ipos
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(pname))
      ! remove trailing blanks
      slen = len_trim(pname) - slena + 1
      if (slena.gt.rprm_lstl_mnm) then
         call mntr_log(rprm_id,lp_deb,
     $        'too long parameter name; shortenning')
         slena = min(slena,rprm_lstl_mnm)
      endif
      call blank(lname,rprm_lstl_mnm)
      lname= pname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! find parameter
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.rprm_pid0) then

         ! check if parameter name is already registered
         do il=1,rprm_par_mpos
            if (rprm_par_id(rprm_par_mark,il).gt.0.and.
     $          rprm_par_name(il).eq.lname) then
               ipos = il
               exit
            endif
         enddo

      endif

      ! broadcast ipos
      call bcast(ipos,isize)

      if (ipos.eq.0) then
         rpid = -1
         call mntr_log(rprm_id,lp_inf,
     $        'Parameter '//trim(lname)//' not registered')
      else
         rpid = ipos
         write(str,'(I3)') ipos
         call mntr_log(rprm_id,lp_vrb,
     $   'Parameter '//trim(lname)//' registered with id = '//trim(str))
         ! check module
         if (mid.ne.rprm_par_id(rprm_par_mark,ipos)) then
            call mntr_log(rprm_id,lp_inf,
     $      "Parameter's "//trim(lname)//" section inconsistent")
            rpid = -1
         endif
         ! check type
         if (ptype.ne.rprm_par_id(rprm_par_type,ipos)) then
            call mntr_log(rprm_id,lp_inf,
     $      "Parameter's "//trim(lname)//" type inconsistent")
            rpid = -1
         endif
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if parameter id is registered and check type consistency. This operation is performed locally
!! @ingroup runparam
!! @param[in]  rpid     runtime parameter id
!! @param[in]  ptype    parameter type
!! @return rprm_rp_is_id_reg
      logical function rprm_rp_is_id_reg(rpid,ptype)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, ptype
!-----------------------------------------------------------------------
      rprm_rp_is_id_reg = rprm_par_id(rprm_par_mark,rpid).gt.0.and.
     $                    rprm_par_id(rprm_par_type,rpid).eq.ptype

      return
      end function
!=======================================================================
!> @brief Get parameter info based on its id. This operation is performed locally
!! @ingroup runparam
!! @param[out]    pname    parameter name
!! @param[out]    mid      section id
!! @param[out]    ptype    parameter type
!! @param[inout]  rpid     runtime parameter id
      subroutine rprm_rp_get_info(pname,mid,ptype,rpid)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, mid, ptype
      character*20 pname

      ! local variables
      character*5 str
!-----------------------------------------------------------------------
      if (rprm_par_id(rprm_par_mark,rpid).gt.0) then
         pname = rprm_par_name(rpid)
         mid = rprm_par_id(rprm_par_mark,rpid)
         ptype = rprm_par_id(rprm_par_type,rpid)
      else
         write(str,'(I3)') rpid
         call mntr_log(rprm_id,lp_inf,
     $        'Parameter id'//trim(str)//' not registered')
         rpid = -1
      endif

      return
      end subroutine
!=======================================================================
!> @brief Set runtime parameter of active section. Master value is broadcasted.
!! @ingroup runparam
!! @param[in]  rpid     runtime parameter id
!! @param[in]  ptype    parameter type
!! @param[in]  ipval    integer value
!! @param[in]  rpval    real value
!! @param[in]  lpval    logical value
!! @param[in]  cpval    string value
      subroutine rprm_rp_set(rpid,ptype,ipval,rpval,lpval,cpval)
      implicit none

      include 'SIZE'
      include 'PARALLEL'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, ptype
      integer ipval
      real rpval
      logical lpval
      character*(*) cpval

      ! local variables
      integer ivall
      real rvall
      logical lvall
      character*20 cvall
      character*5 str
      integer slen,slena

!-----------------------------------------------------------------------
      if (rprm_par_id(rprm_par_mark,rpid).gt.0.and.
     $    rprm_par_id(rprm_par_type,rpid).eq.ptype) then
         if(rprm_sec_act(rprm_par_id(rprm_par_mark,rpid))) then
            ! broadcast pval; to keep consistency
            if (ptype.eq.rpar_int) then
               ivall = ipval
               call bcast(ivall,isize)
               rprm_parv_int(rpid) = ivall
            elseif (ptype.eq.rpar_real) then
               rvall = rpval
               call bcast(rvall,wdsize)
               rprm_parv_real(rpid) = rvall
            elseif (ptype.eq.rpar_log) then
               lvall = lpval
               call bcast(lvall,lsize)
               rprm_parv_log(rpid) = lvall
            elseif (ptype.eq.rpar_str) then
               ! check value length
               slena = len_trim(adjustl(cpval))
               ! remove trailing blanks
               slen = len_trim(cpval) - slena + 1
               if (slena.gt.rprm_lstl_mnm) then
                  call mntr_log(rprm_id,lp_deb,
     $           'too long parameter value; shortenning')
                  slena = min(slena,rprm_lstl_mnm)
               endif
               call blank(cvall,rprm_lstl_mnm)
               cvall= cpval(slen:slen+slena- 1)
               ! broadcast pval; to keep consistency
               call bcast(cvall,rprm_lstl_mnm*csize)
               rprm_parv_str(rpid) = cvall
            else
               write(str,'(I3)') rpid
               call mntr_abort(rprm_id,
     $         "Parameter set "//trim(str)//" wrong type")
            endif
         else
            write(str,'(I3)') rpid
               call mntr_warn(rprm_id,
     $         "Parameter set "//trim(str)//" section not active")
         endif
      else
         write(str,'(I3)') rpid
         call mntr_abort(rprm_id,
     $          "Parameter "//trim(str)//" setting error")
      endif

      return
      end subroutine
!=======================================================================
!> @brief Get runtime parameter form active section. This operation is performed locally
!! @ingroup runparam
!! @param[out]  ipval    integer value
!! @param[out]  rpval    real value
!! @param[out]  lpval    logical value
!! @param[out]  cpval    string value
!! @param[in]   rpid     runtime parameter id
!! @param[in]   ptype    parameter type
      subroutine rprm_rp_get(ipval,rpval,lpval,cpval,rpid,ptype)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer rpid, ptype
      integer ipval
      real rpval
      logical lpval
      character*20 cpval

      ! local variables
      character*5 str
!-----------------------------------------------------------------------
      if (rprm_par_id(rprm_par_mark,rpid).gt.0.and.
     $    rprm_par_id(rprm_par_type,rpid).eq.ptype) then
         if(rprm_sec_act(rprm_par_id(rprm_par_mark,rpid))) then

            if (ptype.eq.rpar_int) then
               ipval = rprm_parv_int(rpid)
            elseif (ptype.eq.rpar_real) then
               rpval = rprm_parv_real(rpid)
            elseif (ptype.eq.rpar_log) then
               lpval = rprm_parv_log(rpid)
            elseif (ptype.eq.rpar_str) then
               cpval = rprm_parv_str(rpid)
            else
               write(str,'(I3)') rpid
               call mntr_abort(rprm_id,
     $      "Parameter get "//trim(str)//" wrong type")
            endif
         else
            write(str,'(I3)') rpid
            call mntr_warn(rprm_id,
     $         "Parameter get "//trim(str)//" section not active")
         endif
      else
         write(str,'(I3)') rpid
         call mntr_abort(rprm_id,
     $          "Parameter "//trim(str)//" getting error")
      endif

      return
      end subroutine
!=======================================================================
!> @brief Get runtime parameter from nek parser dictionary
!! @ingroup runparam
      subroutine rprm_dict_get()
      implicit none

      include 'SIZE'
      include 'PARALLEL'
      include 'FRAMELP'
      include 'RPRMD'

      ! local variables
      integer il, jl, kl
      integer nkey, ifnd, i_out
      integer nmod, pmid
      character*132 key, lkey
      character*1024 val
      logical ifoundm, ifoundp, ifact
      integer itmp
      real rtmp

      character*20  lname
      character*132 ldscr
      character*200 llog
      integer slen,slena

!-----------------------------------------------------------------------
      ! dictionary exists on master node only
      if (nid.eq.rprm_pid0) then
        ! key number in dictionary
        call finiparser_getdictentries(nkey)

        do il=1,nkey!rprm_par_mpos

          ! get a key
          call finiparser_getpair(key,val,il,ifnd)
          key = adjustl(key)
          call capit(key,132)

          ! find section key belongs to
          ifoundm=.false.
          do jl=1,rprm_sec_mpos
            if (rprm_sec_id(jl).gt.0) then
              lname=trim(adjustl(rprm_sec_name(jl)))
              ifnd = index(key,trim(lname))
              if (ifnd.eq.1) then
                ! set section to active
                rprm_sec_act(jl) = .true.
                ifoundm=.true.
                ! looking for more than section name
                if (trim(key).ne.trim(lname)) then
                  ! add variable name
                  ifoundp =.false.
                  do kl=1,rprm_par_mpos
                    if (rprm_par_id(rprm_par_mark,kl).eq.jl) then
                      lkey = trim(lname)//':'//trim(rprm_par_name(kl))
                      if (trim(key).eq.trim(lkey)) then
                        ifoundp=.true.
                        ! read parameter value
                        if (rprm_par_id(rprm_par_type,kl).eq.
     $                      rpar_int) then
                          read(val,*) itmp
                          rprm_parv_int(kl) = itmp
                        elseif (rprm_par_id(rprm_par_type,kl).eq.
     $                      rpar_real) then
                          read(val,*) rtmp
                          rprm_parv_real(kl) = rtmp
                        elseif (rprm_par_id(rprm_par_type,kl).eq.
     $                      rpar_log) then
                          call finiparser_getBool(i_out,trim(lkey),ifnd)
                          if (ifnd.eq.1) then
                            if (i_out.eq.1) then
                              rprm_parv_log(kl) = .true.
                            else
                              rprm_parv_log(kl) = .false.
                            endif
                          else
                            call mntr_warn(rprm_id,
     $               'Boolean parameter reading error '//trim(key))
                          endif
                        elseif (rprm_par_id(rprm_par_type,kl).eq.
     $                      rpar_str) then
                          rprm_parv_str(kl) = trim(adjustl(val))
                        else
                          call mntr_warn(rprm_id,
     $               'Runtime parameter type missmatch '//trim(key))
                        endif
                        exit
                      endif
                    endif
                  enddo
                  ! is it unknown parameter
                  if (.not.ifoundp) then
                    call mntr_warn(rprm_id,
     $               'Unknown runtime parameter '//trim(key))
                  endif
                endif
              exit
              endif
            endif
          enddo
          if (.not.ifoundm) then
          ! possible palce for warning that section not found
          endif
        enddo
      endif

      ! broadcast array data
      call bcast(rprm_parv_int,rprm_par_id_max*isize)
      call bcast(rprm_parv_real,rprm_par_id_max*wdsize)
      call bcast(rprm_parv_log,rprm_par_id_max*lsize)
      call bcast(rprm_parv_str,rprm_par_id_max*rprm_lstl_mnm*csize)

      ! broadcast activation lfag
      call bcast(rprm_sec_act,rprm_sec_id_max*lsize)

      return
      end subroutine
!=======================================================================
!> @brief Print out summary of registered runtime parameters (active sections only)
!! @ingroup runparam
!! @param[in]  unit   I/O unit (6 - standard I/O)
      subroutine rprm_rp_summary_print(unit)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer unit

      ! local variables
      integer ind(rprm_par_id_max)
      integer offset(2,rprm_par_id_max)
      integer slist(2,rprm_par_id_max), itmp1(2)
      integer npos, nset, key
      integer il, jl
      integer istart, in, itest
      character*20 str
      character*22 sname
      character*(*) cmnt
      parameter (cmnt='#')

      ! functions
      integer mntr_lp_def_get
!-----------------------------------------------------------------------
      if (unit.eq.6) then
         call mntr_log(rprm_id,lp_prd,
     $   'Summary of registered runtime parameters for active sections')
      else
         call mntr_log(rprm_id,lp_prd,
     $   'Generated .par file for active sections')
      endif

      if (nid.eq.rprm_pid0) then

         ! sort module index array
         ! copy data removing possible empty slots
         npos=0
         do il=1,rprm_par_mpos
            in = rprm_par_id(rprm_par_mark,il)
            if (in.ge.0.and.rprm_sec_act(in)) then
               npos = npos + 1
               slist(1,npos) = in
               slist(2,npos) = il
            endif
         enddo

         ! sort with respect to section id
         key = 1
         call ituple_sort(slist,2,npos,key,1,ind,itmp1)

         ! sort parameters in single section with respect to parameter id
         nset = 0
         istart = 1
         itest = slist(1,istart)
         do il=1,npos
            if(itest.ne.slist(1,il).or.il.eq.npos) then
              if (il.eq.npos.and.itest.eq.slist(1,il)) then
                 jl = npos + 1
              else
                 jl = il
              endif
              in = jl - istart
              if (in.gt.1) then
                 key = 2
                 call ituple_sort(slist(1,istart),2,in,key,1,ind,itmp1)
              endif
              nset = nset +1
              offset(1,nset) = istart
              offset(2,nset) = in
              if (il.ne.npos) then
                 itest = slist(1,il)
                 istart = il
              elseif(itest.ne.slist(1,il)) then
                 nset = nset +1
                 offset(1,nset) = il
                 offset(2,nset) = 1
              endif
            endif
         enddo

         if (mntr_lp_def_get().le.lp_prd.or.unit.ne.6) then
           if (unit.ne.6) then
             write(unit,'(A)') cmnt
             write(unit,'(A,A)') cmnt,
     $            ' runtime parameter file generated by'
             write(unit,'(A,A)') cmnt,' rprm_rp_summary_print'
             write(unit,'(A)') cmnt
           endif
           do il=1,nset
             istart = offset(1,il)
             in = offset(2,il)
             key = rprm_sec_id(slist(1,istart))
             sname = '['//trim(rprm_sec_name(slist(1,istart)))//']'
             write(unit,'(A)') cmnt
             write(unit,'(A,A)') sname,
     $   '  '//cmnt//' '//trim(adjustl(rprm_sec_dscr(slist(1,istart))))
             do jl = 0, in-1
               key = slist(2,istart+jl)
               if (rprm_par_id(rprm_par_type,key).eq.
     $             rpar_int) then
                 write(str,'(I8)') rprm_parv_int(key)
               elseif (rprm_par_id(rprm_par_type,key).eq.
     $             rpar_real) then
                 write(str,'(E15.8)') rprm_parv_real(key)
               elseif (rprm_par_id(rprm_par_type,key).eq.
     $             rpar_log) then
                 if (rprm_parv_log(key)) then
                   str = 'yes'
                 else
                   str = 'no'
                 endif
               elseif (rprm_par_id(rprm_par_type,key).eq.
     $             rpar_str) then
                 str = rprm_parv_str(key)
               endif
               write(unit,'(A," = ",A,A)')
     $           rprm_par_name(key), adjustl(str),
     $           '   '//cmnt//' '//trim(adjustl(rprm_par_dscr(key)))
             enddo
           enddo
           if (unit.ne.6) then
             write(unit,'(A)') cmnt
             write(unit,'(A,A)') cmnt,' end of runtime parameter file'
             write(unit,'(A)') cmnt
           else
             write(unit,'(A1)') ' '
           endif
         endif
      endif


      return
      end subroutine
!=======================================================================
!> @brief Check consistency of module's runtime parameters
!! @ingroup runparam
!! @param[in]    mod_nkeys    number of module's keys
!! @param[in]    mod_dictkey  module's dictionary keys
!! @param[in]    mod_n3dkeys  number of keys used for 3D run only
!! @param[in]    mod_l3dkey   list of positions of 3D keys
!! @param[out]   ifsec        is section present
!! @details Check if the section name shows up and runtime parameters are
!!  spelled correctly. Give warning if section is missing, or the key is
!!  unknown. Check possible 2D - 3D parameter mismatch.
!! @warning This routine deprecated.
      subroutine rprm_check(mod_nkeys, mod_dictkey, mod_n3dkeys,
     $           mod_l3dkey, ifsec)
      implicit none

      include 'SIZE'
      include 'INPUT'    ! IF3D
      include 'FRAMELP'
      include 'RPRMD'

      ! argument list
      integer mod_nkeys, mod_n3dkeys, mod_l3dkey(mod_n3dkeys)
      character*132 mod_dictkey(mod_nkeys)
      logical ifsec

      ! local variables
      integer il, jl, ip  ! loop index
      ! dictionary operations
      integer nkey, ifnd, i_out
      real d_out
      character*132 key, lkey
      character*1024 val
      logical ifvar, if3dkey
!-----------------------------------------------------------------------
      ! check consistency
      ! key number in dictionary
      call finiparser_getdictentries(nkey)

      ! set marker for finding module's section
      ifsec = .FALSE.
      do il=1,nkey
         ! get a key
         call finiparser_getpair(key,val,il,ifnd)
         call capit(key,132)

         ! does it belong to current module's section
         ifnd = index(key,trim(mod_dictkey(1)))
         if (ifnd.eq.1) then
            ! section was found, check variable
            ifsec = .TRUE.
            ifvar = .FALSE.
            do ip = mod_nkeys,1,-1
               lkey = trim(adjustl(mod_dictkey(1)))
               if (ip.gt.1) lkey =trim(adjustl(lkey))//
     $            ':'//trim(adjustl(mod_dictkey(ip)))
               if(index(key,trim(lkey)).eq.1) then
                  ifvar = .TRUE.
                  exit
               endif
            enddo

            if (ifvar) then
               ! check 2D versus 3D
               if (.not.IF3D) then
                  if3dkey = .FALSE.
                  do jl=1,mod_n3dkeys
                     if (ip.eq.mod_l3dkey(jl)) then
                        if3dkey = .TRUE.
                        exit
                     endif
                  enddo

                  if (if3dkey) then
                     call mntr_log(rprm_id,lp_inf,
     $                   'Module '//trim(mod_dictkey(1)))
                     call mntr_log(rprm_id,lp_inf,
     $              '3D parameter '//trim(key)//' specified for 2D run')
                  endif
               endif
            else
               ! variable not found
               call mntr_log(rprm_id,lp_inf,
     $              'Module '//trim(mod_dictkey(1)))
               call mntr_log(rprm_id,lp_inf,
     $              'Unknown runtime parameter: '//trim(key))
            endif
         endif
      enddo

      ! no parameter section; give warning
      if (.not.ifsec) then
         call mntr_log(rprm_id,lp_inf,'Module '//trim(mod_dictkey(1)))
         call mntr_log(rprm_id,lp_inf,
     $     'runtime parameter section not found.')
      endif

      return
      end subroutine
!=======================================================================

!> @file chkpt_mstp.f
!! @ingroup chkpoint_mstep
!! @brief Set of multi-file checkpoint routines for DNS, MHD and
!!    perturbation simulations
!=======================================================================
!> @brief Register multi step checkpointing module
!! @ingroup chkpoint_mstep
      subroutine chkpts_register()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'CHKPOINTD'
      include 'CHKPTMSTPD'

      ! local variables
      integer lpmid
!-----------------------------------------------------------------------
      ! check if the current module was already registered
      call mntr_mod_is_name_reg(lpmid,chpm_name)
      if (lpmid.gt.0) then
         call mntr_warn(lpmid,
     $        'module ['//trim(chpm_name)//'] already registered')
         return
      endif

      ! find parent module
      call mntr_mod_is_name_reg(lpmid,chpt_name)
      if (lpmid.le.0) then
        lpmid = 1
        call mntr_abort(lpmid,
     $   'Parent ['//trim(chpt_name)//'] module not registered')
      endif

      ! register module
      call mntr_mod_reg(chpm_id,lpmid,chpm_name,
     $         'Multi-file checkpointing')

      ! register timers
      call mntr_tmr_is_name_reg(lpmid,'CHP_TOT')
      call mntr_tmr_reg(chpm_tread_id,lpmid,chpm_id,
     $      'CHP_READ','Checkpointing reading time',.true.)

      call mntr_tmr_reg(chpm_twrite_id,lpmid,chpm_id,
     $      'CHP_WRITE','Checkpointing writing time',.true.)

      ! adjust step delay
      call mntr_set_step_delay(chpm_snmax)

      return
      end subroutine
!=======================================================================
!> @brief Initialise multi-file checkpoint routines
!! @ingroup chkpoint_mstep
!! @note This interface is defined in @ref chkpt_main
      subroutine chkpts_init
      implicit none

      include 'SIZE'            ! NID, NPERT
      include 'TSTEP'           ! ISTEP, NSTEPS
      include 'INPUT'           ! IFPERT, PARAM
      include 'FRAMELP'
      include 'CHKPOINTD'
      include 'CHKPTMSTPD'
!-----------------------------------------------------------------------
      ! check if the module was already initialised
      if (chpm_ifinit) then
         call mntr_warn(chpm_id,
     $        'module ['//trim(chpm_name)//'] already initiaised.')
         return
      endif

      ! get number of snapshots in a set
      if (PARAM(27).lt.0) then
         chpm_nsnap = NBDINP
      else
         chpm_nsnap = chpm_snmax
      endif

      ! we support only one perturbation
      if (IFPERT) then
         if (NPERT.gt.1) call mntr_abort(chpm_id,
     $         'only single perturbation supported')
      endif

      chpm_ifinit = .true.

      return
      end subroutine
!=======================================================================
!> @brief Check if module was initialised
!! @ingroup chkpoint_mstep
!! @return chkpts_is_initialised
      logical function chkpts_is_initialised()
      implicit none

      include 'SIZE'
      include 'CHKPTMSTPD'
!-----------------------------------------------------------------------
      chkpts_is_initialised = chpm_ifinit

      return
      end function
!=======================================================================
!> @brief Write full file restart set
!! @ingroup chkpoint_mstep
!! @note This interface is defined in @ref chkpt_main.
!! @note This is version of @ref full_restart_save routine.
      subroutine chkpts_write()
      implicit none

      include 'SIZE'            !
      include 'TSTEP'           ! ISTEP, NSTEPS
      include 'INPUT'           ! IFMVBD, IFREGUO
      include 'FRAMELP'
      include 'CHKPOINTD'
      include 'CHKPTMSTPD'

      ! local variables
      integer il, ifile, fnum
      real ltim
      character*132 fname(CHKPTNFMAX)
      logical ifcoord
      logical ifreguol

      character*2 str
      character*200 lstring

      integer icalldl
      save    icalldl
      data    icalldl  /0/

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      ! no regular mesh
      ifreguol= IFREGUO
      IFREGUO = .false.

      ! do we write a snapshot
      ifile = 0
      if (chpt_stepc.gt.0.and.chpt_stepc.le.chpm_nsnap) then
      ! timing
         ltim = dnekclock()

         ! file number
         ifile = chpm_nsnap - chpt_stepc +1
         if (ifile.eq.1) call mntr_log(chpm_id,lp_inf,
     $                             'Writing checkpoint snapshot')

         ! initialise I/O data
         call io_init

         ! get set of file names in the snapshot
         call chkpt_set_name(fname, fnum, chpt_set_o, ifile)

         ! do we wtrite coordinates; we save coordinates in DNS files only
         if (IFMVBD) then  ! moving boundaries save in every file
            ifcoord = .true.
         elseif (ifile.eq.1) then
            ! perturbation mode with constant base flow - only 1 rsX written
            if (ifpert.and.(.not.ifbase)) then
               if (icalldl.eq.0.and.(.not.chpt_ifrst)) then
                  icalldl = 1
                  ifcoord = .true.
               else
                  call chcopy (fname(1),fname(fnum),132)
                  fnum = 1
                  ifcoord = .false.
               endif
            ! DNS, MHD, perturbation with changing base flow - every first rsX file in snapshot
            else
               ifcoord = .true.
            endif
         else
            if (ifpert.and.(.not.ifbase)) then
               call chcopy (fname(1),fname(fnum),132)
               fnum = 1
            endif
            ifcoord = .false.
         endif

         ! write down files
         call chkpt_restart_write(fname, fnum, ifcoord)

         ! update output set number
         ! we do it after the last file in the set was sucsesfully written
         if (ifile.eq.chpm_nsnap) then
            write(str,'(I2)') chpt_set_o+1
            lstring = 'Written checkpoint snapshot number: '//trim(str)
            call mntr_log(chpm_id,lp_prd,lstring)
         endif

         ! timing
         ltim = dnekclock() - ltim
         call mntr_tmr_add(chpm_twrite_id,1,ltim)
      endif

      ! put parameters back
      IFREGUO = ifreguol

      return
      end subroutine
!=======================================================================
!> @brief Read full file restart set.
!! @ingroup chkpoint_mstep
!! @note This interface is defined in @ref chkpt_main
!! @note This is version of @ref full_restart routine.
      subroutine chkpts_read()
      implicit none

      include 'SIZE'            !
      include 'TSTEP'           ! ISTEP, IF_FULL_PRES
      include 'INPUT'           ! IFREGUO, INITC
      include 'FRAMELP'
      include 'CHKPOINTD'
      include 'CHKPTMSTPD'

      ! local variables
      integer ifile, fnum, fnuml, il
      real dtratio, epsl, ltim
      parameter (epsl = 0.0001)
      logical ifreguol
      character*132 fname(CHKPTNFMAX),fnamel(CHKPTNFMAX)
      character*200 lstring
      integer icalld
      save icalld
      data icalld /0/

      !functions
      real dnekclock
!-----------------------------------------------------------------------
      ! no regular mesh; important for file name generation
      ifreguol= IFREGUO
      IFREGUO = .false.

      ! this is multi step restart so check for timestep consistency is necessary
      ! this routine gets the information of pressure mesh as well
      if (chpt_ifrst.and.icalld.eq.0) then
         call chkpt_dt_get
         icalld = 1
      endif

      if (chpt_ifrst.and.(ISTEP.lt.chpm_nsnap)) then

         ! timing
         ltim = dnekclock()

         ifile = ISTEP+1  ! snapshot number

         ! initialise I/O data
         call io_init

         ! get set of file names in the snapshot
         call chkpt_set_name(fname, fnum, chpt_set_i, ifile)

         ! perturbation mode with constant base flow - only 1 rsX written
         if (ifpert.and.(.not.ifbase)) then
            if (ifile.eq.1) then
               il = 0
               call chkpt_set_name(fnamel, fnuml, il, ifile)
               call chcopy (fname(1),fnamel(1),132)
               fnum = 2
            else
               call chcopy (fname(1),fname(fnum),132)
               fnum = 1
            endif
         endif

         call chkpt_restart_read(fname, fnum)

         ! check time step consistency
         if(ifile.gt.1.and.chpm_dtstep(ifile).gt.0.0) then
            dtratio = abs(DT-chpm_dtstep(ifile))/chpm_dtstep(ifile)
            if (dtratio.gt.epsl) then
                write(lstring,*) 'Time step inconsistent, new=',
     $            DT,', old=',chpm_dtstep(ifile)
               call mntr_warn(chpm_id,lstring)
              ! possible place to exit if this should be trerated as error
            endif
         endif

         ! timing
         ltim = dnekclock() - ltim
         call mntr_tmr_add(chpm_tread_id,1,ltim)
      endif

      ! put parameters back
      IFREGUO = ifreguol
      IF_FULL_PRES=.false.

      return
      end subroutine
!=======================================================================
!> @brief Get old simulation time steps and pressure mesh marker.
!! @ingroup chkpoint_mstep
!! @todo Different files could have different chpm_if_pmesh, so it is
!!    not the best place to read it
      subroutine chkpt_dt_get
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'RESTART'
      include 'TSTEP'
      include 'FRAMELP'
      include 'CHKPOINTD'
      include 'CHKPTMSTPD'

      ! local variables
      integer ifile, ierr
      real timerl(chpm_snmax), p0thr
      character*132 fname, header
      character*3 prefix
      character*4 dummy
!-----------------------------------------------------------------------
      ! which set of files should be used
      if (ifpert.and.(.not.ifbase)) then
         prefix(1:2)='rp'
      else
         prefix(1:2)='rs'
      endif

      ! initialise I/O data
      call io_init

      ! collect simulation time from file headers
      do ifile=1,chpm_nsnap
         call chkpt_fname(fname, prefix, chpt_set_i, ifile, ierr)
         call mntr_check_abort(chpm_id,ierr,'dt get; file name error')

         ierr = 0
         if (NID.eq.pid00) then
            ! open file
            call addfid(fname,fid0)
            ! add ending character; required by C
            fname = trim(fname)//CHAR(0)
            call byte_open(fname,ierr)
            ! read header
            if (ierr.eq.0) then
               call blank     (header,iHeaderSize)
               call byte_read (header,iHeaderSize/4,ierr)
            endif
            ! close the file
            if (ierr.eq.0) call byte_close(ierr)
         endif
         call mntr_check_abort(chpm_id,ierr,
     $       'dt get; error reading header')

         call bcast(header,iHeaderSize)
         ierr = 0
         if (index(header,'#std').eq.1) then
            read(header,*,iostat=ierr) dummy
     $         ,  wdsizr,nxr,nyr,nzr,nelr,nelgr,timer,istpr
     $         ,  ifiler,nfiler
     $         ,  rdcode      ! 74+20=94
     $         ,  p0thr, chpm_if_pmesh
         else
            ierr = 1
         endif
         call mntr_check_abort(chpm_id,ierr,
     $       'dt get; error extracting timer')

         timerl(ifile) = timer
      enddo

      ! get dt
      do ifile=2,chpm_nsnap
         chpm_dtstep(ifile) = timerl(ifile) - timerl(ifile-1)
      enddo

      return
      end subroutine
!=======================================================================
!> @brief Generate set of restart file names in snapshot
!! @ingroup chkpoint_mstep
!! @param[out] fname  restart file names
!! @param[out] fnum   number of files in snapshot
!! @param[in]  nset   set number
!! @param[in]  ifile  snupshot numer
      subroutine chkpt_set_name(fname, fnum, nset, ifile)
      implicit none

      include 'SIZE'            ! NIO
      include 'INPUT'           ! IFMHD, IFPERT, IFBASE
      include 'FRAMELP'
      include 'CHKPTMSTPD'

      ! argument list
      character*132 fname(CHKPTNFMAX)
      integer fnum, nset, ifile

      ! local variables
      integer ifilel, ierr

      character*132 bname
      character*3 prefix
!-----------------------------------------------------------------------
      ! fill fname array with 'rsX' (DNS), 'rpX' (pert.) and 'rbX' (MHD) file names
      if (IFMHD) then
         ! file number
         fnum = 2

         ! prefix and name for fluid (DNS)
         prefix(1:2)='rs'
         call chkpt_fname(fname(1), prefix, nset, ifile, ierr)
         call mntr_check_abort(chpm_id,ierr,
     $        'chkpt_set_name; DNS file name error')

         ! prefix and name for magnetic field (MHD)
         prefix(1:2)='rb'
         call chkpt_fname(fname(2), prefix, nset, ifile, ierr)
         call mntr_check_abort(chpm_id,ierr,
     $        'chkpt_set_name; MHD file name error')

      elseif (IFPERT) then
         ! file number
         ! I assume only single perturbation
         fnum = 2

         ! prefix and name for base flow (DNS)
         prefix(1:2)='rs'
         if (IFBASE) then
            ifilel = ifile
         else
            ifilel =1
         endif
         call chkpt_fname(fname(1), prefix, nset, ifilel, ierr)
         call mntr_check_abort(chpm_id,ierr,
     $        'chkpt_set_name; base flow file name error')

         ! prefix and name for perturbation
         prefix(1:2)='rp'
         call chkpt_fname(fname(2), prefix, nset, ifile, ierr)
         call mntr_check_abort(chpm_id,ierr,
     $        'chkpt_set_name; perturbation file name error')

      else                ! DNS
         fnum = 1

         ! create prefix and name for DNS
         prefix(1:2)='rs'
         call chkpt_fname(fname(1), prefix, nset, ifile, ierr)
         call mntr_check_abort(chpm_id,ierr,
     $        'chkpt_set_name; DNS file name error')

      endif

      return
      end subroutine
!=======================================================================
!> @brief Generate single restart file name
!! @ingroup chkpoint_mstep
!! @param[out] fname  restart file name
!! @param[in]  prefix prefix
!! @param[in]  nset   set number
!! @param[in]  ifile  snupshot numer
!! @param[out] ierr   error mark
      subroutine chkpt_fname(fname, prefix, nset, ifile, ierr)
      implicit none

      include 'SIZE'            ! NIO
      include 'INPUT'           ! SESSION
      include 'CHKPOINTD'
      include 'CHKPTMSTPD'

      ! argument list
      character*132 fname
      character*3 prefix
      integer nset, ifile, ierr

      ! local variables
      character*132 bname    ! base name
      character*132 fnamel   ! local file name
      character*3 prefixl    ! local prefix
      integer itmp

      character*6  str

      character*(*) kst
      parameter(kst='0123456789abcdefx')
!-----------------------------------------------------------------------
      ! create prefix and name for DNS
      ierr = 0
      prefixl(1:2) = prefix(1:2)
      itmp=min(17,chpt_nset*chpm_nsnap) + 1
      prefixl(3:3)=kst(itmp:itmp)

      ! get base name (SESSION)
      bname = trim(adjustl(SESSION))

      call io_mfo_fname(fnamel,bname,prefixl,ierr)
      if (ierr.ne.0) then
         call mntr_error(chpm_id,'chkpt_fname; file name error')
         return
      endif

      write(str,'(i5.5)') chpm_nsnap*nset+ifile
      fname = trim(fnamel)//trim(str)

      return
      end subroutine
!=======================================================================
!> @brief Write checkpoint snapshot.
!! @ingroup chkpoint_mstep
!! @param[out] fname   restart file name
!! @param[in]  fnum    number of files in snapshot
!! @param[in]  ifcoord do we save coordinates
      subroutine chkpt_restart_write(fname, fnum, ifcoord)
      implicit none

      include 'SIZE'
      include 'RESTART'
      include 'TSTEP'
      include 'INPUT'
      include 'CHKPTMSTPD'

      ! argument list
      character*132 fname(CHKPTNFMAX)
      integer fnum
      logical ifcoord

      ! local variables
      integer lwdsizo
      integer ipert, il
      ! which set of variables do we write: DNS (1), MHD (2) or perturbation (3)
      integer chktype

      logical lif_full_pres, lifxyo, lifpo, lifvo, lifto,
     $        lifpsco(LDIMT1)
!-----------------------------------------------------------------------
      ! adjust I/O parameters
      lwdsizo = WDSIZO
      WDSIZO  = 8
      lif_full_pres = IF_FULL_PRES
      IF_FULL_PRES = .true.
      lifxyo = IFXYO
      lifpo= IFPO
      IFPO = .TRUE.
      lifvo= IFVO
      IFVO = .TRUE.
      lifto= IFTO
      IFTO = IFHEAT
      do il=1,NPSCAL
         lifpsco(il)= IFPSCO(il)
         IFPSCO(il) = .TRUE.
      enddo

      if (IFMHD) then
         ! DNS first
         IFXYO = ifcoord
         chktype = 1
         call chkpt_mfo(fname(1),chktype,ipert)

         ! MHD
         IFXYO = .FALSE.
         chktype = 2
         call chkpt_mfo(fname(2),chktype,ipert)

      elseif (IFPERT) then
         ! DNS first
         if (fnum.eq.2) then
            IFXYO = ifcoord
            chktype = 1
            call chkpt_mfo(fname(1),chktype,ipert)
         endif

         ! perturbation
         IFXYO = .FALSE.
         chktype = 3
         ipert = 1
         call chkpt_mfo(fname(fnum),chktype,ipert)
      else ! DNS
         ! write only one set of files
         if (fnum.ne.1) call mntr_abort(chpm_id,
     $        'chkpt_restart_save; too meny files for DNS')

         IFXYO = ifcoord
         chktype = 1
         call chkpt_mfo(fname(1),chktype,ipert)
      endif

      ! restore I/O parameters
      WDSIZO = lwdsizo
      IF_FULL_PRES = lif_full_pres
      IFXYO = lifxyo
      IFPO = lifpo
      IFVO = lifvo
      IFTO = lifto
      do il=1,NPSCAL
         IFPSCO(il) = lifpsco(il)
      enddo

      return
      end subroutine
!=======================================================================
!> @brief Read checkpoint snapshot.
!! @ingroup chkpoint_mstep
!! @param[out] fname   restart file name
!! @param[in]  fnum    number of files in snapshot
      subroutine chkpt_restart_read(fname, fnum)
      implicit none

      include 'SIZE'
      include 'RESTART'
      include 'TSTEP'
      include 'INPUT'
      include 'CHKPTMSTPD'

      ! argument list
      character*132 fname(CHKPTNFMAX)
      integer fnum

      ! local variables
      integer ndumps, ipert, il
      ! which set of variables do we write: DNS (1), MHD (2) or perturbation (3)
      integer chktype
      character*132 fnamel
!-----------------------------------------------------------------------
      if (IFMHD) then
         ! DNS first
         chktype = 1
         call sioflag(ndumps,fnamel,fname(1))
         call chkpt_mfi(fnamel,chktype,ipert)

         ! MHD
         chktype = 2
         call sioflag(ndumps,fnamel,fname(2))
         call chkpt_mfi(fnamel,chktype,ipert)

      elseif (IFPERT) then
         ! DNS first
         if (fnum.eq.2) then
            chktype = 1
            call sioflag(ndumps,fnamel,fname(1))
            call chkpt_mfi(fnamel,chktype,ipert)
         endif

         ! perturbation
         chktype = 3
         ipert = 1
         call sioflag(ndumps,fnamel,fname(fnum))
         call chkpt_mfi(fnamel,chktype,ipert)
      else ! DNS
         ! read only one set of files
         if (fnum.ne.1) call mntr_abort(chpm_id,
     $        'chkpt_restart_read; too meny files for DNS')

         chktype = 1
         call sioflag(ndumps,fnamel,fname(1))
         call chkpt_mfi(fnamel,chktype,ipert)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Write field to the file
!! @details This routine is based on @ref mfo_outfld but does not assume
!!    any file numbering. It is optimised for chekpoint writing.
!! @ingroup chkpoint_mstep
!! @param[in]   fname      file name
!! @param[in]   chktype    data type to write (DNS, MHD, perturbation)
!! @param[in]   ipert      index of perturbation field
!! @note Only one set of data (DNS, MHD or perturbation) can be saved in
!!    single file
!! @remark This routine uses global scratch space \a SCRCG.
      subroutine chkpt_mfo(fname,chktype,ipert)
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'
      include 'TSTEP'
      include 'GEOM'
      include 'SOLN'
      include 'FRAMELP'
      include 'CHKPTMSTPD'

      ! argumnt list
      character*132 fname
      integer chktype, ipert

      ! local variables
      integer ierr, il, itmp
      integer ioflds
      integer*8 offs,nbyte
      real dnbyte, tiostart, tio

      ! functions
      real dnekclock_sync, glsum

      real pm1(lx1,ly1,lz1,lelv)
      common /SCRCG/ pm1
!-----------------------------------------------------------------------
      ! simple timing
      tiostart=dnekclock_sync()

      ! set elelemnt size
      NXO  = NX1
      NYO  = NY1
      NZO  = NZ1

      ! open file
      call io_mbyte_open(fname,ierr)
      call mntr_check_abort(chpm_id,ierr,'chkpt_mfo; file not opened.')

      ! write a header and create element mapping
      call mfo_write_hdr

      ! set header offset
      offs = iHeaderSize + 4 + isize*nelgt
      ioflds = 0

      ! write fields
      ! coordinates
      if (ifxyo) then
         call io_mfov(offs,xm1,ym1,zm1,nx1,ny1,nz1,nelt,nelgt,ndim)
         ioflds = ioflds + ndim
      endif

      ! velocity, magnetic field, perturbation velocity
      if (ifvo) then
         if (chktype.eq.1) then
            call io_mfov(offs,vx,vy,vz,nx1,ny1,nz1,nelt,nelgt,ndim)
         elseif(chktype.eq.2) then
            call io_mfov(offs,bx,by,bz,nx1,ny1,nz1,nelt,nelgt,ndim)
         elseif(chktype.eq.3) then
            call io_mfov(offs,vxp(1,ipert),vyp(1,ipert),
     $                       vzp(1,ipert),nx1,ny1,nz1,nelt,nelgt,ndim)
         endif
         ioflds = ioflds + ndim
      endif

      ! pressure
      if (ifpo) then
         if (chktype.eq.1) then
            ! copy array if necessary
            if (ifsplit) then
               itmp = nx1*ny1*nz1*lelv
               call io_mfos(offs,pr,nx2,ny2,nz2,nelt,nelgt,ndim)
            else
               itmp = nx1*ny1*nz1*lelv
               call rzero(pm1,itmp)
               itmp = nx2*ny2*nz2
               do il=1,nelv
                  call copy(pm1(1,1,1,il),pr(1,1,1,il),itmp)
               enddo
               call io_mfos(offs,pm1,nx1,ny1,nz1,nelt,nelgt,ndim)
            endif
         elseif(chktype.eq.2) then
            ! copy array
            itmp = nx1*ny1*nz1*lelv
            call rzero(pm1,itmp)
            itmp = nx2*ny2*nz2
            do il=1,nelv
               call copy(pm1(1,1,1,il),pm(1,1,1,il),itmp)
            enddo
            call io_mfos(offs,pm1,nx1,ny1,nz1,nelt,nelgt,ndim)
         elseif(chktype.eq.3) then
            ! copy array
            itmp = nx1*ny1*nz1*lelv
            call rzero(pm1,itmp)
            itmp = nx2*ny2*nz2
            do il=1,nelv
               call copy(pm1(1,1,1,il),prp(1+itmp*(il-1),ipert),itmp)
            enddo
            call io_mfos(offs,pm1,nx1,ny1,nz1,nelt,nelgt,ndim)
         endif
         ioflds = ioflds + 1
      endif

      if (chktype.ne.2) then
         if (ifto) then
            if (chktype.eq.1) then
               call io_mfos(offs,t,nx1,ny1,nz1,nelt,nelgt,ndim)
            elseif(chktype.eq.3) then
               call io_mfos(offs,tp(1,1,ipert),
     $                          nx1,ny1,nz1,nelt,nelgt,ndim)
            endif
            ioflds = ioflds + 1
         endif

         do il=1,ldimt-1
            if (ifpsco(il)) then
               if (chktype.eq.1) then
                  call io_mfos(offs,t(1,1,1,1,il+1),
     $                 nx1,ny1,nz1,nelt,nelgt,ndim)
               elseif(chktype.eq.3) then
                  call io_mfos(offs,tp(1,il+1,ipert),
     $                 nx1,ny1,nz1,nelt,nelgt,ndim)
               endif
               ioflds = ioflds + 1
            endif
         enddo
      endif
      dnbyte = 1.*ioflds*nelt*wdsizo*nx1*ny1*nz1

      ! possible place for metadata

      ! close file
      call io_mbyte_close(ierr)
      call mntr_check_abort(chpm_id,ierr,'chkpt_mfo; file not closed.')

      ! stamp the log
      tio = dnekclock_sync()-tiostart
      if (tio.le.0) tio=1.

      dnbyte = glsum(dnbyte,1)
      dnbyte = dnbyte + iHeaderSize + 4. + isize*nelgt
      dnbyte = dnbyte/1024/1024

      call mntr_log(chpm_id,lp_prd,'Checkpoint written:')
      call mntr_logr(chpm_id,lp_vrb,'file size (MB) = ',dnbyte)
      call mntr_logr(chpm_id,lp_vrb,'avg data-throughput (MB/s) = ',
     $     dnbyte/tio)
      call mntr_logi(chpm_id,lp_vrb,'io-nodes = ',nfileo)

      return
      end subroutine
!=======================================================================
!> @brief Read field to the file
!! @details This routine is based on @ref mfi but supports perturbation
!!    as well. It is optimised for chekpoint reading.
!! @ingroup chkpoint_mstep
!! @param[in]   fname      file name
!! @param[in]   chktype    data type to read (DNS, MHD, preturbation)
!! @param[in]   ipert      index of perturbation field
!! @remark This routine uses global scratch space \a SCRUZ.
      subroutine chkpt_mfi(fname,chktype,ipert)
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'
      include 'TSTEP'
      include 'GEOM'
      include 'SOLN'
      include 'FRAMELP'
      include 'CHKPTMSTPD'

      ! argumnt list
      character*132 fname
      integer chktype, ipert

      ! local variables
      integer ierr, il, jl, kl
      integer itmp1, itmp2, itmp3
      integer ioflds
      integer*8 offs0,offs,nbyte
      real dnbyte, tiostart, tio
      logical ifskip

      !     scratch arrays
      integer lwkv
      parameter (lwkv = lx1*ly1*lz1*lelt)
      real wkv1(lwkv),wkv2(lwkv),wkv3(lwkv)
      common /scruz/ wkv1,wkv2,wkv3

      ! functions
      real dnekclock_sync, glsum
!-----------------------------------------------------------------------
      ! simple timing
      tiostart=dnekclock_sync()

      ! open file and read header; some operations related to header are
      ! performed in chkpts_read; it is not the optimal way, but I don't want
      ! to modify mfi_prepare
      call mfi_prepare(fname)

      ! set header offset
      offs = iHeaderSize + 4 + isize*nelgr
      ioflds = 0

      ! read fields
      ! coordinates
      if (ifgetxr) then
         ifskip = .not.ifgetx
         ! skip coordinates if you need to interpolate them;
         ! I assume current coordinates are more exact than the interpolated one
         if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
            call io_mfiv(offs,xm1,ym1,zm1,lx1,ly1,lz1,lelt,ifskip)
         else
            ifskip=.TRUE.
            call io_mfiv(offs,wkv1,wkv2,wkv3,nxr,nyr,nzr,lelt,ifskip)
         endif
         ioflds = ioflds + ldim
      endif

      ! velocity, magnetic field, perturbation velocity
      if (ifgetur) then
         ifskip = .not.ifgetu
         if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
            ! unchanged resolution
            ! read field directly to the variables
            if (chktype.eq.1) then
               call io_mfiv(offs,vx,vy,vz,lx1,ly1,lz1,lelv,ifskip)
            elseif(chktype.eq.2) then
               call io_mfiv(offs,bx,by,bz,lx1,ly1,lz1,lelv,ifskip)
            elseif(chktype.eq.3) then
               call io_mfiv(offs,vxp(1,ipert),vyp(1,ipert),vzp(1,ipert)
     $                   ,lx1,ly1,lz1,lelv,ifskip)
            endif
         else
            ! modified resolution
            ! read field to tmp array
            call io_mfiv(offs,wkv1,wkv2,wkv3,nxr,nyr,nzr,lelt,ifskip)

            ! interpolate
            if (ifgetu) then
               if (chktype.eq.1) then
                  call chkpt_map_gll(vx,wkv1,nxr,nzr,nelv)
                  call chkpt_map_gll(vy,wkv2,nxr,nzr,nelv)
                  if (if3d) call chkpt_map_gll(vz,wkv3,nxr,nzr,nelv)
               elseif(chktype.eq.2) then
                  call chkpt_map_gll(bx,wkv1,nxr,nzr,nelv)
                  call chkpt_map_gll(by,wkv2,nxr,nzr,nelv)
                  if (if3d) call chkpt_map_gll(bz,wkv3,nxr,nzr,nelv)
               elseif(chktype.eq.3) then
                  call chkpt_map_gll(vxp(1,ipert),wkv1,nxr,nzr,nelv)
                  call chkpt_map_gll(vyp(1,ipert),wkv2,nxr,nzr,nelv)
                  if (if3d) call chkpt_map_gll(vzp(1,ipert),wkv3,
     $                        nxr,nzr,nelv)
               endif
            endif
         endif
         ioflds = ioflds + ndim
      endif

      ! pressure
      if (ifgetpr) then
         ifskip = .not.ifgetp

         if (chpm_if_pmesh) then
            ! file contains pressure on nxr-2 (GL) mesh
            ! read field to tmp array
            call io_mfis(offs,wkv1,nxr,nyr,nzr,lelt,ifskip)

            if (ifgetp) then
               if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
                  ! unchanged resolution
                  if (ifsplit) then
                     if (chktype.eq.1) then
                        !interpolate GL to GLL
                        itmp1 = nx1*ny1*nz1
                        jl = 1
                        do il=1,nelv
                           call map21t (pr(1,1,1,il),wkv1(jl),il)
                           jl = jl +itmp1
                        enddo
                     endif
                  else
                     ! remove zeros
                     itmp1 = nx1*ny1*nz1
                     itmp2 = nx2*ny2*nz2
                     jl = 1
                     if(chktype.eq.1) then
                        do il=1,nelv
                           call copy(pr(1,1,1,il),wkv1(jl),itmp2)
                           jl = jl + itmp1
                        enddo
                     elseif(chktype.eq.2) then
                        do il=1,nelv
                           call copy(pm(1,1,1,il),wkv1(jl),itmp2)
                           jl = jl + itmp1
                        enddo
                     elseif(chktype.eq.3) then
                        kl = 1
                        do il=1,nelv
                           call copy(prp(kl,ipert),wkv1(jl),itmp2)
                           jl = jl + itmp1
                           kl = kl + itmp2
                        enddo
                     endif
                  endif
               else
                  ! modified resolution
                  ! remove zeros
                  itmp1 = nxr*nyr*nzr
                  itmp3 = max(nzr-2,1)
                  itmp2 = (nxr-2)*(nyr-2)*itmp3
                  jl = 1
                  kl = 1
                  do il=1,nelv
                     call copy(wkv2(kl),wkv1(jl),itmp2)
                     jl = jl + itmp1
                     kl = kl + itmp2
                  enddo

                  if (ifsplit) then
                     if (chktype.eq.1) then
                        ! interpolate on GL mesh
                        call chkpt_map_gl(wkv1,wkv2,nxr-2,itmp3,nelv)

                        !interpolate GL to GLL
                        itmp2 = nx2*ny2*nz2
                        jl = 1
                        do il=1,nelv
                           call map21t (pr(1,1,1,il),wkv1(jl),il)
                           jl = jl +itmp2
                        enddo
                     endif
                  else
                     ! interpolate on GL mesh
                     if (chktype.eq.1) then
                        call chkpt_map_gl(pr,wkv2,nxr-2,itmp3,nelv)
                     elseif(chktype.eq.2) then
                        call chkpt_map_gl(pm,wkv2,nxr-2,itmp3,nelv)
                     elseif(chktype.eq.3) then
                        call chkpt_map_gl(prp(1,ipert),wkv2,nxr-2,
     $                       itmp3,nelv)
                     endif
                  endif
               endif
            endif

         else
            ! file contains pressure on nxr (GLL) mesh
            if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
               ! unchanged resolution
               if (ifsplit) then
                  ! read field directly to the variables
                  if (chktype.eq.1) then
                     call io_mfis(offs,pr,lx1,ly1,lz1,lelv,ifskip)
                  endif
               else
                  ! read field to tmp array
                  call io_mfis(offs,wkv1,nxr,nyr,nzr,lelt,ifskip)

                  ! interpolate GLL to GL
                  if (ifgetp) then
                     itmp2 = nx1*ny1*nz1
                     itmp2 = nx2*ny2*nz2
                     jl = 1
                     if (chktype.eq.1) then
                        do il=1,nelv
                           call map12 (pr(1,1,1,il),wkv1(jl),il)
                           jl = jl +itmp1
                        enddo
                     elseif(chktype.eq.2) then
                        do il=1,nelv
                           call map12 (pm(1,1,1,il),wkv1(jl),il)
                           jl = jl +itmp1
                        enddo
                     elseif(chktype.eq.3) then
                        kl = 1
                        do il=1,nelv
                           call map12 (prp(kl,ipert),wkv1(jl),il)
                           jl = jl +itmp1
                           kl = kl +itmp2
                        enddo
                     endif
                  endif
               endif

            else
               ! modified resolution
               ! read field to tmp array
               call io_mfis(offs,wkv1,nxr,nyr,nzr,lelt,ifskip)

               if (ifgetp) then
                  if (ifsplit) then
                     ! interpolate on GLL
                     call chkpt_map_gll(pr,wkv1,nxr,nzr,nelv)
                  else
                     ! interpolate on GLL
                     call chkpt_map_gll(wkv2,wkv1,nxr,nzr,nelv)

                     ! interpolate GLL to GL
                     itmp2 = nx1*ny1*nz1
                     itmp2 = nx2*ny2*nz2
                     jl = 1
                     if (chktype.eq.1) then
                        do il=1,nelv
                           call map12 (pr(1,1,1,il),wkv2(jl),il)
                           jl = jl +itmp1
                        enddo
                     elseif(chktype.eq.2) then
                        do il=1,nelv
                           call map12 (pm(1,1,1,il),wkv2(jl),il)
                           jl = jl +itmp1
                        enddo
                     elseif(chktype.eq.3) then
                        kl = 1
                        do il=1,nelv
                           call map12 (prp(kl,ipert),wkv2(jl),il)
                           jl = jl +itmp1
                           kl = kl +itmp2
                        enddo
                     endif
                  endif
               endif
            endif
         endif

         ioflds = ioflds + 1
      endif

      if (chktype.ne.2) then
         if (ifgettr) then
            ifskip = .not.ifgett
            if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
               ! unchanged resolution
               ! read field directly to the variables
               if (chktype.eq.1) then
                  call io_mfis(offs,t,lx1,ly1,lz1,lelt,ifskip)
               elseif(chktype.eq.3) then
                  call io_mfis(offs,tp(1,1,ipert),lx1,ly1,lz1,lelt,
     $                 ifskip)
               endif
            else
               ! modified resolution
               ! read field to tmp array
               call io_mfis(offs,wkv1,nxr,nyr,nzr,lelt,ifskip)

               ! interpolate
               if (ifgett) then
                  if (chktype.eq.1) then
                     call chkpt_map_gll(t,wkv1,nxr,nzr,nelt)
                  elseif(chktype.eq.3) then
                     call chkpt_map_gll(tp(1,1,ipert),wkv1,nxr,nzr,nelt)
                  endif
               endif
            endif
            ioflds = ioflds + 1
         endif

         do il=1,ldimt-1
            if (ifgtpsr(il)) then
               ifskip = .not.ifgtps(il)
               if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
                  ! unchanged resolution
                  ! read field directly to the variables
                  if (chktype.eq.1) then
                     call io_mfis(offs,t(1,1,1,1,il+1),lx1,ly1,lz1,
     $                            lelt,ifskip)
                  elseif(chktype.eq.3) then
                     call io_mfis(offs,tp(1,il+1,ipert),lx1,ly1,lz1,
     $                            lelt,ifskip)
                  endif
               else
                  ! modified resolution
                  ! read field to tmp array
                  call io_mfis(offs,wkv1,nxr,nyr,nzr,lelt,ifskip)

                  ! interpolate
                  if (ifgtps(il)) then
                     if (chktype.eq.1) then
                        call chkpt_map_gll(t(1,1,1,1,il+1),wkv1,
     $                                    nxr,nzr,nelt)
                     elseif(chktype.eq.3) then
                        call chkpt_map_gll(tp(1,il+1,ipert),wkv1,
     $                                    nxr,nzr,nelt)
                     endif
                  endif
               endif
               ioflds = ioflds + 1
            endif
         enddo
      endif

      if (ifgtim) time = timer

      ! close file
      call io_mbyte_close(ierr)
      call mntr_check_abort(chpm_id,ierr,'chkpt_mfi; file not closed.')

      ! stamp the log
      tio = dnekclock_sync()-tiostart
      if (tio.le.0) tio=1.

      if(nid.eq.pid0r) then
         dnbyte = 1.*ioflds*nelr*wdsizr*nxr*nyr*nzr
      else
         dnbyte = 0.0
      endif

      dnbyte = glsum(dnbyte,1)
      dnbyte = dnbyte + iHeaderSize + 4. + isize*nelgt
      dnbyte = dnbyte/1024/1024

      call mntr_log(chpm_id,lp_prd,'Checkpoint read:')
      call mntr_logr(chpm_id,lp_vrb,'avg data-throughput (MB/s) = ',
     $     dnbyte/tio)
      call mntr_logi(chpm_id,lp_vrb,'io-nodes = ',nfileo)

      if (ifaxis) call chkpt_axis_interp_ic()

      return
      end subroutine
!=======================================================================
!> @brief Interpolate input on velocity mesh
!! @details This is version of @ref mapab with corrected array sizes.
!!    It iterpolates fields defined on GLL points. Like
!!    the orginal routine I assume NXR=NYR=NZR, or NXR=NYR, NZR=1
!! @ingroup chkpoint_mstep
!! @param[out]   xf           output field on velocity mesh
!! @param[in]    yf           input field on velocity mesh
!! @param[in]    nxr, nzr     array sizes
!! @param[in]    nel          element number
!! @remarks This routine uses global scratch space CTMP0, CTMPABM1
      subroutine chkpt_map_gll(xf,yf,nxr,nzr,nel)
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'IXYZ'
      include 'WZ'

      ! argument lists
      integer nxr, nzr, nel
      real xf(lx1,ly1,lz1,nel), yf(nxr,nxr,nzr,nel)

      ! local variables
      integer nyzr, nxy2
      integer ie, iz, izoff

      ! moddificaion flag
      integer nold
      save    nold
      data    nold /0/

      ! work arrays
      integer lxr, lyr, lzr, lxyzr
      parameter (lxr=lx1+6)
      parameter (lyr=ly1+6)
      parameter (lzr=lz1+6)
      parameter (lxyzr=lxr*lyr*lzr)
      real txa(lxyzr),txb(lx1,ly1,lzr),zgmr(lxr),wgtr(lxr)
      common /ctmp0/  txa, txb, zgmr, wgtr

      ! interpolation arrays
      real ires(lxr*lxr)  ,itres(lxr*lxr)
      common /ctmpabm1/ ires, itres
!-----------------------------------------------------------------------
      nyzr = nxr*nzr
      nxy2 = lx1*ly1

      if (nxr.ne.nold) then
         nold=nxr
         call zwgll(zgmr,wgtr,nxr)
         call igllm(ires,itres,zgmr,zgm1,nxr,lx1,nxr,lx1)
      endif

      do ie=1,nel
         call mxm (ires,lx1,yf(1,1,1,ie),nxr,txa,nyzr)
         do iz=1,nzr
            izoff = 1 + (iz-1)*lx1*nxr
            call mxm (txa(izoff),lx1,itres,nxr,txb(1,1,iz),ly1)
         enddo
         if (if3d) then
            call mxm (txb,nxy2,itres,nzr,xf(1,1,1,ie),lz1)
         else
            call copy(xf(1,1,1,ie),txb,nxy2)
         endif
      enddo

      return
      end subroutine
!=======================================================================
!> @brief Interpolate pressure input
!! @details This is version of @ref mapab modified to work with pressure
!!    mesh. It iterpolates fields defined on GL points. Like
!!    the orginal routine I assume NXR=NYR=NZR, or NXR=NYR, NZR=1
!! @ingroup chkpoint_mstep
!! @param[out]   xf           output field on pressure mesh
!! @param[in]    yf           input field on pressure mesh
!! @param[in]    nxr, nzr     array sizes
!! @param[in]    nel          element number
!! @remarks This routine uses global scratch space CTMP0, CTMPABM2
      subroutine chkpt_map_gl(xf,yf,nxr,nzr,nel)
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'IXYZ'
      include 'WZ'

      ! argument lists
      integer nxr, nzr, nel
      real xf(lx2,ly2,lz2,nel), yf(nxr,nxr,nzr,nel)

      ! local variables
      integer nyzr, nxy2
      integer ie, iz, izoff

      ! moddificaion flag
      integer nold
      save    nold
      data    nold /0/

      ! work arrays
      integer lxr, lyr, lzr, lxyzr
      parameter (lxr=lx2+6)
      parameter (lyr=ly2+6)
      parameter (lzr=lz2+6)
      parameter (lxyzr=lxr*lyr*lzr)
      real txa(lxyzr),txb(lx2,ly2,lzr),zgmr(lxr),wgtr(lxr)
      common /ctmp0/  txa, txb, zgmr, wgtr

      ! interpolation arrays
      real ires(lxr,lxr)  ,itres(lxr,lxr)
      common /ctmpabm2/ ires, itres
!-----------------------------------------------------------------------
      nyzr = nxr*nzr
      nxy2 = lx2*ly2

      if (nxr.ne.nold) then
         nold=nxr
         call zwgl   (zgmr,wgtr,nxr)
         call iglm   (ires,itres,zgmr,zgm2,nxr,lx2,nxr,lx2)
      endif

      do ie=1,nel
         call mxm (ires,lx2,yf(1,1,1,ie),nxr,txa,nyzr)
         do iz=1,nzr
            izoff = 1 + (iz-1)*lx2*nxr
            call mxm (txa(izoff),lx2,itres,nxr,txb(1,1,iz),ly2)
         enddo
         if (if3d) then
            call mxm (txb,nxy2,itres,nzr,xf(1,1,1,ie),lz2)
         else
            call copy(xf(1,1,1,ie),txb,nxy2)
         endif
      enddo

      return
      end subroutine
!=======================================================================
!> @brief Map loaded variables from velocity to axisymmetric mesh
!! @ingroup chkpoint_mstep
!! @note This is version of @ref axis_interp_ic taking into account fact
!! pressure does not have to be written on velocity mesh.
!! @remark This routine uses global scratch space \a CTMP0.
      subroutine chkpt_axis_interp_ic()
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      include 'RESTART'
      include 'SOLN'
      include 'GEOM'
      include 'IXYZ'

      ! scratch space
      real axism1 (lx1,ly1), axism2 (lx2,ly2), ialj2 (ly2,ly2),
     $     iatlj2(ly2,ly2), tmp(ly2,ly2)
      common /ctmp0/ axism1, axism2, ialj2, iatlj2, tmp

      ! local variables
      integer el, ips, is1
!-----------------------------------------------------------------------
      if (.not.ifaxis) return

      ! get interpolation operators between Gauss-Lobatto Jacobi
      ! and and Gauss Legendre poits (this is missing in genwz)
      !call invmt(iajl2 ,ialj2 ,tmp ,ly2)
      call invmt(iatjl2,iatlj2,tmp,ly2)

      do el=1,nelv
         if (ifrzer(el)) then
           if (ifgetx) then
             call mxm(xm1(1,1,1,el),nx1,iatlj1,ny1,axism1,ny1)
             call copy(xm1(1,1,1,el),axism1,nx1*ny1)
             call mxm(ym1(1,1,1,el),nx1,iatlj1,ny1,axism1,ny1)
             call copy(ym1(1,1,1,el),axism1,nx1*ny1)
           endif
           if (ifgetu) then
             call mxm(vx(1,1,1,el),nx1,iatlj1,ny1,axism1,ny1)
             call copy(vx(1,1,1,el),axism1,nx1*ny1)
             call mxm(vy(1,1,1,el),nx1,iatlj1,ny1,axism1,ny1)
             call copy(vy(1,1,1,el),axism1,nx1*ny1)
           endif
           if (ifgetw) then
             call mxm(vz(1,1,1,el),nx1,iatlj1,ny1,axism1,ny1)
             call copy(vz(1,1,1,el),axism1,nx1*ny1)
           endif
           if (ifgetp) then
             if (ifsplit) then
                call mxm(pr(1,1,1,el),nx1,iatlj1,ny1,axism1,ny1)
                call copy(pr(1,1,1,el),axism1,nx1*ny1)
             else
                call mxm(pr(1,1,1,el),nx2,iatlj2,ny2,axism2,ny2)
                call copy(pr(1,1,1,el),axism2,nx2*ny2)
             endif
           endif
           if (ifgett) then
             call mxm(t(1,1,1,el,1),nx1,iatlj1,ny1,axism1,ny1)
             call copy(t(1,1,1,el,1),axism1,nx1*ny1)
           endif
           do ips=1,npscal
            is1 = ips + 1
            if (ifgtps(ips)) then
             call mxm(t(1,1,1,el,is1),nx1,iatlj1,ny1,axism1,ny1)
             call copy(t(1,1,1,el,is1),axism1,nx1*ny1)
            endif
           enddo
         endif
      enddo

      return
      end subroutine
!=======================================================================

!> @file map2D.f
!! @ingroup map2d
!! @brief 3D to 2D element mapping routines
!! @details Partially based on the old statistic code
!! @note This code works for extruded meshes only
!! @author Adam Peplinski
!! @date May 29, 2018
!=======================================================================
!> @brief Register 2D mapping routines
!! @ingroup map2d
!! @note This routine should be called in frame_usr_register
      subroutine map2D_register()
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'FRAMELP'
      include 'MAP2D'

!     local variables
      integer lpmid, il
      real ltim
      character*2 str

!     functions
      real dnekclock
!-----------------------------------------------------------------------
!     timing
      ltim = dnekclock()

!     check if the current module was already registered
      call mntr_mod_is_name_reg(lpmid,map2d_name)
      if (lpmid.gt.0) then
         call mntr_warn(lpmid,
     $        'module ['//trim(map2d_name)//'] already registered')
         return
      endif

!     find parent module
      call mntr_mod_is_name_reg(lpmid,'FRAME')
      if (lpmid.le.0) then
         lpmid = 1
         call mntr_abort(lpmid,
     $        'parent module ['//'FRAME'//'] not registered')
      endif
      
!     register module
      call mntr_mod_reg(map2d_id,lpmid,map2d_name,
     $      'Mapping 3D mesh to 2D section')

!     register timer
      call mntr_tmr_is_name_reg(lpmid,'FRM_TOT')
      call mntr_tmr_reg(map2d_tmr_id,lpmid,map2d_id,
     $     'MAP2D_TOT','2D mapping total time',.false.)

!     set initialisation flag
      map2d_ifinit=.false.
      
!     timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(map2d_tmr_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Initilise map2d module
!! @ingroup map2d
!! @note This routine should be called in frame_usr_init
      subroutine map2d_init()
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'FRAMELP' 
      include 'MAP2D'

!     local variables
      integer itmp
      real rtmp, ltim
      logical ltmp
      character*20 ctmp

      integer il, jl

!     functions
      real dnekclock
!-----------------------------------------------------------------------
!     timing
      ltim = dnekclock()      

!     check if the module was already initialised
      if (map2d_ifinit) then
         call mntr_warn(map2d_id,
     $        'module ['//trim(map2d_name)//'] already initiaised.')
         return
      endif

      call map2d_get

!     reshuffle coordinate arrays
      call mntr_log(map2d_id,lp_vrb,'Creating 2D mesh')
      call map2d_init_coord

!     everything is initialised
      map2d_ifinit=.true.
      
!     timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(map2d_tmr_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Get 3D to 2D element mapping
!! @ingroup map2d
!! @remark This routine uses global scratch space \a SCRNS , \a SCRVH
!!   and \a SCRUZ
      subroutine map2d_get()
      implicit none

      include 'SIZE'
      include 'FRAMELP' 
      include 'MAP2D'           ! 2D mapping speciffic variables

!     work arrays
      integer lctrs1 ,lctrs2    ! array sizes
      parameter (lctrs1=3,lctrs2=2*LX1*LY1*LZ1*LELT)
      real ctrs(lctrs1,lctrs2)  ! 2D element centres for sorting
      integer cell(lctrs2)      ! local element numberring
      integer ninseg(lctrs2)    ! elements in segment
      integer ind(lctrs2)       ! sorting index
      integer owner(lctrs2)     ! mark node with smallest id
      logical ifseg(lctrs2)     ! segment borders
      common /SCRNS/ ctrs
      common /SCRVH/ ifseg
      common /SCRUZ/ cell, ninseg, ind, owner

      integer nelsort           ! number of local 3D elements to sort
      integer nseg              ! segments number
      integer il, jl, iseg      ! loop index
      integer ierr              ! error flag

      real ltol                 ! tolerance for detection of section borders
      parameter (ltol = 1.0e-4)
      
!     simple timing
      real ltim

!     functions
      integer iglsum, iglmin, iglmax
      real dnekclock

!#define DEBUG
#ifdef DEBUG
!     for testing
      character*3 str1, str2
      integer iunit
      ! call number
      integer icalldl
      save icalldl
      data icalldl /0/
#endif
!-----------------------------------------------------------------------
!     simple timing
      ltim = dnekclock()
      
!     stamp logs
      call mntr_log(map2d_id,lp_inf,'3D=>2D mapping begin')

      
      call mntr_log(map2d_id,lp_vrb,'Local 3D=>2D mapping')

!     fill in arrays using user interface
!     We can sort only part of the domain, so first mark and copy
!     all elements in the region you are interested in
!     set uniform direction, cell centres and diagonals
      call user_map2d_get(map2d_idir,ctrs,cell,lctrs1,lctrs2,nelsort,
     $     map2d_xm1,map2d_ym1,ierr)

      call mntr_check_abort(map2d_id,ierr,'Wrong element shape')

      if (map2d_idir.gt.ldim) call mntr_abort(map2d_id,
     $        'Wrong mapping direction')
      
!     check array sizes vs number of elements for sorting
      if (lctrs2.lt.nelsort) then
         ierr = 1
      else
         ierr = 0
      endif
      call mntr_check_abort(map2d_id,ierr,'Too many element to sort')

      if (NELT.lt.nelsort) then
         ierr = 1
      else
         ierr = 0
      endif
      call mntr_check_abort(map2d_id,ierr,
     $     'More element to sort than local elements')
      
!     local sort to get unique 2D elements
      call map2d_get_local(ctrs,cell,ninseg,ind,ifseg,
     $     lctrs1,lctrs2,nseg,nelsort,ltol)

!     generate local 3D => 2D mapping
!     local number of unique 2D elements
      MAP2D_LNUM = nseg

!     mark all elements as unwanted
      call ifill(MAP2D_LMAP,-1,NELT)
      
!     for all segments count 3D elements
      jl=1
      do iseg=1,nseg
!     within segment
         do il=1,ninseg(iseg)
            MAP2D_LMAP(cell(jl)) = iseg
            jl=jl+1
         enddo
      enddo

#ifdef DEBUG
!     testing
      icalldl = icalldl+1
      call io_file_freeid(iunit, ierr)
      write(str1,'(i3.3)') NID
      write(str2,'(i3.3)') icalldl
      open(unit=iunit,file='map2d_loc.txt'//str1//'i'//str2)
      
      write(iunit,*) nseg, NELV
      write(iunit,*) 'Coordinates'
      do il=1,nseg
         write(iunit,*) il, ctrs(:,il)
      enddo
      write(iunit,*) 'Mapping'
      do il=1,NELV
         write(iunit,*) il, MAP2D_LMAP(il)
      enddo
      close(iunit)
#endif
      
      call mntr_log(map2d_id,lp_vrb,'Global 3D=>2D mapping')

!     reset ownership and local => global map
!     this routine will produce the simplest ownership without 
!     taking into account work ballancing
      call ifill(MAP2D_GMAP,-1,nseg)
      call ifill(MAP2D_OWN,-1,nseg)
      
      call map2d_get_global(ctrs,owner,cell,ninseg,ind,ifseg,
     $     lctrs1,lctrs2,nseg,ltol)

!     find number of of elements owned
      MAP2D_LOWN = 0
      do il=1,MAP2D_LNUM
         if (MAP2D_OWN(il).eq.NID) MAP2D_LOWN = MAP2D_LOWN + 1
      enddo
!     global number of unique 2D elements
      MAP2D_GNUM = iglsum(MAP2D_LOWN,1)
!     imbalance
      il = iglmin(MAP2D_LOWN,1)
      jl = iglmax(MAP2D_LOWN,1)
      
!     stamp logs
      call mntr_logi(map2d_id,lp_inf,
     $     'Global number of unique 2D elements: ',MAP2D_GNUM)
      call mntr_log(map2d_id,lp_vrb,'Owned 2D element imbalance:')
      call mntr_logi(map2d_id,lp_vrb,'   min: ',il)
      call mntr_logi(map2d_id,lp_vrb,'   max: ',jl)

#ifdef DEBUG
!     testing
      call io_file_freeid(iunit, ierr)
      write(str1,'(i3.3)') NID
      write(str2,'(i3.3)') icalldl
      open(unit=iunit,file='map2d_glob.txt'//str1//'i'//str2)
      
      write(iunit,*) MAP2D_GNUM, MAP2D_LOWN
      write(iunit,*) 'Mapping'
      do il=1,MAP2D_LNUM
         write(iunit,*) il, MAP2D_GMAP(il),MAP2D_OWN(il)
      enddo
      close(iunit)
#endif
#undef DEBUG

!     stamp logs
      call mntr_log(map2d_id,lp_inf,'3D=>2D mapping end')

!     timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(map2d_tmr_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Get local 3D=>2D mapping
!! @ingroup map2d
!! @param[out]  ctrs              2D element centres
!! @param[out]  cell              local element numberring
!! @param[out]  ninseg            elements in segmen (work array)
!! @param[out]  ind               sorting index (work array)
!! @param[out]  ifseg             segment borders (work array)
!! @param[in]   lctrs1,lctrs2     array sizes
!! @param[out]  nseg              segments number
!! @param[in]   nelsort           number of local 3D elements to sort
!! @param[in]   tol               tolerance to find segment borders
      subroutine map2d_get_local(ctrs,cell,ninseg,ind,ifseg,
     $     lctrs1,lctrs2,nseg,nelsort,tol)
      implicit none

      include 'SIZE'

!     argument list
      integer lctrs1,lctrs2     ! array sizes
      real ctrs(lctrs1,lctrs2)  ! 2D element centres for sorting
      integer nseg              ! segments number
      integer nelsort           ! number of local 3D elements to sort
      real tol                  ! tolerance to find segment borders
!     work arrays
      integer cell(lctrs2)      ! local element numberring
      integer ninseg(lctrs2)    ! elements in segment
      integer ind(lctrs2)       ! sorting index
      logical ifseg(lctrs2)     ! segment borders

!     local variables
      integer el, il, jl        ! loop indexes
      integer ierr              ! error flag

!     local sorting
      integer key               ! sorting key
      integer ipass, iseg       ! loop index
      real aa(lctrs1)           ! dummy array
!-----------------------------------------------------------------------
!     for every element
      do el=1,nelsort
!     reset segments borders
         ifseg(el) = .FALSE.
      enddo

!     perform local sorting to identify unique set sorting by directions
!     first run => whole set is one segment
      nseg        = 1
      ifseg(1)    = .TRUE.
      ninseg(1)   = nelsort

!     Multiple passes eliminates false positives
      do ipass=1,2
         do jl=1,ldim-1          ! Sort within each segment (dimention)

            il=1
            do iseg=1,nseg
               call tuple_sort(ctrs(1,il),lctrs1,ninseg(iseg),jl,1,
     $              ind,aa)     ! key = jl
               call iswap_ip(cell(il),ind,ninseg(iseg)) ! Swap position
               il = il + ninseg(iseg)
            enddo
 
            do il=2,nelsort
!     find segments borders
               if (abs(ctrs(jl,il)-ctrs(jl,il-1)).gt.
     $              tol*min(ctrs(3,il),ctrs(3,il-1)))
     $              ifseg(il)=.TRUE.
            enddo

!  Count up number of different segments
            nseg = 0
            do il=1,nelsort
               if (ifseg(il)) then
                  nseg = nseg+1
                  ninseg(nseg) = 1
               else
                  ninseg(nseg) = ninseg(nseg) + 1
               endif
            enddo
         enddo                  ! jl=1,2
      enddo                     ! ipass=1,2
!     sorting end

!     contract coordinate set
!     for all segments
!     count 3D elements
      jl=ninseg(1) +1
      do iseg=2,nseg
         do il = 1,lctrs1
            ctrs(il,iseg) = ctrs(il,jl)
         enddo
         jl = jl + ninseg(iseg)
      enddo

      return
      end subroutine
!=======================================================================
!> @brief Get global 3D=>2D mapping
!! @ingroup map2d
!! @param[inout]  ctrs            2D element centres
!! @param[inout]  owner           global element ownership (work array)
!! @param[inout]  cell            local element numberring (work array)
!! @param[inout]  ninseg          elements in segmen (work array)
!! @param[inout]  ind             sorting index (work array)
!! @param[inout]  ifseg           segment borders (work array)
!! @param[in]     lctrs1,lctrs2   array sizes
!! @param[inout]  nseg            segments number
!! @param[in]     tol             tolerance to find segment borders
      subroutine map2d_get_global(ctrs,owner,cell,ninseg,ind,ifseg,
     $     lctrs1,lctrs2,nseg,tol)
      implicit none

      include 'SIZE'
      include 'PARALLEL'
      include 'FRAMELP'
      include 'MAP2D'

!     argument list
      integer lctrs1,lctrs2     ! array sizes
      real ctrs(lctrs1,lctrs2)  ! 2D element centres for sorting
      integer nseg              ! segments number
      real tol                  ! tolerance to find segment borders
!     work arrays
      integer owner(lctrs2)     ! mark node with smallest id
      integer cell(lctrs2)      ! local element numberring
      integer ninseg(lctrs2)    ! elements in segment
      integer ind(lctrs2)       ! sorting index
      logical ifseg(lctrs2)     ! segment borders

!     local variables
      integer lnseg             ! initia number of segments
      integer csteps            ! numer of steps in the cycle
      integer lwork             ! working array size
      integer umrkgl            ! global number of unmarked zones
!     local coppies
      real lctrs(lctrs1,LELT)   ! local copy 2D element centres
      integer nsort             ! number of elements to sort
      integer nsorted           ! number of sorted elements

      integer igpass            ! numer of executed cycles
      integer igpass_max        ! max numer of cycles
      parameter (igpass_max = 100)

      integer icstep            ! loop index

!     communication
      integer msg_id1, msg_id2  ! message id for non-blocking receive
      integer srcid, dstid      ! source and destination node id
      integer len               ! buffer size
      integer cnsort            ! number of elements to receive

!     local sorting
      integer key               ! sorting key
      integer ipass, iseg, il, jl, kl ! loop index
      real aa(lctrs1)           ! dummy array

!     error mark
      integer ierror

      character*3 str

!     functions
      integer iglsum, irecv, iglmin, iglmax
!-----------------------------------------------------------------------
!     make a local copy of initial set
      lnseg = nseg
      il = lctrs1*nseg
      call copy(lctrs,ctrs,il)

!     get number of steps to exchange all the data in the ring
      csteps=int(log(NP+0.0)/log(2.0))
      if(NP.gt.2**csteps) csteps=csteps+1
      
!     free array size
      lwork = lctrs2/2
      
!     get global number of unmarked zones
      umrkgl = iglsum(nseg,1)
!     initial number of elements to sort
      nsort = min(nseg,lwork)
!     initial number of sorted elements
      nsorted = 0

!     fill initial cell and ownership arrays
      do il=1,nsort
         cell(il) = il
         owner(il) = NID
      enddo
      
!     following loop has to be executed as long as unmarked zones 
!     exists
!     count global passes
      igpass = 1
      do

!     stamp log
         write(str,'(i3.3)')  igpass
         call mntr_logi(map2d_id,lp_vrb,
     $        'Cycle '//str//'; globally unmarked = ',umrkgl)

!     collect information within the ring
         do icstep=1,csteps

!     exchange information between processors
!     source and destination
            il = 2**(icstep-1)
            srcid = NID - il
            dstid = NID + il
            if (srcid.lt.0) srcid = srcid + NP
            if (dstid.ge.NP) dstid = dstid - NP

!     set buffer for the number of elements to receive
            len = ISIZE
            msg_id1 = irecv(0,cnsort,len)

!     send local size of the buffer
            call csend(0,nsort,len,dstid,0)

!     finish communication
            call msgwait(msg_id1)

!     exchange coordinates and ownership
!     receive
            len = WDSIZE*lctrs1*cnsort
            msg_id1 = irecv(1,ctrs(1,nsort+1),len)

            len = ISIZE*cnsort
            msg_id2 = irecv(2,owner(nsort+1),len)

!     send
            len = WDSIZE*lctrs1*nsort
            call csend(1,ctrs,len,dstid,0)

            len = ISIZE*nsort
            call csend(2,owner,len,dstid,0)

!     reset cell for the received elements to -1
!     this way all the non-local elements are marked
            do il=nsort + 1,nsort + cnsort
               cell(il) = -1
            enddo

!     update number of elements to sort
            nsort = nsort + cnsort

!     perform local sorting to identify unique set
!     sorting by directions
!     reset section boudarry mark
            do il=1,nsort
               ifseg(il) = .FALSE.
            enddo
!     first run => whole set is one segment
            nseg        = 1
            ifseg(1)    = .TRUE.
            ninseg(1)   = nsort

!     finish communication
            call msgwait(msg_id1)
            call msgwait(msg_id2)
            
! Multiple passes eliminates false positives
            do ipass=1,2
               do jl=1,ldim-1    ! Sort within each segment (dimension)

                  il =1
                  do iseg=1,nseg
                     call tuple_sort(ctrs(1,il),lctrs1,ninseg(iseg),
     $                    jl,1, ind,aa) ! key = jl
!     Swap position
                     call iswap_ip(cell(il),ind,ninseg(iseg)) 
                     call iswap_ip(owner(il),ind,ninseg(iseg))
                     il = il + ninseg(iseg)
                  enddo
 
                  do il=2,nsort
!     find segments borders
                     if (abs(ctrs(jl,il)-ctrs(jl,il-1)).gt.
     $                    tol*min(ctrs(3,il),ctrs(3,il-1)))
     $                    ifseg(il)=.TRUE.
                  enddo

!     Count up number of different segments
                  nseg = 0      
                  do il=1,nsort
                     if (ifseg(il)) then
                        nseg = nseg+1
                        ninseg(nseg) = 1
                     else
                        ninseg(nseg) = ninseg(nseg) + 1
                     endif
                  enddo
               enddo            ! jl=1,2
            enddo               ! ipass=1,2
!     local sorting end

!     contract coordinate set
!     for all segments
            jl=ninseg(1) +1
            do iseg=2,nseg
               do il = 1,lctrs1
                  ctrs(il,iseg) = ctrs(il,jl)
               enddo
               jl = jl + ninseg(iseg)
            enddo
!     contract ownership
!     for all segments
            jl=1
            do iseg=1,nseg
               owner(iseg) = owner(jl)
               jl = jl + 1
!     within segment
               do il=2,ninseg(iseg)
                  if (owner(iseg).gt.owner(jl)) owner(iseg) = owner(jl)
                  jl = jl + 1
               enddo
            enddo
!     contract cell
            ierror = 0
!     for all segments
            jl=1
            do iseg=1,nseg
               cell(iseg) = cell(jl)
               jl = jl + 1
!     within segment
!     for checking consistency
!     in every section can be only 1 non negative cell entrance
               kl = 0
               if (cell(iseg).ne.-1) kl = kl+1
               do il=2,ninseg(iseg)
                  if (cell(iseg).lt.cell(jl)) cell(iseg) = cell(jl)
                  if (cell(jl).ne.-1) kl = kl+1
                  jl=jl + 1
               enddo
               if (kl.gt.1) ierror = ierror +1
            enddo

!     check consistency
            call mntr_check_abort(map2d_id,ierror,
     $           'Too many local elements in section')

!     update number of elements to sort
            nsort = min(nseg,lwork)

         enddo                  ! icstep
!     global exchange and sort end

         ierror = 0
!     mark elements that can be mapped
         do il=1,nsort
            if (cell(il).ne.-1) then
!     check consistency; was this cell mapped previously
               if(MAP2D_GMAP(cell(il)).ne.-1) then
                  ierror = ierror +1
               endif
               MAP2D_GMAP(cell(il)) = nsorted + il
               MAP2D_OWN(cell(il))  = owner(il)
            endif
         enddo

!     check consistency
         call mntr_check_abort(map2d_id,ierror,
     $           'Element already assigned')

!     update number of sorted elements
         nsorted = nsorted + nsort

!     count local unmarked zones
         nseg = 0
         do il=1,lnseg
            if(MAP2D_GMAP(il).eq.-1) then
               nseg = nseg + 1
!     fill in coordinates and mark initial ownership
               if (nseg.le.lwork) then
                  call copy(ctrs(1,nseg),lctrs(1,il),lctrs1)
                  owner(nseg) = NID
                  cell(nseg) = il
               endif
            endif
         enddo

!     get global number of unmarked zones
         umrkgl = iglsum(nseg,1)

         if (umrkgl.eq.0) exit

!     update number of elements to sort
         nsort = min(nseg,lwork)

!     count global passes
         igpass = igpass +1

!     is igpass too big; something is wrong exit
         if (igpass.gt.igpass_max) then
            call mntr_abort(map2d_id,'Max iterations exceeded')
         endif

      enddo                     ! infinite loop

      return
      end subroutine
!=======================================================================
!> @brief Generate 2D mesh out of 3D one.
!! @ingroup map2d
      subroutine map2d_init_coord
      implicit none

      include 'SIZE'
      include 'MAP2D'

!     local variables
      integer len               ! buffer size
      integer il                ! loop index
      integer el                ! destination element
      integer imark(lelt)       ! element mark
      real rtmp(lx1,lz1,lelt,2) ! dummy arrays
      common /ctmp0/ rtmp

!#define DEBUG
#ifdef DEBUG
!     for testing
      character*2 str
      integer iunit
#endif
!-----------------------------------------------------------------------
      len = lx1*lz1
      call ifill(imark, -1,nelv)
      do il=1,nelv
         el = map2d_lmap(il)
         if (el.gt.0) then
            if (imark(el).eq.-1) then
               imark(el) = 1
               call copy(rtmp(1,1,el,1),map2d_xm1(1,1,il),len)
               call copy(rtmp(1,1,el,2),map2d_ym1(1,1,il),len)
            endif
         endif
      enddo

!     copy arrays back
      len = len*map2d_lnum
      call copy(map2d_xm1,rtmp(1,1,1,1),len)
      call copy(map2d_ym1,rtmp(1,1,1,2),len)

#ifdef DEBUG
!     testing
      write(str,'(i2.2)') nid
      call io_file_freeid(iunit, ierr)
      open(unit=iunit,file='map2d_init_coord.txt'//str)
      write(iunit,*) nid, nelv, map2d_idir, map2d_lnum
      do el=1,nelv
         write(iunit,*) 'Element ', el
         do jl=1,nz1
            do il=1,nx1
               write(iunit,*) il,jl,map2d_xm1(il,jl,el),
     $              map2d_ym1(il,jl,el)
            enddo
         enddo
      enddo
      close(iunit)
#endif
#undef DEBUG
      return
      end subroutine
!======================================================================

!> @file mntrlog.f
!! @ingroup monitor
!! @brief Set of module register and logging routines for KTH framework
!! @author Adam Peplinski
!! @date Sep 28, 2017
!=======================================================================
!> @brief Initialise monitor by registering framework and monitor
!! @ingroup monitor
!! @param[in]  log_thr   initial log threshold
      subroutine mntr_register_mod(log_thr)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'
      include 'MNTRTMRD'

      ! argument list
      integer log_thr

      ! local variables
      character*2 str
      character*200 lstring

      ! functions
      integer frame_get_master
      real dnekclock
!-----------------------------------------------------------------------
      ! simple timing
      mntr_frame_tmini = dnekclock()

      ! set master node
      mntr_pid0 = frame_get_master()

      ! first register framework
      mntr_frame_id = 1
      mntr_mod_id(mntr_frame_id) = 0
      mntr_mod_name(mntr_frame_id) = mntr_frame_name
      mntr_mod_dscr(mntr_frame_id) = 'Framework backbone'
      mntr_mod_num = mntr_mod_num + 1
      mntr_mod_mpos = mntr_mod_mpos + 1

      ! next monitor
      mntr_id = 2
      mntr_mod_id(mntr_id) = mntr_frame_id
      mntr_mod_name(mntr_id) = mntr_name
      mntr_mod_dscr(mntr_id) = 'Monitoring module'
      mntr_mod_num = mntr_mod_num + 1
      mntr_mod_mpos = mntr_mod_mpos + 1

      ! set log threshold
      mntr_lp_def = log_thr

      ! log changes
      lstring ='Registered module ['//trim(mntr_mod_name(mntr_frame_id))
      lstring= trim(lstring)//']: '//trim(mntr_mod_dscr(mntr_frame_id))
      call mntr_log(mntr_id,lp_inf,trim(lstring))

      lstring = 'Registered module ['//trim(mntr_mod_name(mntr_id))
      lstring= trim(lstring)//']: '//trim(mntr_mod_dscr(mntr_id))
      call mntr_log(mntr_id,lp_inf,trim(lstring))

      ! register framework timer and get initiaisation time
      call mntr_tmr_reg(mntr_frame_tmr_id,0,mntr_frame_id,
     $     'FRM_TOT','Total elapsed framework time',.false.)

      write(str,'(I2)') mntr_lp_def
      call mntr_log(mntr_id,lp_inf,
     $     'Initial log threshold set to: '//trim(str))

      return
      end subroutine
!=======================================================================
!> @brief Register monitor runtime parameters
!! @ingroup monitor
      subroutine mntr_register_par
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! local variables
      integer rpid,itmp
      real rtmp
      logical ltmp
      character*20 ctmp
!-----------------------------------------------------------------------
      ! register and set active section
      call rprm_sec_reg(mntr_sec_id,mntr_id,'_'//adjustl(mntr_name),
     $     'Runtime parameter section for monitor module')
      call rprm_sec_set_act(.true.,mntr_sec_id)

      ! register parameters
      call rprm_rp_reg(mntr_lp_def_id,mntr_sec_id,'LOGLEVEL',
     $     'Logging threshold for toolboxes',rpar_int,mntr_lp_def,
     $      0.0,.false.,' ')

      call rprm_rp_reg(mntr_iftdsc_id,mntr_sec_id,'IFTIMDSCR',
     $     'Write timer description in the summary',rpar_log,0,
     $      0.0,.false.,' ')

      call rprm_rp_reg(mntr_wtime_id,mntr_sec_id,'WALLTIME',
     $     'Simulation wall time',rpar_str,0,0.0,.false.,'00:00')

      return
      end subroutine
!=======================================================================
!> @brief Initialise monitor module
!! @ingroup monitor
      subroutine mntr_init
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! local variables
      integer ierr, nhour, nmin
      integer itmp
      real rtmp
      logical ltmp
      character*20 ctmp
      character*2 str
!-----------------------------------------------------------------------
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,mntr_lp_def_id,rpar_int)
      mntr_lp_def = itmp

      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,mntr_iftdsc_id,rpar_log)
      mntr_iftdsc = ltmp

      write(str,'(I2)') mntr_lp_def
      call mntr_log(mntr_id,lp_inf,
     $     'Reseting log threshold to: '//trim(str))

      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,mntr_wtime_id,rpar_str)
      mntr_wtimes = ctmp

      ! get wall clock
      ctmp = trim(adjustl(mntr_wtimes))
      ! check string format
      ierr = 0
      if (ctmp(3:3).ne.':') ierr = 1
      if (.not.(LGE(ctmp(1:1),'0').and.LLE(ctmp(1:1),'9'))) ierr = 1
      if (.not.(LGE(ctmp(2:2),'0').and.LLE(ctmp(2:2),'9'))) ierr = 1
      if (.not.(LGE(ctmp(4:4),'0').and.LLE(ctmp(4:4),'9'))) ierr = 1
      if (.not.(LGE(ctmp(5:5),'0').and.LLE(ctmp(5:5),'9'))) ierr = 1

      if (ierr.eq.0) then
         read(ctmp(1:2),'(I2)') nhour
         read(ctmp(4:5),'(I2)') nmin
         mntr_wtime = 60.0*(nmin +60*nhour)
      else
         call mntr_log(mntr_id,lp_inf,'Wrong wall time format')
      endif

      ! write summary
      call mntr_mod_summary_print()

      mntr_ifinit = .true.

      return
      end subroutine
!=======================================================================
!> @brief Monitor simulation wall clock
!! @ingroup monitor
      subroutine mntr_wclock
      implicit none

      include 'SIZE'
      include 'TSTEP'           ! ISTEP, NSTEPS, LASTEP
      include 'INPUT'           ! IFMVBD, IFREGUO
      include 'PARALLEL'        ! WDSIZE
      include 'CTIMER'          ! ETIMES
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! local variables
      integer il, lstdl
      real rtmp
!-----------------------------------------------------------------------
      ! double delay step as monitoing routine does not know when checkpointing
      ! starts and wall clock can be reached in the middle of writnig process
      lstdl = 2*mntr_stdl+1

      ! check simulation wall time
      if (mntr_wtime.gt.0.0) then

         ! save wall time of the current step
         do il=lstdl,2,-1
            mntr_wtstep(il) = mntr_wtstep(il-1)
         enddo
         mntr_wtstep(1) = dnekclock() - ETIMES
         ! check if simulation is going to exceed wall time, but
         ! first let read all checkpointing files (necessary for multi file
         ! checkpointing)
         if (ISTEP.gt.lstdl) then
            ! it should be enough for the master to check condition
            if (NID.eq.mntr_pid0) rtmp = 2.0*mntr_wtstep(1) -
     $         mntr_wtstep(lstdl)
            ! broadcast predicted time
            il = WDSIZE
            call bcast(rtmp,il)

            if (rtmp.gt.mntr_wtime.and.(NSTEPS-ISTEP).gt.lstdl) then
               call mntr_log(mntr_id,lp_inf,
     $                 'Wall clock reached; adjust NSTEPS')
               NSTEPS = ISTEP+lstdl
            endif
         endif
      endif

      ! check convergence flag
      if (mntr_ifconv.and.(NSTEPS-ISTEP).gt.lstdl) then
         call mntr_log(mntr_id,lp_inf,
     $            'Simulation converged; adjust NSTEPS')
         NSTEPS = ISTEP+lstdl
      endif

      ! just to take into account there is istep and kstep,
      ! and kstep is just a local variable
      if (ISTEP.ge.NSTEPS) LASTEP=1

      return
      end subroutine
!=======================================================================
!> @brief Set number of steps necessary to write proper checkpointing
!! @ingroup monitor
!! @param[in] dstep   step delay
      subroutine mntr_set_step_delay(dstep)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer dstep

!-----------------------------------------------------------------------
      if (dstep.gt.mntr_stdl_max) then
         call mntr_abort(mntr_id,"Step delay exceeds mntr_stdl_max")
      else
         mntr_stdl = max(mntr_stdl,dstep)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Get step delay
!! @ingroup monitor
!! @param[out] dstep   step delay
      subroutine mntr_get_step_delay(dstep)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer dstep
!-----------------------------------------------------------------------
      dstep = mntr_stdl

      return
      end subroutine
!=======================================================================
!> @brief Set convergence flag to shorten simulation
!! @ingroup monitor
      subroutine mntr_set_conv(ifconv)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      logical ifconv

!-----------------------------------------------------------------------
      mntr_ifconv = ifconv

      return
      end subroutine
!=======================================================================
!> @brief Check if module was initialised
!! @ingroup monitor
!! @return mntr_is_initialised
      logical function mntr_is_initialised()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'
!-----------------------------------------------------------------------
      mntr_is_initialised = mntr_ifinit

      return
      end function
!=======================================================================
!> @brief Get logging threashold
!! @ingroup monitor
!! @return mntr_lp_def_get
      integer function mntr_lp_def_get()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'
!-----------------------------------------------------------------------
      mntr_lp_def_get = mntr_lp_def

      return
      end function
!=======================================================================
!> @brief Register new module
!! @ingroup monitor
!! @param[out] mid      current module id
!! @param[in]  pmid     parent module id
!! @param[in]  mname    module name
!! @param[in]  mdscr    module description
      subroutine mntr_mod_reg(mid,pmid,mname,mdscr)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer mid, pmid
      character*(*) mname, mdscr

      ! local variables
      character*10  lname
      character*132 ldscr
      integer slen,slena

      integer il, ipos
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(mname))
      ! remove trailing blanks
      slen = len_trim(mname) - slena + 1
      if (slena.gt.mntr_lstl_mnm) then
         call mntr_log(mntr_id,lp_deb,
     $        'too long module name; shortenning')
         slena = min(slena,mntr_lstl_mnm)
      endif
      call blank(lname,mntr_lstl_mnm)
      lname= mname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! check description length
      slena = len_trim(adjustl(mdscr))
      ! remove trailing blanks
      slen = len_trim(mdscr) - slena + 1
      if (slena.ge.mntr_lstl_mds) then
         call mntr_log(mntr_id,lp_deb,
     $        'too long module description; shortenning')
         slena = min(slena,mntr_lstl_mnm)
      endif
      call blank(ldscr,mntr_lstl_mds)
      ldscr= mdscr(slen:slen + slena - 1)

      ! find empty space
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.mntr_pid0) then

         ! check if module is already registered
         do il=1,mntr_mod_mpos
            if (mntr_mod_id(il).ge.0.and.
     $         mntr_mod_name(il).eq.lname) then
               ipos = -il
               exit
            endif
         enddo

         ! find empty spot
         if (ipos.eq.0) then
            do il=1,mntr_id_max
               if (mntr_mod_id(il).eq.-1) then
                  ipos = il
                  exit
               endif
            enddo
         endif
      endif

      ! broadcast mid
      call bcast(ipos,isize)

      ! error; no free space found
      if (ipos.eq.0) then
         mid = ipos
         call mntr_abort(mntr_id,
     $        'module ['//trim(lname)//'] cannot be registered')
      !  module already registered
      elseif (ipos.lt.0) then
         mid = abs(ipos)
         call mntr_abort(mntr_id,
     $    'Module ['//trim(lname)//'] is already registered')
      ! new module
      else
         mid = ipos
         ! check if parent module is registered
         if (pmid.gt.0) then
            if (mntr_mod_id(pmid).ge.0) then
               mntr_mod_id(ipos) = pmid
            else
               mntr_mod_id(ipos) = 0
               call mntr_log(mntr_id,lp_inf,
     $       "Module's ["//trim(lname)//"] parent not registered.")
            endif
         else
            mntr_mod_id(ipos) = 0
         endif
         mntr_mod_name(ipos)=lname
         mntr_mod_dscr(ipos)=ldscr
         mntr_mod_num = mntr_mod_num + 1
         if (mntr_mod_mpos.lt.ipos) mntr_mod_mpos = ipos
         call mntr_log(mntr_id,lp_inf,
     $       'Registered module ['//trim(lname)//']: '//trim(ldscr))
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if module name is registered and return its id.
!! @ingroup monitor
!! @param[out] mid      module id
!! @param[in]  mname    module name
      subroutine mntr_mod_is_name_reg(mid,mname)
      implicit none

      include 'SIZE'
      include 'PARALLEL'        ! ISIZE
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer mid
      character*(*) mname

      ! local variables
      character*10  lname
      character*3 str
      integer slen,slena

      integer il, ipos
!-----------------------------------------------------------------------
      ! check name length
      slena = len_trim(adjustl(mname))
      ! remove trailing blanks
      slen = len_trim(mname) - slena + 1
      if (slena.gt.mntr_lstl_mnm) then
         call mntr_log(mntr_id,lp_deb,
     $          'too long module name; shortenning')
         slena = min(slena,mntr_lstl_mnm)
      endif
      call blank(lname,mntr_lstl_mnm)
      lname= mname(slen:slen+slena- 1)
      call capit(lname,slena)

      ! find module
      ipos = 0

      ! to ensure consistency I do it on master and broadcast result
      if (nid.eq.mntr_pid0) then
         ! check if module is already registered
         do il=1,mntr_mod_mpos
            if (mntr_mod_id(il).ge.0.and.
     $         mntr_mod_name(il).eq.lname) then
               ipos = il
               exit
            endif
         enddo
      endif

      ! broadcast ipos
      call bcast(ipos,isize)

      if (ipos.eq.0) then
         mid = -1
         call mntr_log(mntr_id,lp_inf,
     $        'Module ['//trim(lname)//'] not registered')
      else
         mid = ipos
         write(str,'(I3)') ipos
         call mntr_log(mntr_id,lp_vrb,
     $        'Module ['//trim(lname)//'] registered with mid='//str)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Check if module id is registered. This operation is performed locally
!! @ingroup monitor
!! @param[in] mid      module id
!! @return mntr_mod_is_id_reg
      logical function mntr_mod_is_id_reg(mid)
      implicit none

      include 'SIZE'
      include 'PARALLEL'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer mid
!-----------------------------------------------------------------------
      mntr_mod_is_id_reg = mntr_mod_id(mid).ge.0

      return
      end function
!=======================================================================
!> @brief Get number of registered modules. This operation is performed locally
!! @ingroup monitor
!! @param[out]    nmod     module number
!! @param[out]    mmod     max module id
      subroutine mntr_mod_get_number(nmod,mmod)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer nmod, mmod
!-----------------------------------------------------------------------
      nmod = mntr_mod_num
      mmod = mntr_mod_mpos

      return
      end subroutine
!=======================================================================
!> @brief Get module name an parent id for given module id. This operation is performed locally
!! @ingroup monitor
!! @param[out]    pmid     parent module id
!! @param[out]    mname    module name
!! @param[inout]  mid      module id
      subroutine mntr_mod_get_info(mname, pmid,mid)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      character*10 mname
      integer mid, pmid

      ! local variables
      character*5 str
!-----------------------------------------------------------------------
      if (mntr_mod_id(mid).ge.0) then
         pmid = mntr_mod_id(mid)
         mname = mntr_mod_name(mid)
      else
         mid = -1
         write(str,'(I3)') mid
         call mntr_log(mntr_id,lp_vrb,
     $        'Module id'//trim(str)//' not registered')
      endif

      return
      end subroutine
!=======================================================================
!> @brief Write log message
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] priority  log priority
!! @param[in] logs      log body
      subroutine mntr_log(mid,priority,logs)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer mid,priority
      character*(*) logs

      ! local variables
      character*200 llogs
      character*5 str
      integer slen, slena
!-----------------------------------------------------------------------
      ! check log priority
      if (priority.lt.mntr_lp_def) return

      ! done only by master
      if (nid.eq.mntr_pid0) then

         ! check description length
         slena = len_trim(adjustl(logs))
         ! remove trailing blanks
         slen = len_trim(logs) - slena + 1
         if (slena.ge.mntr_lstl_log) then
            if (mntr_lp_def.le.lp_deb) write(*,*)' ['//mntr_name//'] ',
     $       'too long log string; shortenning'
            slena = min(slena,mntr_lstl_log)
         endif
         call blank(llogs,mntr_lstl_mds)
         llogs= logs(slen:slen + slena - 1)

         ! check module id
         if (mntr_mod_id(mid).ge.0) then
            ! add module name
            write(*,*) ' ['//trim(mntr_mod_name(mid))//'] '//trim(llogs)
         else
            write(str,'(I3)') mid
            write(*,*) ' ['//trim(mntr_name)//'] ',
     $      ' WARNING: module'//trim(str)//' not registered;'
            write(*,*) 'Log body: '//trim(llogs)
         endif
      endif

      return
      end subroutine
!=======================================================================
!> @brief Write log message from given process
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] priority  log priority
!! @param[in] logs      log body
!! @param[in] prid      process id
      subroutine mntr_log_local(mid,priority,logs,prid)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer mid,priority, prid
      character*(*) logs

      ! local variables
      character*200 llogs
      character*5 str
      integer slen, slena
!-----------------------------------------------------------------------
      ! check log priority
      if (priority.lt.mntr_lp_def) return

      ! done only by given process

      ! check description length
      slena = len_trim(adjustl(logs))
      ! remove trailing blanks
      slen = len_trim(logs) - slena + 1
      if (slena.ge.mntr_lstl_log) then
         if (mntr_lp_def.le.lp_deb) write(*,*)' ['//mntr_name//'] ',
     $       'too long log string; shortenning'
         slena = min(slena,mntr_lstl_log)
      endif
      call blank(llogs,mntr_lstl_mds)
      llogs= logs(slen:slen + slena - 1)

      ! check module id
      if (mntr_mod_id(mid).ge.0) then
      ! add module name
       write(*,*) ' ['//trim(mntr_mod_name(mid))//'] nid= ',prid,
     $      ' '//trim(llogs)
      else
         write(str,'(I3)') mid
         write(*,*) ' ['//trim(mntr_name)//'] ',
     $   ' WARNING: module'//trim(str)//' not registered;'
         write(*,*) 'Log body: nid= ',prid,' '//trim(llogs)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Write log message adding single integer
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] priority  log priority
!! @param[in] logs      log body
!! @param[in] ivar      integer variable
      subroutine mntr_logi(mid,priority,logs,ivar)
      implicit none

      ! argument list
      integer mid,priority,ivar
      character*(*) logs

      ! local variables
      character*10 str
!-----------------------------------------------------------------------
      write(str,'(I8)') ivar
      call mntr_log(mid,priority,trim(logs)//' '//trim(str))

      return
      end subroutine
!=======================================================================
!> @brief Write log message adding single real
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] priority  log priority
!! @param[in] logs      log body
!! @param[in] rvar      real variable
      subroutine mntr_logr(mid,priority,logs,rvar)
      implicit none

      ! argument list
      integer mid,priority
      character*(*) logs
      real rvar

      ! local variables
      character*20 str
!-----------------------------------------------------------------------
      write(str,'(E15.8)') rvar
      call mntr_log(mid,priority,trim(logs)//' '//trim(str))

      return
      end subroutine
!=======================================================================
!> @brief Write log message adding single logical
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] priority  log priority
!! @param[in] logs      log body
!! @param[in] lvar      logical variable
      subroutine mntr_logl(mid,priority,logs,lvar)
      implicit none

      ! argument list
      integer mid,priority
      character*(*) logs
      logical lvar

      ! local variables
      character*2 str
!-----------------------------------------------------------------------
      write(str,'(L2)') lvar
      call mntr_log(mid,priority,trim(logs)//' '//trim(str))

      return
      end subroutine
!=======================================================================
!> @brief Write warning message
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] logs      log body
      subroutine mntr_warn(mid,logs)
      implicit none

      include 'FRAMELP'

      ! argument list
      integer mid,priority
      character*(*) logs
!-----------------------------------------------------------------------
      call mntr_log(mid,lp_inf,'WARNING: '//logs)
      return
      end subroutine
!=======================================================================
!> @brief Write error message
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] logs      log body
      subroutine mntr_error(mid,logs)
      implicit none

      include 'FRAMELP'

      ! argument list
      integer mid
      character*(*) logs
!-----------------------------------------------------------------------
      call mntr_log(mid,lp_err,'ERROR: '//logs)
      return
      end subroutine
!=======================================================================
!> @brief Abort simulation
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] logs      log body
      subroutine mntr_abort(mid,logs)
      implicit none

      include 'FRAMELP'

      ! argument list
      integer mid
      character*(*) logs
!-----------------------------------------------------------------------
      call mntr_log(mid,lp_err,'ABORT: '//logs)
      call exitt
      return
      end subroutine
!=======================================================================
!> @brief Abort simulation
!! @ingroup monitor
!! @param[in] mid       module id
!! @param[in] ierr      error flag
!! @param[in] logs      log body
      subroutine mntr_check_abort(mid,ierr,logs)
      implicit none

      include 'FRAMELP'

      ! argument list
      integer mid,ierr
      character*(*) logs

      ! local variables
      integer imax, imin, itest
      character*5 str
      ! functions
      integer iglmax, iglmin
!-----------------------------------------------------------------------
      imax = iglmax(ierr,1)
      imin = iglmin(ierr,1)
      if (imax.gt.0) then
         itest = imax
      else
         itest = imin
      endif

      if (itest.ne.0) then
         write(str,'(I3)') itest
         call mntr_log(mid,lp_err,
     $         'ABORT: '//trim(logs)//' ierr='//trim(str))
         call exitt
      endif
      return
      end subroutine
!=======================================================================
!> @brief Print registered modules showing tree structure
!! @ingroup monitor
      subroutine mntr_mod_summary_print()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! local variables
      integer il, stride
      parameter (stride=4)
      integer olist(2,mntr_id_max), ierr
      character*25 ftm
      character*3 str
!-----------------------------------------------------------------------
      call mntr_log(mntr_id,lp_prd,
     $         'Summary of registered modules')

      if (nid.eq.mntr_pid0) then
         ! get ordered list
         call mntr_mod_get_olist(olist, ierr)


         if(ierr.eq.0.and.mntr_lp_def.le.lp_prd) then
            do il=1,mntr_mod_num
               write(str,'(I3)') stride*(olist(2,il))
               ftm = '('//trim(str)//'X,"[",A,"] : ",A)'
               write(*,ftm) mntr_mod_name(olist(1,il)),
     $                mntr_mod_dscr(olist(1,il))
            enddo
         endif
      endif

      return
      end subroutine
!=======================================================================
!> @brief Provide ordered list of registered modules for printing.
!! @ingroup monitor
!! @param[out]   olist    ordered list
!! @param[out]   ierr     error flag
      subroutine mntr_mod_get_olist(olist,ierr)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MNTRLOGD'

      ! argument list
      integer olist(2,mntr_id_max), ierr

      ! local variables
      integer ind(mntr_id_max), level, parent, ipos
      integer slist(2,mntr_id_max), itmp1(2)
      integer npos, key
      integer il, jl
      integer istart, in, itest
!-----------------------------------------------------------------------
      ierr = 0

      ! sort module index array
      ! copy data removing possible empty slots
      npos=0
      do il=1,mntr_mod_mpos
         if (mntr_mod_id(il).ge.0) then
            npos = npos + 1
            slist(1,npos) = mntr_mod_id(il)
            slist(2,npos) = il
         endif
      enddo
      if(npos.ne.mntr_mod_num) then
         ierr = 1
         call mntr_log_local(mntr_id,lp_inf,
     $         'Inconsistent module number; return',mntr_pid0)
         return
      endif

      ! sort with respect to parent id
      key = 1
      call ituple_sort(slist,2,npos,key,1,ind,itmp1)

      ! sort within children of single parent with respect to children id
      istart = 1
      itest = slist(1,istart)
      do il=1,npos
         if(itest.ne.slist(1,il).or.il.eq.npos) then
           if (il.eq.npos.and.itest.eq.slist(1,il)) then
              jl = npos + 1
           else
              jl = il
           endif
           in = jl - istart
           if (itest.eq.0.and.in.ne.1) then
              call mntr_log_local(mntr_id,lp_inf,
     $         'Must be single root of the graph; return',mntr_pid0)
              ierr = 2
              return
           endif
           if (in.gt.1) then
              key = 2
              call ituple_sort(slist(1,istart),2,in,key,1,ind,itmp1)
           endif
           if (il.ne.npos) then
              itest = slist(1,il)
              istart = il
           endif
         endif
      enddo

      parent = 0
      level = 0
      ipos = 1
      call mntr_build_ord_list(olist,slist,npos,ipos,parent,level)

      return
      end subroutine
!=======================================================================
!> @brief Build ordered list reflecting graph structure
!! @ingroup monitor
!! @param[out]   olist    ordered list
!! @param[inout] slist    list sorted with respect to parent
!! @param[in]    nlist    lists length
!! @param[inout] npos     position in olist array
!! @param[in]    parent   parent id
!! @param[in]    level    parent level
      recursive subroutine mntr_build_ord_list(olist,slist,nlist,npos,
     $     parent,level)
      implicit none

      ! argument list
      integer nlist, npos, parent, level
      integer olist(2,nlist),slist(2,nlist)

      ! local variables
      integer il
      integer lparent, llevel
!-----------------------------------------------------------------------
      llevel = level + 1
      do il=1, nlist
         if (slist(1,il).eq.parent) then
            slist(1,il) = - parent
            lparent = slist(2,il)
            olist(1,npos) = lparent
            olist(2,npos) = llevel
            npos = npos +1
            call mntr_build_ord_list(olist,slist,nlist,npos,lparent,
     $           llevel)
         endif
      enddo

      return
      end subroutine
!=======================================================================

!> @file mntrlog_block.f
!! @ingroup monitor
!! @brief Block data to initialise common blocks in MNTRLOGD
!! @details Following Nek5000 standard I keep block data in seaprate file.
!! @author Adam Peplinski
!! @date Sep 28, 2017
!=======================================================================
      block data mntr_log_common_init
      include 'MNTRLOGD'

      data mntr_ifinit /.false./
      data mntr_stdl /1/
      data mntr_ifconv /.false./
      data mntr_pid0 /0/
      data mntr_mod_num /0/
      data mntr_mod_mpos /0/
      data mntr_mod_id /mntr_id_max*-1/
      data mntr_mod_name /mntr_id_max*mntr_blname/

      end

!> @file math_tools.f
!! @ingroup math
!! @brief Set of math related tools for KTH modules
!! @author Adam Peplinski
!! @date Jan 31, 2017
!=======================================================================
!> @brief Step function
!! @ingroup math
!! @details Continuous step function:
!!  \f{eqnarray*}{
!!    stepf(x) = \left\{ \begin{array}{ll}
!!  0 &\mbox{ if $x \leq x_{min}$} \\
!!  \left(1+e^{\left((x-1)^{-1} + x^{-1}\right)}\right)^{-1} &\mbox{ if $x \leq x_{max}$} \\
!!  1 &\mbox{ if $x >  x_{max}$}
!!       \end{array} \right.
!!  \f}
!!  with \f$ x_{min} = 0.02\f$ and \f$ x_{max}=0.98\f$
!! @param[in] x       function argument
!! @return mth_stepf
      real function mth_stepf(x)
      implicit none

      ! argument list
      real x

      ! local variables
      real xdmin, xdmax
      parameter (xdmin = 0.001, xdmax = 0.999)
!-----------------------------------------------------------------------
      ! get function vale
      if (x.le.xdmin) then
         mth_stepf = 0.0
      else if (x.le.xdmax) then
         mth_stepf = 1./( 1. + exp(1./(x - 1.) + 1./x) )
      else
         mth_stepf = 1.
      end if

      return
      end function mth_stepf
!=======================================================================
!> @brief Give random distribution depending on position
!! @ingroup math
!! @details The original Nek5000 rundom number generator is implementted
!!  in @ref ran1. This totally ad-hoc random number generator below
!!  could be preferable to the origina one for the simple reason that it
!!  gives the same initial cindition independent of the number of
!!  processors, which is important for code verification.
!! @param[in] ix,iy,iz     GLL point index
!! @param[in] ieg          global element number
!! @param[in] xl           physical point coordinates
!! @param[in] fcoeff       function coefficients
!! @return  random distribution
      real function mth_ran_dst(ix,iy,iz,ieg,xl,fcoeff)
      implicit none

      include 'SIZE'
      include 'INPUT'       ! IF3D

      ! argument list
      integer ix,iy,iz,ieg
      real xl(LDIM)
      real fcoeff(3)
!-----------------------------------------------------------------------
      mth_ran_dst = fcoeff(1)*(ieg+xl(1)*sin(xl(2))) + fcoeff(2)*ix*iy +
     $     fcoeff(3)*ix
      if (IF3D) mth_ran_dst =
     $     fcoeff(1)*(ieg +xl(NDIM)*sin(mth_ran_dst)) +
     $     fcoeff(2)*iz*ix + fcoeff(3)*iz
      mth_ran_dst = 1.e3*sin(mth_ran_dst)
      mth_ran_dst = 1.e3*sin(mth_ran_dst)
      mth_ran_dst = cos(mth_ran_dst)

      return
      end function mth_ran_dst
!=======================================================================
!> @brief Give random number in the defined range
!! @ingroup math
!! @param[in] lower, upper     range for random numer
!! @return  random number in the defined range
      real function mth_ran_rng(lower, upper)
      implicit none

      ! argument list
      real lower, upper

      ! functions
      real mth_zbqlu01
!-----------------------------------------------------------------------
      mth_ran_rng = lower + mth_zbqlu01()*(upper-lower)

      return
      end function mth_ran_rng
!=======================================================================
!> @brief Marsaglia-Zaman random number generator
!! @ingroup math
!! @details Returns a uniform random number between 0 & 1, using
!!   a Marsaglia-Zaman type subtract-with-borrow generator.
!! @remarks Uses double precision, rather than integer, arithmetic 
!!   throughout because MZ's INTEGER constants overflow
!!   32-bit INTEGER storage (which goes from -2^31 to 2^31).
!!   Ideally, we would explicitly truncate all INTEGER 
!!   quantities at each stage to ensure that the DOUBLE
!!   PRECISION representations DO not accumulate approximation
!!   error; however, on some machines the USE of DNINT to
!!   accomplish this is *seriously* slow (run-time increased
!!   by a factor of about 3). This DOUBLE PRECISION version 
!!   has been tested against an INTEGER implementation that
!!   uses long integers (non-standard and, again, slow) -
!!   the output was identical up to the 16th decimal place
!!   after 10^10 calls, so we're probably OK ...
!!   In current implementation we follow Nek5000 compilation
!!   rulles prolonging all reals to doulbe with compiler flaggs.
!! @author Richard Chandler (richard@stats.ucl.ac.uk)
!! @author Paul Northrop (northrop@stats.ox.ac.uk)
!! @return  random number
      real function mth_zbqlu01()
      implicit none

      ! global variables
      real zbqlix(43), br, cr
      common /math_zbql01/ zbqlix, br, cr

      ! local variables
      integer curpos,id22,id43
      save curpos,id22,id43
      data curpos,id22,id43 /1,22,43/
      real xr,b2,binv

!-----------------------------------------------------------------------
      b2 = br
      binv = 1.0/br

      do
         xr = zbqlix(id22) - zbqlix(id43) - cr
         if (xr.lt.0.0) then
            xr = xr + br
            cr = 1.0
         else
            cr = 0.0
         endif
         zbqlix(id43) = xr

         ! Update array pointers. Do explicit check for bounds of each to
         ! avoid expense of modular arithmetic. If one of them is 0
         ! the others won't be   
         curpos = curpos - 1
         id22 = id22 - 1
         id43 = id43 - 1
         if (curpos.eq.0) then
            curpos=43
         elseif (id22.eq.0) then
            id22 = 43
         elseif (id43.eq.0) then
            id43 = 43
         endif

         ! The INTEGER arithmetic there can yield X=0, which can cause 
         ! problems in subsequent routines (e.g. ZBQLEXP). The problem
         ! is simply that X is discrete whereas U is supposed to 
         ! be continuous - hence IF X is 0, go back and generate another
         ! X and RETURN X/B^2 (etc.), which will be uniform on (0,1/B). 
         if (xr.ge.binv) exit
         b2 = b2*br       
      enddo
      
      mth_zbqlu01 = xr/b2
      return
      end function mth_zbqlu01
!=======================================================================
!> @brief Initialise Marsaglia-Zaman random number generator
!! @ingroup math
!! @details To initialise the random number generator - either repeatably
!!    or nonrepeatably. 
!! @param[in] seed     number which generates elements of the array ZBQLIX
      subroutine math_zbqlini(seed)
      implicit none

      ! argiment list
      integer seed

      ! global variables
      real zbqlix(43), br, cr
      common /math_zbql01/ zbqlix, br, cr

      ! local variables
      integer icall
      save    icall
      data    icall  /0/

      integer il

      !  Initialisation data for random number generator.
      !  The values below have themselves been generated using the
      !  NAG generator.      
      real zbq_ini(43),b_ini,c_ini
      data (zbq_ini(il),il=1,43) /8.001441d7,5.5321801d8,
     $   1.69570999d8,2.88589940d8,2.91581871d8,1.03842493d8,
     $   7.9952507d7,3.81202335d8,3.11575334d8,4.02878631d8,
     $   2.49757109d8,1.15192595d8,2.10629619d8,3.99952890d8,
     $   4.12280521d8,1.33873288d8,7.1345525d7,2.23467704d8,
     $   2.82934796d8,9.9756750d7,1.68564303d8,2.86817366d8,
     $   1.14310713d8,3.47045253d8,9.3762426d7 ,1.09670477d8,
     $   3.20029657d8,3.26369301d8,9.441177d6,3.53244738d8,
     $   2.44771580d8,1.59804337d8,2.07319904d8,3.37342907d8,
     $   3.75423178d8,7.0893571d7 ,4.26059785d8,3.95854390d8,
     $   2.0081010d7,5.9250059d7,1.62176640d8,3.20429173d8,
     $   2.63576576d8/
      data b_ini / 4.294967291d9 /
      data c_ini / 0.0d0 /

      real tmpvar1

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      if (icall.gt.0) return
      icall = icall + 1

      br = b_ini
      cr = c_ini
      ! if seed==0 use cpu time as seed
      if (seed.eq.0) then
         tmpvar1 = mod(dnekclock(),br)
      else
         tmpvar1 = mod(real(seed),br)
      endif
      zbqlix(1) = tmpvar1
      do il= 2, 43
         tmpvar1 = zbq_ini(il-1)*3.0269d4
         tmpvar1 = mod(tmpvar1,br)       
         zbqlix(il) = tmpvar1
      enddo
     
      return
      end subroutine math_zbqlini
!=======================================================================
!> @brief Give bounds for loops to extract edge
!! @ingroup math
!! @note All edge related routines used IXCN and ESKIP, but this
!!   caused some problems as these arrays have to be continuosly
!!   updated for different levels in pressure solver, so I add this
!!   routine.
!! @param[out]   istart    lower loop bound
!! @param[out]   istop     upper loop bound
!! @param[out]   iskip     stride
!! @param[in]    iedg      edge number
!! @param[in]    nx,ny,xz  element size
      subroutine math_edgind(istart,istop,iskip,iedg,nx,ny,nz)
      implicit none
      include 'SIZE'
      include 'INPUT'
      include 'TOPOL'

!     argument list
      integer istart,istop,iskip,iedg,nx,ny,nz

!     local variables
      integer ivrt, icx, icy, icz
!-----------------------------------------------------------------------
!     find vertex position
!     start
      ivrt = icedg(1,iedg)
      icx = mod(ivrt +1,2)
      icy = mod((ivrt-1)/2,2)
      icz = (ivrt-1)/4
      istart =  1 + (nx-1)*icx + nx*(ny-1)*icy + nx*ny*(nz-1)*icz

!     stop
      ivrt = icedg(2,iedg)
      icx = mod(ivrt +1,2)
      icy = mod((ivrt-1)/2,2)
      icz = (ivrt-1)/4
      istop =  1 + (nx-1)*icx + nx*(ny-1)*icy + nx*ny*(nz-1)*icz

!     find stride
      if (iedg.le.4) then
         iskip = 1
      elseif (iedg.le.8) then
         iskip = nx
      else
         iskip =nx*nx
      endif

      return
      end subroutine
!=======================================================================
!> @brief Extract element edge
!! @ingroup math
!! @note This routine works on singe element not whole field.
!! @param[out]   vec       vector containg edge values
!! @param[in]    edg       edge number
!! @param[in]    vfld      pointer to singe element in the field
!! @param[in]    nx,ny,xz  element size
      subroutine math_etovec(vec,edg,vfld,nx,ny,nz)
      implicit none

      include 'SIZE'
      include 'TOPOL'

!     argument list
      real vfld(nx*ny*nz)
      integer edg,nx,ny,nz
      real vec(nx)

!     local variables
      integer is, ie, isk, il, jl
!-----------------------------------------------------------------------
!      is  = IXCN(icedg(1,edg))
!      ie  = IXCN(icedg(2,edg))
!      isk = ESKIP(edg,3)
      call math_edgind(is,ie,isk,edg,nx,ny,nz)
      jl = 1
      do il=is,ie,isk
        vec(jl) = vfld(il)
        jl = jl + 1
      enddo

      return
      end subroutine
!=======================================================================
!> @brief 3D rotation of a vector along given axis
!! @ingroup math
!! @param[in]  vo     output vector
!! @param[in]  vi     input vector
!! @param[in]  va     rotation axis
!! @param[in]  an     rotation angle
      subroutine mth_rot3Da(vo,vi,va,an)
      implicit none

      ! parameters
      integer ldim
      parameter (ldim=3)

      ! argument list
      real vo(ldim), vi(ldim), va(ldim), an

      ! local variables
      integer il, jl
      real mat(ldim,ldim), ta(ldim)
      real rtmp, can, can1, san
!-----------------------------------------------------------------------
      if (an.eq.0.0) then
         call copy(vo,vi,ldim)
      else
         ! make sure the axis vector is normalised
         rtmp = 0.0
         do il=1,ldim
            rtmp = rtmp + va(il)**2
         enddo
         ! add check if rtmp.gt.0
         rtmp = 1.0/sqrt(rtmp)
         do il=1,ldim
            ta(il) = rtmp*va(il)
         enddo
         ! fill in rotation mtrix
         can = cos(an)
         can1 = 1.0 - can
         san = sin(an)
         mat(1,1) = can + ta(1)*ta(1)*can1
         mat(2,1) = ta(1)*ta(2)*can1 - ta(3)*san
         mat(1,2) = ta(1)*ta(2)*can1 + ta(3)*san
         mat(3,1) = ta(1)*ta(3)*can1 + ta(2)*san
         mat(1,3) = ta(1)*ta(3)*can1 - ta(2)*san
         mat(2,2) = can + ta(2)*ta(2)*can1
         mat(3,2) = ta(2)*ta(3)*can1 - ta(1)*san
         mat(2,3) = ta(2)*ta(3)*can1 + ta(1)*san
         mat(3,3) = can + ta(3)*ta(3)*can1
         ! perform rotation
         do il = 1, ldim
            vo(il) = 0.0
            do jl=1,ldim
               vo(il) = vo(il) + mat(jl,il)*vi(jl)
            enddo
         enddo
      endif

      return
      end subroutine
!=======================================================================

!> @file io_tools.f
!! @ingroup io_tools
!! @brief Set of I/O related tools for KTH modules
!! @author Adam Peplinski
!! @date Mar 7, 2016
!=======================================================================
!> @brief Register io tool module
!! @ingroup io_tools
!! @note This routine should be called in frame_usr_register
      subroutine io_register()
      implicit none

      include 'FRAMELP'
      include 'IOTOOLD'

      ! local variables
      integer lpmid
!-----------------------------------------------------------------------
      ! check if the current module was already registered
      call mntr_mod_is_name_reg(lpmid,io_name)
      if (lpmid.gt.0) then
         call mntr_warn(lpmid,
     $        'module ['//trim(io_name)//'] already registered')
         return
      endif

      ! find parent module
      call mntr_mod_is_name_reg(lpmid,'FRAME')
      if (lpmid.le.0) then
         lpmid = 1
         call mntr_abort(lpmid,
     $        'Parent module ['//'FRAME'//'] not registered')
      endif

      ! register module
      call mntr_mod_reg(io_id,lpmid,io_name,'I/O TOOLS')

      return
      end subroutine
!=======================================================================
!> @brief Get free file unit number and store max unit value
!! @ingroup io_tools
!! @param[out] iunit     file unit
!! @param[out] ierr      error mark
!! @see io_file_close
      subroutine io_file_freeid(iunit, ierr)
      implicit none

      include 'FRAMELP'
      include 'IOTOOLD'

      ! argument list
      integer iunit
      integer ierr

      ! local variables
      logical ifcnnd            ! is unit connected
!-----------------------------------------------------------------------
      ! initialise variables
      ierr=0
      iunit = io_iunit_min

      do
         inquire(unit=iunit,opened=ifcnnd,iostat=ierr)
         if(ifcnnd) then
            iunit = iunit +1
         else
            exit
         endif
      enddo

      if (iunit.gt.io_iunit_max) io_iunit_max = iunit

      return
      end subroutine
!=======================================================================
!> @brief Close all opened files up to sotred max unit numer
!! @ingroup io_tools
!! @see io_file_freeid
      subroutine io_file_close()
      implicit none

      include 'FRAMELP'
      include 'IOTOOLD'

      ! local variables
      integer iunit, ierr
      logical ifcnnd            ! is unit connected
!-----------------------------------------------------------------------
      do iunit = io_iunit_min, io_iunit_max
         inquire(unit=iunit,opened=ifcnnd,iostat=ierr)
         if(ifcnnd) close(iunit)
      enddo
      io_iunit_max = io_iunit_min

      return
      end subroutine
!=======================================================================
!> @brief Generate file name according to nek rulles without opening the file
!! @details It is a modified version of @ref mfo_open_files from prepost.f but
!! without equivalence and file opening part. I split file name generation
!! and file opening as different tools can require this.
!! @ingroup io_tools
!! @param[out]  fname     file name
!! @param[in]   bname     base name
!! @param[in]   prefix    prefix
!! @param[out]  ierr      error mark
      subroutine io_mfo_fname(fname,bname,prefix,ierr)
      implicit none

      include 'SIZE'
      include 'INPUT'           ! IFREGUO, IFMPIIO
      include 'RESTART'         ! NFILEO
      include 'FRAMELP'
      include 'IOTOOLD'


      ! argument list
      character*132  fname, bname
      character*3 prefix
      integer ierr

      ! local variables
      integer ndigit, itmp
      real rfileo

      character*(*)  six
      parameter(six='??????')
!-----------------------------------------------------------------------
      ! initialise variables
      ierr = 0
      fname = ''

      ! numbe or IO nodes
      if (IFMPIIO) then
        rfileo = 1
      else
        rfileo = NFILEO
      endif
      ndigit = log10(rfileo) + 1

      ! Add directory
      if (ifdiro) fname = 'A'//six(1:ndigit)//'/'

      ! Add prefix
      if (prefix(1:1).ne.' '.and.prefix(2:2).ne.' '
     $    .and.prefix(3:3).ne.' ')
     $     fname = trim(fname)//trim(adjustl(prefix))

      ! Add SESSION
      fname = trim(fname)//trim(adjustl(bname))

      if (IFREGUO) fname = trim(fname)//'_reg'

      ! test string length
      itmp = len_trim(fname)
      if (itmp.eq.0) then
         call mntr_error(io_id,'io_mfo_fname; zero lenght fname.')
         ierr = 1
         return
      elseif ((itmp+ndigit+2+5).gt.132) then
         call mntr_error(io_id,'io_mfo_fname; fname too long.')
         ierr = 2
         return
      endif

      ! Add file-id holder and .f appendix
      fname = trim(fname)//six(1:ndigit)//'.f'

      return
      end subroutine
!=======================================================================
!> @brief Open field file
!! @details This routine opens the file (serial or parallel depending on
!!    parmeter set by @ref io_init) using Nek5000 C routines. I need it
!!    for a number of tools writing restart files that do not directly
!!    stick to the numbering scheme used in @ref mfo_open_files.
!! @ingroup io_tools
!! @param[in]   hname      file name
!! @param[out]  ierr       error mark
      subroutine io_mbyte_open(hname,ierr)
      implicit none

      include 'SIZE'            ! NID
      include 'INPUT'           ! ifmpiio
      include 'RESTART'         ! fid0, pid0, ifh_mbyte
      include 'FRAMELP'
      include 'IOTOOLD'

      ! argumnt list
      integer fid, ierr
      character*132 hname

      ! local variables
      character*132 fname
      integer itmp
!-----------------------------------------------------------------------
      ! initialise variables
      ierr = 0
      ! work on local copy
      fname = trim(adjustl(hname))

      ! test string length
      itmp = len_trim(fname)
      if (itmp.eq.0) then
         call mntr_error(io_id,'io_mbyte_open; zero lenght fname.')
         ierr = 1
         return
      endif

      ! add file number
      call addfid(fname,fid0)

      call mntr_log(io_id,lp_ess,'Opening file: '//trim(fname))
      if(ifmpiio) then
        call byte_open_mpi(fname,ifh_mbyte,.false.,ierr)
      else
        ! add ending character; required by C
        fname = trim(fname)//CHAR(0)
        call byte_open(fname,ierr)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Close field file
!! @details This routine closes the file (serial or parallel depending on
!!    parmeter set by @ref io_init) using Nek5000 C routines.
!! @ingroup io_tools
!! @param[out]  ierr       error mark
      subroutine io_mbyte_close(ierr)
      implicit none

      include 'SIZE'            ! NID
      include 'INPUT'           ! ifmpiio
      include 'RESTART'         ! pid0, ifh_mbyte

      ! argumnt list
      integer ierr

      ! local variables
      character*132 fname
      integer itmp
!-----------------------------------------------------------------------
      ! initialise variables
      ierr = 0

      ! close the file
      if (nid.eq.pid0) then
         if(ifmpiio) then
           call byte_close_mpi(ifh_mbyte,ierr)
         else
           call byte_close(ierr)
         endif
      endif

      return
      end subroutine
!=======================================================================
!> @brief Write single vector to the file
!! @details This routine is based on @ref mfo_outfld but can be used for
!!    writing 2D sections of 3D simulation.
!! @ingroup io_tools
!! @param[inout] offs               offset of global vector beginning
!! @param[in]    lvx,lvy,lvz        vector to write
!! @param[in]    lnx,lny,lnz        element dimensions
!! @param[in]    lnel               local number of filed elements
!! @param[in]    lnelg              global number of filed elements
!! @param[in]    lndim              written domain dimension
!! @remark This routine uses global scratch space \a SCRUZ.
      subroutine io_mfov(offs,lvx,lvy,lvz,lnx,lny,lnz,
     $           lnel,lnelg,lndim)
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'RESTART'
      include 'FRAMELP'
      include 'IOTOOLD'

      ! argumnt list
      integer*8 offs
      integer lnx,lny,lnz,lnel,lnelg,lndim
      real lvx(lnx,lny,lnz,lnel), lvy(lnx,lny,lnz,lnel),
     $     lvz(lnx,lny,lnz,lnel)

      ! local variables
      integer*8 loffs
      integer il, ik, itmp

      real rvx(lxo*lxo*(1 + (ldim-2)*(lxo-1))*lelt),
     $     rvy(lxo*lxo*(1 + (ldim-2)*(lxo-1))*lelt),
     $     rvz(lxo*lxo*(1 + (ldim-2)*(lxo-1))*lelt)
      common /SCRUZ/ rvx, rvy, rvz
!-----------------------------------------------------------------------
      if (ifreguo) then
         ! check size of mapping space
         if (nrg.gt.lxo) then
            call mntr_warn(io_id,
     $          'io_mfov; nrg too large, reset to lxo!')
            nrg = lxo
         endif

         ! map to regular mesh
         ! this code works with square element only
         itmp = nrg**lndim
         if (lndim.eq.2) then
            ik=1
            do il=1,lnel
               call map2reg_2di_e(rvx(ik),nrg,lvx(1,1,1,il),lnx)
               ik = ik + itmp
            enddo
            ik=1
            do il=1,lnel
               call map2reg_2di_e(rvy(ik),nrg,lvy(1,1,1,il),lnx)
               ik = ik + itmp
            enddo
         else
            ik = 1
            do il=1,lnel
               call map2reg_3di_e(rvx(ik),nrg,lvx(1,1,1,il),lnx)
               ik = ik + itmp
            enddo
            ik = 1
            do il=1,lnel
               call map2reg_3di_e(rvy(ik),nrg,lvy(1,1,1,il),lnx)
               ik = ik + itmp
            enddo
            ik = 1
            do il=1,lnel
               call map2reg_3di_e(rvz(ik),nrg,lvz(1,1,1,il),lnx)
               ik = ik + itmp
            enddo
         endif

         ! shift offset taking onto account elements on processes with smaller id
         itmp = 1 + (lndim-2)*(nrg-1)
         ! to ensure proper integer prolongation
         loffs = offs + int(nelB,8)*int(lndim*wdsizo*nrg*nrg*itmp,8)
         call byte_set_view(loffs,ifh_mbyte)

         ! write vector
         call mfo_outv(rvx,rvy,rvz,lnel,nrg,nrg,itmp)

         ! update offset
         offs = offs + int(lnelg,8)*int(lndim*wdsizo*nrg*nrg*itmp,8)
      else
         ! shift offset taking onto account elements on processes with smaller id
         ! to ensure proper integer prolongation
         loffs = offs + int(nelB,8)*int(lndim*wdsizo*lnx*lny*lnz,8)
         call byte_set_view(loffs,ifh_mbyte)

         ! write vector
         call mfo_outv(lvx,lvy,lvz,lnel,lnx,lny,lnz)

         ! update offset
         offs = offs + int(lnelg,8)*int(lndim*wdsizo*lnx*lny*lnz,8)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Write single scalar to the file
!! @details This routine is based on @ref mfo_outfld but can be used for
!!    writing 2D sections of 3D simulation.
!! @ingroup io_tools
!! @param[inout] offs               offset of global vector beginning
!! @param[in]    lvs                scalar to write
!! @param[in]    lnx,lny,lnz        element dimensions
!! @param[in]    lnel               local number of field elements
!! @param[in]    lnelg              global number of filed elements
!! @param[in]    lndim              written domain dimension
!! @remark This routine uses global scratch space \a SCRUZ.
      subroutine io_mfos(offs,lvs,lnx,lny,lnz,lnel,lnelg,lndim)
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'RESTART'
      include 'FRAMELP'
      include 'IOTOOLD'

      ! argumnt list
      integer*8 offs
      integer lnx,lny,lnz,lnel,lnelg,lndim
      real lvs(lnx,lny,lnz,lnel)

      ! local variables
      integer*8 loffs
      integer il, ik, itmp

      real rvs(lxo*lxo*(1 + (ldim-2)*(lxo-1))*lelt)
      common /SCRUZ/ rvs
!-----------------------------------------------------------------------
      if (ifreguo) then
         ! check size of mapping space
         if (nrg.gt.lxo) then
            call mntr_warn(io_id,
     $          'io_mfos; nrg too large, reset to lxo!')
            nrg = lxo
         endif

         ! map to regular mesh
         ! this code works with square element only
         itmp = nrg**lndim
         if (lndim.eq.2) then
            ik=1
            do il=1,lnel
               call map2reg_2di_e(rvs(ik),nrg,lvs(1,1,1,il),lnx)
               ik = ik + itmp
            enddo
         else
            ik = 1
            do il=1,lnel
               call map2reg_3di_e(rvs(ik),nrg,lvs(1,1,1,il),lnx)
               ik = ik + itmp
            enddo
         endif

         ! shift offset taking onto account elements on processes with smaller id
         itmp = 1 + (lndim-2)*(nrg-1)
         ! to ensure proper integer prolongation
         loffs = offs + int(nelB,8)*int(wdsizo*nrg*nrg*itmp,8)
         call byte_set_view(loffs,ifh_mbyte)

         ! write vector
         call mfo_outs(rvs,lnel,nrg,nrg,itmp)

         ! update offset
         offs = offs + int(lnelg,8)*int(wdsizo*nrg*nrg*itmp,8)
      else
         ! shift offset taking onto account elements on processes with smaller id
         ! to ensure proper integer prolongation
         loffs = offs + int(nelB,8)*int(wdsizo*lnx*lny*lnz,8)
         call byte_set_view(loffs,ifh_mbyte)

         ! write vector
         call mfo_outs(lvs,lnel,lnx,lny,lnz)

         ! update offset
         offs = offs + int(lnelg,8)*int(wdsizo*lnx*lny*lnz,8)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Read vector filed from the file
!! @details This is version of @ref mfi_getv that does not perform
!!    interpolation and allows to specify element size.
!! @param[inout] offs         offset of global vector beginning
!! @param[out]   uf, vf, wf   vector field compinents
!! @param[in]    lnx,lny,lnz  element size
!! @param[in]    lnel         number of elements
!! @param[in]    ifskip       reading flag (for non-mpi formats)
!! @remarks This routine uses global scratch space \a VRTHOV and \a SCRNS
      subroutine io_mfiv(offs,uf,vf,wf,lnx,lny,lnz,lnel,ifskip)
      implicit none
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'
      include 'FRAMELP'
      include 'IOTOOLD'

      ! argument list
      integer*8 offs
      integer lnx,lny,lnz,lnel
      real uf(lnx*lny*lnz,lnel),vf(lnx*lny*lnz,lnel),
     $     wf(lnx*lny*lnz,lnel)
      logical ifskip

      ! local variables
      integer lndim, nxyzr, nxyzw, nxyzv, mlen
      integer num_recv, num_avail, nread, nelrr
      integer el, il, kl, ll, ierr
      integer ei, eg, jnid, jeln
      integer msg_id(lelt)
      integer*8 i8tmp

      ! read buffer
      integer lrbs
      parameter(lrbs=20*lx1*ly1*lz1*lelt)
      real*4 w2(lrbs)
      common /vrthov/ w2

      ! communication buffer
      integer lwk
      parameter (lwk = 14*lx1*ly1*lz1*lelt)
      real*4 wk(lwk)
      common /SCRNS/ wk

      ! functions
      integer irecv, iglmax
!-----------------------------------------------------------------------
      call nekgsync() ! clear outstanding message queues.

      ! check element size
      if ((nxr.ne.lnx).or.(nyr.ne.lny).or.(nzr.ne.lnz)) then
         call mntr_abort(io_id,'io_mfiv, wrong element size')
      endif

      if (lnz.gt.1) then
         lndim = 3
      else
         lndim = 2
      endif

      nxyzr  = lndim*lnx*lny*lnz   ! element size
      mlen   = nxyzr*wdsizr  ! message length
      if (wdsizr.eq.8) then
         nxyzw = 2*nxyzr
      else
         nxyzw = nxyzr
      endif

      ! shift offset
      i8tmp = offs + int(nelBr,8)*int(mlen,8)
      call byte_set_view(i8tmp,ifh_mbyte)

      ! check message buffer
      num_recv  = mlen
      num_avail = lwk*4
      call lim_chk(num_recv,num_avail,'     ','     ','io_mfiv a')

      ! setup read buffer
      if (nid.eq.pid0r) then
         i8tmp = int(nxyzw,8)*int(nelr,8)
         nread = i8tmp/int(lrbs,8)
         if (mod(i8tmp,int(lrbs,8)).ne.0) nread = nread + 1
         if(ifmpiio) nread = iglmax(nread,1) ! needed because of collective read
         nelrr = nelr/nread
      endif
      call bcast(nelrr,4)
      call lim_chk(nxyzw*nelrr,lrbs,'     ','     ','io_mfiv b')

      ! reset error flag
      ierr = 0

      if (ifskip) then ! just read deata and do not use it (avoid communication)

         if (nid.eq.pid0r) then ! only i/o nodes will read
            ! read blocks of size nelrr
            kl = 0
            do il = 1,nread
               if (il.eq.nread) then ! clean-up
                  nelrr = nelr - (nread-1)*nelrr
                  if (nelrr.lt.0) nelrr = 0
               endif

               if (ierr.eq.0) then
                  if (ifmpiio) then
                    call byte_read_mpi(w2,nxyzw*nelrr,-1,ifh_mbyte,ierr)
                  else
                    call byte_read (w2,nxyzw*nelrr,ierr)
                  endif
               endif
            enddo
         endif

         call nekgsync()

      else   ! read and use data
         ! pre-post recieves
         if (np.gt.1) then
            ll = 1
            do el=1,nelt
               msg_id(el) = irecv(el,wk(ll),mlen)
               ll = ll+nxyzw
            enddo
         endif

         if (nid.eq.pid0r.and.np.gt.1) then ! only i/o nodes will read
            ! read blocks of size nelrr
            kl = 0
            do il = 1,nread
               if (il.eq.nread) then ! clean-up
                  nelrr = nelr - (nread-1)*nelrr
                  if (nelrr.lt.0) nelrr = 0
               endif

               if (ierr.eq.0) then
                  if (ifmpiio) then
                    call byte_read_mpi(w2,nxyzw*nelrr,-1,ifh_mbyte,ierr)
                  else
                    call byte_read (w2,nxyzw*nelrr,ierr)
                  endif
               endif

               ! distribute data across target processors
               ll = 1
               do el = kl+1,kl+nelrr
                  jnid = gllnid(er(el))                ! where is er(e) now?
                  jeln = gllel(er(el))
                  if(ierr.ne.0) call rzero(w2(ll),mlen)
                  call csend(jeln,w2(ll),mlen,jnid,0)  ! blocking send
                  ll = ll+nxyzw
               enddo
               kl = kl + nelrr
            enddo
         elseif (np.eq.1) then
            if (ifmpiio) then
               call byte_read_mpi(wk,nxyzw*nelr,-1,ifh_mbyte,ierr)
            else
               call byte_read(wk,nxyzw*nelr,ierr)
            endif
         endif

         ! distinguish between vector lengths
         nxyzv = lnx*lny*lnz
         if (wdsizr.eq.8) then
            nxyzw = 2*nxyzv
         else
            nxyzw = nxyzv
         endif

         ll = 1
         do el=1,nelt
            if (np.gt.1) then
               call msgwait(msg_id(el))
               ei = el
            elseif(np.eq.1) then
              ei = er(el)
            endif
            if (if_byte_sw) then
               if (wdsizr.eq.8) then
                  call byte_reverse8(wk(ll),nxyzr*2,ierr)
               else
                  call byte_reverse(wk(ll),nxyzr,ierr)
               endif
            endif
            ! copy data
            if (wdsizr.eq.4) then
               call copy4r(uf(1,ei),wk(ll),nxyzv)
               call copy4r(vf(1,ei),wk(ll + nxyzw),nxyzv)
               if (lndim.eq.3)
     $             call copy4r(wf(1,ei),wk(ll + 2*nxyzw),nxyzv)
            else
               call copy(uf(1,ei),wk(ll),nxyzv)
               call copy(vf(1,ei),wk(ll + nxyzw),nxyzv)
               if (lndim.eq.3)
     $             call copy(wf(1,ei),wk(ll + 2*nxyzw),nxyzv)
            endif
            ll = ll+ldim*nxyzw
         enddo

      endif

      ! update offset
      offs = offs + int(nelgr,8)*int(mlen,8)

      call err_chk(ierr,'Error reading restart data,in io_mfiv.$')
      return
      end subroutine
!=======================================================================
!> @brief Read scalar filed from the file
!! @details This is version of @ref mfi_gets that does not perform
!!    interpolation and allows to specify element size.
!! @ingroup io_tools
!! @param[inout] offs         offset of global vector beginning
!! @param[out]   uf           scalar field
!! @param[in]    lnx,lny,lnz  element size
!! @param[in]    lnel         number of elements
!! @param[in]    ifskip       reading flag (for non-mpi formats)
!! @remarks This routine uses global scratch space \a VRTHOV and \a SCRNS
      subroutine io_mfis(offs,uf,lnx,lny,lnz,lnel,ifskip)
      implicit none
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'
      include 'FRAMELP'
      include 'IOTOOLD'

      ! argument list
      integer*8 offs
      integer lnx,lny,lnz,lnel
      real uf(lnx*lny*lnz,lnel)
      logical ifskip

      ! local variables
      integer nxyzr, nxyzw, mlen
      integer num_recv, num_avail, nread, nelrr
      integer el, il, kl, ll, ierr
      integer ei, eg, jnid, jeln
      integer msg_id(lelt)
      integer*8 i8tmp

      ! read buffer
      integer lrbs
      parameter(lrbs=20*lx1*ly1*lz1*lelt)
      real*4 w2(lrbs)
      common /vrthov/ w2

      ! communication buffer
      integer lwk
      parameter (lwk = 14*lx1*ly1*lz1*lelt)
      real*4 wk(lwk)
      common /SCRNS/ wk

      ! functions
      integer irecv, iglmax
!-----------------------------------------------------------------------
      call nekgsync() ! clear outstanding message queues.

      ! check element size
      if ((nxr.ne.lnx).or.(nyr.ne.lny).or.(nzr.ne.lnz)) then
         call mntr_abort(io_id,'io_mfis, wrong element size')
      endif

      nxyzr  = lnx*lny*lnz   ! element size
      mlen   = nxyzr*wdsizr  ! message length
      if (wdsizr.eq.8) then
         nxyzw = 2*nxyzr
      else
         nxyzw = nxyzr
      endif

      ! shift offset
      i8tmp = offs + int(nelBr,8)*int(mlen,8)
      call byte_set_view(i8tmp,ifh_mbyte)

      ! check message buffer
      num_recv  = mlen
      num_avail = lwk*4
      call lim_chk(num_recv,num_avail,'     ','     ','io_mfis a')

      ! setup read buffer
      if (nid.eq.pid0r) then
         i8tmp = int(nxyzw,8)*int(nelr,8)
         nread = i8tmp/int(lrbs,8)
         if (mod(i8tmp,int(lrbs,8)).ne.0) nread = nread + 1
         if(ifmpiio) nread = iglmax(nread,1) ! needed because of collective read
         nelrr = nelr/nread
      endif
      call bcast(nelrr,4)
      call lim_chk(nxyzw*nelrr,lrbs,'     ','     ','io_mfis b')

      ! reset error flag
      ierr = 0

      if (ifskip) then ! just read deata and do not use it (avoid communication)

         if (nid.eq.pid0r) then ! only i/o nodes will read
            ! read blocks of size nelrr
            kl = 0
            do il = 1,nread
               if (il.eq.nread) then ! clean-up
                  nelrr = nelr - (nread-1)*nelrr
                  if (nelrr.lt.0) nelrr = 0
               endif

               if (ierr.eq.0) then
                  if (ifmpiio) then
                    call byte_read_mpi(w2,nxyzw*nelrr,-1,ifh_mbyte,ierr)
                  else
                    call byte_read (w2,nxyzw*nelrr,ierr)
                  endif
               endif
            enddo
         endif

         call nekgsync()

      else   ! read and use data
         ! pre-post recieves
         if (np.gt.1) then
            ll = 1
            do el=1,nelt
               msg_id(el) = irecv(el,wk(ll),mlen)
               ll = ll+nxyzw
            enddo
         endif

         if (nid.eq.pid0r.and.np.gt.1) then ! only i/o nodes will read
            ! read blocks of size nelrr
            kl = 0
            do il = 1,nread
               if (il.eq.nread) then ! clean-up
                  nelrr = nelr - (nread-1)*nelrr
                  if (nelrr.lt.0) nelrr = 0
               endif

               if (ierr.eq.0) then
                  if (ifmpiio) then
                    call byte_read_mpi(w2,nxyzw*nelrr,-1,ifh_mbyte,ierr)
                  else
                    call byte_read (w2,nxyzw*nelrr,ierr)
                  endif
               endif

               ! distribute data across target processors
               ll = 1
               do el = kl+1,kl+nelrr
                  jnid = gllnid(er(el))                ! where is er(e) now?
                  jeln = gllel(er(el))
                  if(ierr.ne.0) call rzero(w2(ll),mlen)
                  call csend(jeln,w2(ll),mlen,jnid,0)  ! blocking send
                  ll = ll+nxyzw
               enddo
               kl = kl + nelrr
            enddo
         elseif (np.eq.1) then
            if (ifmpiio) then
               call byte_read_mpi(wk,nxyzw*nelr,-1,ifh_mbyte,ierr)
            else
               call byte_read(wk,nxyzw*nelr,ierr)
            endif
         endif

         ll = 1
         do el=1,nelt
            if (np.gt.1) then
               call msgwait(msg_id(el))
               ei = el
            elseif(np.eq.1) then
               ei = er(el)
            endif
            if (if_byte_sw) then
               if (wdsizr.eq.8) then
                  call byte_reverse8(wk(ll),nxyzw,ierr)
               else
                  call byte_reverse(wk(ll),nxyzw,ierr)
               endif
            endif
            ! copy data
            if (wdsizr.eq.4) then
               call copy4r(uf(1,ei),wk(ll),nxyzr)
            else
               call copy  (uf(1,ei),wk(ll),nxyzr)
            endif
            ll = ll+nxyzw
         enddo

      endif

      ! update offset
      offs = offs + int(nelgr,8)*int(mlen,8)

      call err_chk(ierr,'Error reading restart data,in io_mfis.$')
      return
      end subroutine
!=======================================================================

!> @file rprm_block.f
!! @ingroup runparam
!! @brief Block data to initialise common block for runtime parameter module
!! @details Following Nek5000 standard I keep block data in seaprate file.
!! @author Adam Peplinski
!! @date Sep 28, 2017
!=======================================================================
      block data rprm_common_init
      include 'RPRMD'

      data rprm_ifinit /.false./
      data rprm_pid0 /0/
      data rprm_sec_num /0/
      data rprm_sec_mpos /0/
      data rprm_sec_id /rprm_sec_id_max*-1/
      data rprm_sec_act /rprm_sec_id_max*.false./
      data rprm_sec_name /rprm_sec_id_max*rprm_blname/
      data rprm_par_num /0/
      data rprm_par_mpos /0/
      data rprm_par_id /rprm_par_id_size*-1/
      data rprm_par_name /rprm_par_id_max*rprm_blname/
      data rprm_parv_int /rprm_par_id_max*0/
      data rprm_parv_real /rprm_par_id_max*0.0/
      data rprm_parv_log /rprm_par_id_max*.false./
      data rprm_parv_str /rprm_par_id_max*rprm_blname/

      end

!-----------------------------------------------------------------------
      subroutine uservp (ix,iy,iz,ieg)
      include 'SIZE'
      include 'NEKUSE'
      include 'INPUT'
      include 'TSTEP'

      udiff = 0.
      utrans = 0.

      return
      end
!-----------------------------------------------------------------------
      subroutine userf  (ix,iy,iz,ieg)
      include 'SIZE'
      include 'NEKUSE'
      include 'PARALLEL'
      include 'SOLN'
      include 'INPUT'
      include 'SFDD'

      integer ix, iy, iz, ieg, iel
      real rtmp, Pr_, enable_sfd

      Pr_ = abs(UPARAM(1))
      enable_sfd = abs(UPARAM(7))

      ! local element number
      iel = GLLEL(ieg)

      FFX = 0
      FFY = 0
      FFZ = 0
      ! forcing, put boussinesq
      if (IFPERT) then
         ip = ix + NX1*(iy-1+NY1*(iz-1+NZ1*(iel-1)))
         rtmp = TP(ip,1,1)*Pr_
      else
         rtmp = T(ix,iy,iz,iel,1)*Pr_
      endif

      FFX = 0
      FFY = rtmp
      if (IF3D) FFZ = 0
      if (enable_sfd.ne.0.0) then
         call sfd_forcing(FFX,FFY,FFZ,ix,iy,iz,ieg)
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine userq  (ix,iy,iz,ieg)
      include 'SIZE'
      include 'TOTAL'
      include 'NEKUSE'

      qvol   = 0.
      source = 0.

      return
      end
!-----------------------------------------------------------------------
      subroutine userchk

      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      include 'SOLN'
      include 'CHKPOINTD'  ! chpt_ifrst

      integer nxyz1, nxyz2, nit_pert, nit_hist

      real vtmp(lx1*ly1*lz1*lelt,ldim),ttmp(lx1*ly1*lz1*lelt) ! temporary variables
      real ptmp(lx2*ly2*lz2*lelt), enable_sfd

      nit_hist = abs(UPARAM(10))
      nit_pert = abs(UPARAM(9))
      enable_sfd = UPARAM(7)

      if (ISTEP.eq.0) then
         if (IFPERT) then
            TIME = 0
         endif   
      ! start framework
         call frame_start
      endif

      ! monitor simulation
      call frame_monitor
      call chkpt_main
      if (enable_sfd.ne.0.0) then
         call sfd_main
      endif

      ! finalise framework
      if (istep.eq.nsteps.or.lastep.eq.1) then
         call frame_end
      else if (istep .eq. 0 .and. (.not. chpt_ifrst) ) then
      ! first timestep which is not restarted
         call outpost(vx, vy, vz, pr, t, '   ')  ! write initial condition
      endif

      ! perturbation field
      if (IFPERT) then
         if (mod(ISTEP,nit_pert).eq.0) then
      ! write perturbation field
             call out_pert()
         endif
      endif

      ! history points

      ! we have two formulations for pressure solver
      nxyz1 = nx1*ny1*nz1 ! velocity
      nxyz2 = nx2*ny2*nz2 ! pressure

      if (lhis.gt.1) then
         if (mod(ISTEP,nit_hist).eq.0) then
            if (.not. ifpert) then
               call hpts()
            else
               ! save base state in temporary variables
               call opcopy(vtmp(1,1),vtmp(1,2),vtmp(1,ndim),vx,vy,vz)
               call copy(ttmp,T,nxyz1*NELV)
               call copy(ptmp,PR,nxyz2*NELV)

               call opcopy(vx, vy, vz, vxp, vyp, vzp)
               call copy(T,TP,nxyz1*NELV)
               call copy(PR,PRP,nxyz2*NELV)

               call hpts()
               ! restore base state
               call opcopy(vx,vy,vz, vtmp(1,1),vtmp(1,2),vtmp(1,ndim))
               call copy(T,ttmp,nxyz1*NELV)
               call copy(PR,ptmp,nxyz2*NELV)

            endif
         endif
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine userbc (ix,iy,iz,iside,ieg)
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'SOLN'
      include 'NEKUSE'

      real delta_T_side, delta_T_vert
      real xmax, ymax, dTs, dTv

      delta_T_side = abs(UPARAM(5))
      delta_T_vert = abs(UPARAM(6))

      xmax = u_oper_lx
      ymax = u_oper_ly
      if (if3d) then
            zmax = u_oper_lz
      endif

      dTs = delta_T_side/2.
      dTv = delta_T_vert/2.

      ! base flow
      if (JP.eq.0) then

         ux = 0.
         uy = 0.
         uz = 0.

         if (delta_T_side.ne.0.and.delta_T_vert.eq.0) then
            temp = delta_T_side * (x/xmax - 0.5)
         elseif (delta_T_vert.ne.0.and.delta_T_side.eq.0) then
            temp = delta_T_vert * (0.5- y/ymax)
         elseif (delta_T_side.ne.0.and.delta_T_vert.ne.0) then
            if (x.eq.0) then
               temp = -dTs
            elseif (x.eq.xmax) then
               temp = dTs
            elseif(y.eq.0) then
               temp = dTv
            elseif (y.eq.ymax) then
               temp = -dTv
            elseif (x.eq.0.and.y.eq.0) then
               temp = (dTv-dTs)/2.
            elseif (x.eq.0.and.y.eq.ymax) then
               temp = (-dTv-dTs)/2.
            elseif (x.eq.xmax.and.y.eq.0) then
               temp = (dTs+dTv)/2.
            elseif (x.eq.xmax.and.y.eq.ymax) then
               temp = (dTs-dTv)/2.
            endif
         endif

      ! perturbation
      else

         ux = 0.
         uy = 0.
         uz = 0.
         temp = 0.
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine useric (ix,iy,iz,ieg)
      include 'SIZE'
      include 'NEKUSE'
      include 'SOLN'
      include 'GEOM'
      include 'INPUT'

      real delta_T_side, delta_T_vert, amplitude
      real xmax, ymax, ran

      delta_T_side = abs(UPARAM(5))
      delta_T_vert = abs(UPARAM(6))
      amplitude = 1e-5

      xmax = u_oper_lx
      ymax = u_oper_ly
      if (if3d) then
            zmax = u_oper_lz
      endif

      ! base flow
      if (JP.eq.0) then

         ux = 0.0
         uy = 0.0
         uz = 0.0

         call random_number(temp)
         temp = amplitude * temp

         if (delta_T_vert.ne.0.and.delta_T_side.eq.0) then
            if (IFPERT) then
               temp = delta_T_vert * (0.5- y/ymax)
            else
               temp = delta_T_vert * (0.5- y/ymax) + temp
            endif
         elseif (delta_T_side.ne.0.and.delta_T_vert.eq.0) then
                temp = delta_T_side * (x/xmax - 0.5) + temp
         endif

      ! perturbation
      else

         ux = 0.0
         uy = 0.0
         uz = 0.0

         call random_number(temp)
         temp = amplitude * temp
         endif

      return
      end
!-----------------------------------------------------------------------
! This routine to modify element vertices
      subroutine usrdat
      include 'SIZE'

      return
      end
!-----------------------------------------------------------------------
      subroutine usrdat2
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'SOLN'

      integer i, ntot
      real stretch_x, stretch_y, stretch_z, xx, yy, zz, twopi
      real xmax, ymax, zmax

      stretch_y = abs(UPARAM(4))

      if (stretch_y.ne.0.0) then
         ntot = nx1*ny1*nz1*nelt

         xmax = glmax(xm1,ntot)
         ymax = glmax(ym1,ntot)
         if (if3d) then
             zmax = glmax(zm1,ntot)
         endif

         twopi = 8 * atan(1.)

      ! stretch factors
         stretch_x = stretch_y*xmax
         if (if3d) then
             stretch_z = stretch_y*zmax
         endif

         do i=1,ntot
             xx = xm1(i,1,1,1)
             yy = ym1(i,1,1,1)
             xm1(i,1,1,1) = xx - (stretch_x * (sin(twopi*xx/xmax)))
             ym1(i,1,1,1) = yy - (stretch_y * (sin(twopi*yy/ymax)))

             if (if3d) then
                 zz = zm1(i,1,1,1)
                 zm1(i,1,1,1) = zz - (stretch_z * (sin(twopi*zz/zmax)))
             endif
         enddo
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine usrdat3

      return
      end
!-----------------------------------------------------------------------
      subroutine frame_usr_register
      implicit none
      include 'SIZE'
      include 'FRAMELP'
      include 'INPUT'

      real enable_sfd

      enable_sfd = abs(UPARAM(7))

      ! register modules
      call io_register
      call chkpt_register
      if (enable_sfd.ne.0.0) then
         call sfd_register
      endif

      return
      end subroutine
!-----------------------------------------------------------------------
      subroutine frame_usr_init
      implicit none
      include 'SIZE'
      include 'FRAMELP'
      include 'INPUT'

      real enable_sfd

      enable_sfd = abs(UPARAM(7))

      ! initialise modules
      call chkpt_init
      if (enable_sfd.ne.0.0) then
         call sfd_init
      endif

      return
      end subroutine
!-----------------------------------------------------------------------
      subroutine frame_usr_end
      implicit none
      include 'SIZE'
      include 'FRAMELP'
      include 'INPUT'

      real enable_sfd

      enable_sfd = abs(UPARAM(7))

      if (enable_sfd.ne.0.0) then
         call sfd_end
      endif

      return
      end subroutine

!> @file stat.f
!! @ingroup stat
!! @brief 2D and 3D statistics module
!! @details 
!! @note This code works for extruded meshes only
!! @author Prabal Negi, Adam Peplinski
!! @date Aug 15, 2018
!=======================================================================
!> @brief Register 2D and 3D statistics module
!! @ingroup stat
!! @note This routine should be called in frame_usr_register
      subroutine stat_register()
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'FRAMELP'
      include 'STATD'

      ! local variables
      integer lpmid, il
      real ltim
      character*2 str

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      ! timing
      ltim = dnekclock()

      ! check if the current module was already registered
      call mntr_mod_is_name_reg(lpmid,stat_name)
      if (lpmid.gt.0) then
         call mntr_warn(lpmid,
     $        'module ['//trim(stat_name)//'] already registered')
         return
      endif
      
      ! find parent module
      call mntr_mod_is_name_reg(lpmid,'FRAME')
      if (lpmid.le.0) then
         lpmid = 1
         call mntr_abort(lpmid,
     $        'parent module ['//'FRAME'//'] not registered')
      endif
      
      ! register module
      call mntr_mod_reg(stat_id,lpmid,stat_name,
     $      '2D and 3D statistics')

      ! check if 2D mapping module is registered
      if (stat_rdim.eq.1) then
         call mntr_mod_is_name_reg(lpmid,'MAP2D')
         ! if not, register module
         if (lpmid.le.0) then
            call map2D_register()
         endif
      endif

      ! register timers
      call mntr_tmr_is_name_reg(lpmid,'FRM_TOT')
      ! total time
      call mntr_tmr_reg(stat_tmr_tot_id,lpmid,stat_id,
     $     'STAT_TOT','Statistics total time',.false.)
      lpmid = stat_tmr_tot_id
      ! initialisation
      call mntr_tmr_reg(stat_tmr_ini_id,lpmid,stat_id,
     $     'STAT_INI','Statistics initialisation time',.true.)
      ! averagign
      call mntr_tmr_reg(stat_tmr_avg_id,lpmid,stat_id,
     $     'STAT_AVG','Statistics averaging time',.true.)

      if (stat_rdim.eq.1) then
      ! communication
         call mntr_tmr_reg(stat_tmr_cmm_id,lpmid,stat_id,
     $        'STAT_CMM','Statistics communication time',.true.)
      endif
      ! IO
      call mntr_tmr_reg(stat_tmr_io_id,lpmid,stat_id,
     $     'STAT_IO','Statistics IO time',.true.)

      ! register and set active section
      call rprm_sec_reg(stat_sec_id,stat_id,'_'//adjustl(stat_name),
     $     'Runtime paramere section for statistics module')
      call rprm_sec_set_act(.true.,stat_sec_id)

      ! register parameters
      call rprm_rp_reg(stat_avstep_id,stat_sec_id,'AVSTEP',
     $     'Frequency of averaging',rpar_int,10,0.0,.false.,' ')

      call rprm_rp_reg(stat_IOstep_id,stat_sec_id,'IOSTEP',
     $     'Frequency of filed saving',rpar_int,100,0.0,.false.,' ')
      
      ! set initialisation flag
      stat_ifinit=.false.

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(stat_tmr_tot_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Initilise statistics module
!! @ingroup stat
!! @note This routine should be called in frame_usr_init
      subroutine stat_init()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'TSTEP'
      include 'MAP2D'
      include 'STATD'

      ! local variables
      integer itmp, il
      real rtmp, ltim
      logical ltmp
      character*20 ctmp

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      ! check if the module was already initialised
      if (stat_ifinit) then
         call mntr_warn(stat_id,
     $        'module ['//trim(stat_name)//'] already initiaised.')
         return
      endif

      ! check if map2d module is initialised
      if (stat_rdim.eq.1) then
         if (.not.map2d_ifinit) call map2d_init()
      endif

      ! timing
      ltim = dnekclock()
      
      ! get runtime parameters
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,stat_avstep_id,rpar_int)
      stat_avstep = itmp
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,stat_IOstep_id,rpar_int)
      stat_IOstep = itmp

      ! initialise time averaging variables for a given statistics file
      stat_atime = 0.0
      stat_tstart = time

      if (stat_rdim.eq.1) then
         ! finish 3D => 2D mapping operations
         ! get local integration coefficients
         call mntr_log(stat_id,lp_vrb,'Getting loacal int. coeff.')
         call stat_init_int1D
      endif

      ! reset statistics variables
      itmp = lx1**(LDIM-stat_rdim)*lelt*stat_lvar
      call rzero(stat_ruavg,itmp)
      
      ! everything is initialised
      stat_ifinit=.true.

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(stat_tmr_ini_id,1,ltim)
      
      return
      end subroutine
!=======================================================================
!> @brief Check if module was initialised
!! @ingroup stat
!! @return stat_is_initialised
      logical function stat_is_initialised()
      implicit none

      include 'SIZE'
      include 'STATD'
!-----------------------------------------------------------------------
      stat_is_initialised = stat_ifinit

      return
      end function
!=======================================================================
!> @brief Main interface of statistics module
!! @ingroup stat
!! @details This routine performs time averaging and file writing.
!! @note This routine should be called in userchk during every step
      subroutine stat_avg
      implicit none 

      include 'SIZE'
      include 'FRAMELP'
      include 'TSTEP'
      include 'STATD'

      ! local variables
      integer itmp

      ! simple timing
      real ltim

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      ! average
      if (ISTEP.gt.0.and.mod(ISTEP,stat_avstep).eq.0) then
         ! simple timing
         ltim = dnekclock()
         call mntr_log(stat_id,lp_inf,'Average compute')
         call stat_compute
         ! timing
         ltim = dnekclock() - ltim
         call mntr_tmr_add(stat_tmr_avg_id,1,ltim)
      endif

      ! save statistics file and restart statistics variables
      if (ISTEP.gt.0.and.mod(ISTEP,stat_IOstep).eq.0) then            
         if (stat_rdim.eq.1) then

            ltim = dnekclock()
            call mntr_log(stat_id,lp_inf,'Global sum')
            call stat_gs_sum
            ltim = dnekclock() - ltim
            call mntr_tmr_add(stat_tmr_cmm_id,1,ltim)
         endif

         ltim = dnekclock()
         call mntr_log(stat_id,lp_inf,'Writing stat file')
         call stat_mfo
         ltim = dnekclock() - ltim
         call mntr_tmr_add(stat_tmr_io_id,1,ltim)


         ! clean up array
         itmp = lx1**(LDIM-stat_rdim)*lelt*stat_lvar
         call rzero(stat_ruavg,itmp)

         ! reset averagign parameters
         stat_atime = 0.0
         stat_tstart = time
      endif

      return
      end subroutine
!====================================================================== 
!> @brief Get local integration coefficients
!! @ingroup stat
!! @details This version does 1D integration over one of the directions
!!  R,S,T. It supports curved coordinate systems, however 
!!  axisymmetric 2.5D cases are not supported
!! @remark This routine uses global scratch space \a SCRSF
      subroutine stat_init_int1D()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'WZ'              ! W?M1
      include 'GEOM'            ! ?M1
      include 'INPUT'           ! IFAXIS, IF3D
      include 'DXYZ'            ! D?M1, D?TM1
      include 'MAP2D'
      include 'STATD'

      ! global variables
      integer mid,mp,nekcomm,nekgroup,nekreal
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
      ! scratch space
      real lxyzd(lx1,ly1,lz1,lelt,3)
      common /SCRSF/ lxyzd      ! coordinate derivatives

      ! local variables
      integer il, jl, kl, el    ! loop index
      integer el2               ! index of 2D element
      real lwm1(lx1)            ! wieghts for 1D integration

      ! global communication
      integer gs_handle         ! gather-scatter handle
      integer*8 unodes(lx1*lz1*lelt)    ! unique local nodes
!-----------------------------------------------------------------------
      if(ifaxis) call mntr_abort(stat_id,
     $        'stat_init_int1D; IFAXIS not supported')

      ! copy wieghts depending on the uniform direction
      if (map2d_idir.eq.1) then
         call copy(lwm1,wxm1,nx1)
         stat_nm1 = nx1
         stat_nm2 = ny1
         stat_nm3 = nz1
         ! get coordinates derivatives d[XYZ]/dr
         il = ny1*nz1
         do el = 1, nelt
            if(map2d_lmap(el).ne.-1) then
               call mxm(dxm1,nx1,xm1(1,1,1,el),nx1,lxyzd(1,1,1,el,1),il)
               call mxm(dxm1,nx1,ym1(1,1,1,el),nx1,lxyzd(1,1,1,el,2),il)
               if (if3d) call mxm(dxm1,nx1,zm1(1,1,1,el),nx1,
     $              lxyzd(1,1,1,el,3),il)
            endif
         enddo
      elseif (map2d_idir.eq.2) then
         call copy(lwm1,wym1,ny1)
         stat_nm1 = ny1
         stat_nm2 = nx1
         stat_nm3 = nz1
         ! get coordinates derivatives d[XYZ]/ds
         do el = 1, nelt
            if(map2d_lmap(el).ne.-1) then
               do il=1, nz1
                  call mxm(xm1(1,1,il,el),nx1,dytm1,ny1,
     $                 lxyzd(1,1,il,el,1),ny1)
                  call mxm(ym1(1,1,il,el),nx1,dytm1,ny1,
     $                 lxyzd(1,1,il,el,2),ny1)
                  if (if3d) call mxm(zm1(1,1,il,el),nx1,dytm1,ny1,
     $                 lxyzd(1,1,il,el,3),ny1)
               enddo
            endif
         enddo
      else
         if (if3d) then
            call copy(lwm1,wzm1,nz1)
            stat_nm1 = nz1
            stat_nm2 = nx1
            stat_nm3 = ny1
            ! get coordinates derivatives d[XYZ]/dt
            il = nx1*ny1
            do el = 1, nelt
               if(map2d_lmap(el).ne.-1) then
                  call mxm(xm1(1,1,1,el),il,dztm1,nz1,
     $                 lxyzd(1,1,1,el,1),nz1)
                  call mxm(ym1(1,1,1,el),il,dztm1,nz1,
     $                 lxyzd(1,1,1,el,2),nz1)
                  call mxm(zm1(1,1,1,el),il,dztm1,nz1,
     $                 lxyzd(1,1,1,el,3),nz1)
               endif
            enddo
         else
            call mntr_abort(stat_id,'2D run cannot be z averaged.')
         endif
      endif

      ! for now I assume lx1=stat_nm1=stat_nm2=stat_nm3
      ! check if that is true
      if (if3d) then
         if(lx1.ne.stat_nm1.or.lx1.ne.stat_nm2.or.lx1.ne.stat_nm3) then
            call mntr_abort(stat_id,
     $           'stat_init_int1D; unequal array sizes')
         endif
      else
         if(lx1.ne.stat_nm1.or.lx1.ne.stat_nm2.or.1.ne.stat_nm3) then
            call mntr_abort(stat_id,
     $           'stat_init_int1D; unequal array sizes')
         endif
      endif

      ! get 1D mass matrix ordering directions in such a way that
      ! the uniform direction corresponds to the the first index
      il = stat_nm1*stat_nm2*stat_nm3
      ! get arc length
      do el = 1, nelt
         if(map2d_lmap(el).ne.-1) then
            call vsq(lxyzd(1,1,1,el,1),il)
            call vsq(lxyzd(1,1,1,el,2),il)
            if (if3d) call vsq(lxyzd(1,1,1,el,3),il)
      
            call add2(lxyzd(1,1,1,el,1),lxyzd(1,1,1,el,2),il)
            if (if3d) call add2(lxyzd(1,1,1,el,1),lxyzd(1,1,1,el,3),il)

            call vsqrt(lxyzd(1,1,1,el,1),il)
         endif
      enddo

      il=il*nelt
      call rzero(stat_bm1d,il)

      ! reshuffle array
      call stat_reshufflev(stat_bm1d,lxyzd,nelt)

      ! multiply by wieghts
      do el=1, nelt
         if(map2d_lmap(el).ne.-1) then
            do kl=1, stat_nm3
               do jl=1, stat_nm2
                  do il=1, stat_nm1
                     stat_bm1d(il,jl,kl,el) =
     $                    lwm1(il)*stat_bm1d(il,jl,kl,el)
                  enddo
               enddo
            enddo
         endif
      enddo

      ! get total line length
      ! sum contributions from different 3D elements to get
      ! local arc length

      il = stat_nm2*stat_nm3*nelt
      call rzero(stat_abm1d,il)

      do el = 1, nelv
         el2 = map2d_lmap(el)
         if(el2.gt.0) then
            do kl=1, stat_nm3
               do jl=1, stat_nm2
                  do il=1, stat_nm1
                     stat_abm1d(jl,kl,el2) = stat_abm1d(jl,kl,el2) +
     $                    stat_bm1d(il,jl,kl,el)
                  enddo
               enddo
            enddo
         endif
      enddo

      ! Global communication to sum local contributions for arc lenght
      ! set up communicator
      el = stat_nm2*stat_nm3
      do il = 1,map2d_lnum
         kl = map2d_gmap(il) - 1
         do jl=1,el
            unodes(el*(il-1) + jl) = int(el,8)*int(kl,8) + jl
         enddo
      enddo
      kl = el*map2d_lnum
      call fgslib_gs_setup(gs_handle,unodes,kl,nekcomm,mp)

      call fgslib_gs_op(gs_handle,stat_abm1d,1,1,0)

      ! destroy communicator
      call fgslib_gs_free (gs_handle)

      return
      end subroutine
!=======================================================================
!> @brief Array reshuffle
!! @ingroup stat
!! @details Reorder directions in such a way that the uniform direction 
!!   corresponds to the the first index
!! @param[out]  rvar   reshuffled array
!! @param[in]   var    input array
!! @param[in]   nl     element number to reshuffle
      subroutine stat_reshufflev(rvar, var, nl)
      implicit none

      include 'SIZE'
      include 'MAP2D'
      include 'STATD'

      ! argument list
      real rvar(lx1,ly1,lz1,lelt) !reshuffled array
      real var(lx1,ly1,lz1,lelt) ! input array
      integer nl                ! element number to reshuffle

      ! local variables
      integer il, jl, kl, el    ! loop index
!-----------------------------------------------------------------------
      ! if no space averaging copy
      if (stat_rdim.eq.0) then
         el = lx1*ly1*lz1*lelt
         call copy(rvar,var,el)
      else
         ! if space averagign swap data
         if (map2d_idir.eq.1) then
            do el=1, nl
               if(map2d_lmap(el).ne.-1) then
                  do kl=1, stat_nm3
                     do jl=1, stat_nm2
                        do il=1, stat_nm1
                           rvar(il,jl,kl,el) = var(il,jl,kl,el)
                        enddo
                     enddo
                  enddo
               endif
            enddo
         elseif (map2d_idir.eq.2) then
            do el=1, nl
               if(map2d_lmap(el).ne.-1) then
                  do kl=1, stat_nm3
                     do jl=1, stat_nm2
                        do il=1, stat_nm1
                           rvar(il,jl,kl,el) = var(jl,il,kl,el)
                        enddo
                     enddo
                  enddo
               endif
            enddo
         else
            do el=1, nl
               if(map2d_lmap(el).ne.-1) then
                  do kl=1, stat_nm3
                     do jl=1, stat_nm2
                        do il=1, stat_nm1
                           rvar(il,jl,kl,el) = var(jl,kl,il,el)
                        enddo
                     enddo
                  enddo
               endif
            enddo
         endif
      endif
         
      return
      end subroutine
!=======================================================================
!> @brief Perform local 1D integration on 1 variable
!! @ingroup stat
!! @param[in]   lvar        integrated variable
!! @param[in]   npos        position in stat_ruavg
!! @param[in]   alpha,beta  time averaging parameters
!! @remark This routine uses global scratch space \a CTMP0
      subroutine stat_compute_1Dav1(lvar,npos,alpha,beta)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MAP2D'
      include 'STATD'

      ! argument list
      real lvar(lx1,ly1,lz1,lelt)
      integer npos
      real alpha, beta

      ! global variables
      real rtmp(lx1,lz1,lelt) ! dummy array
      common /CTMP0/ rtmp

      ! local variables
      integer il, jl, kl, el    ! loop index
      integer el2               ! index of 2D element
!-----------------------------------------------------------------------
      ! consistency check
      if(npos.gt.stat_lvar)
     $     call mntr_abort(stat_id,'inconsistent npos ')

      if (stat_rdim.eq.1) then
         ! zero work array
         el = lx1*lz1*lelt
         call rzero(rtmp,el)

         ! perform 1D integral
         do el = 1, nelv
            el2 = map2d_lmap(el)
            if(el2.gt.0) then
               do kl=1, stat_nm3
                  do jl=1, stat_nm2
                     do il=1, stat_nm1
                        rtmp(jl,kl,el2) = rtmp(jl,kl,el2) +
     $                       stat_bm1d(il,jl,kl,el)*lvar(il,jl,kl,el)
                     enddo
                  enddo
               enddo
            endif
         enddo

         ! time average
         el = stat_nm2*stat_nm3*map2d_lnum
         call add2sxy(stat_ruavg(1,1,npos),alpha,rtmp,beta,el)
      else
         el = lx1**(LDIM)*lelt
         call add2sxy(stat_ruavg(1,1,npos),alpha,lvar,beta,el)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Perform local 1D integration on multiplication of 2 variables
!! @ingroup stat
!! @param[in]   lvar1,lvar2 integrated variable
!! @param[in]   npos        position in stat_ruavg
!! @param[in]   alpha,beta  time averaging parameters
!! @remark This routine uses global scratch space \a CTMP0
      subroutine stat_compute_1Dav2(lvar1,lvar2,npos,alpha,beta)
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'MAP2D'
      include 'STATD'

      ! argument list
      real lvar1(lx1,ly1,lz1,lelt), lvar2(lx1,ly1,lz1,lelt)
      integer npos
      real alpha, beta

      ! global variables
      real rtmp(lx1,lz1,lelt)   ! dummy array
      real rtmp2(lx1,ly1,lz1,lelt) ! dummy array
      common /CTMP0/ rtmp, rtmp2

      ! local variables
      integer il, jl, kl, el    ! loop index
      integer el2               ! index of 2D element
!-----------------------------------------------------------------------
      ! consistency check
      if(npos.gt.stat_lvar)
     $     call mntr_abort(stat_id,'inconsistent npos ')

      if (stat_rdim.eq.1) then
         ! zero work array
         el = lx1*lz1*lelt
         call rzero(rtmp,el)

         ! perform 1D integral
         do el = 1, nelv
            el2 = map2d_lmap(el)
            if(el2.gt.0) then
               do kl=1, stat_nm3
                  do jl=1, stat_nm2
                     do il=1, stat_nm1
                        rtmp(jl,kl,el2) = rtmp(jl,kl,el2) +
     $                       stat_bm1d(il,jl,kl,el)*
     $                       lvar1(il,jl,kl,el)*lvar2(il,jl,kl,el)
                     enddo
                  enddo
               enddo
            endif
         enddo

         ! time average
         el = stat_nm2*stat_nm3*map2d_lnum
         call add2sxy(stat_ruavg(1,1,npos),alpha,rtmp,beta,el)
      else
         el = lx1**(LDIM)*lelt
         call col3(rtmp2,lvar1,lvar2,el)
         call add2sxy(stat_ruavg(1,1,npos),alpha,rtmp2,beta,el)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Global statistics summation
!! @ingroup stat
      subroutine stat_gs_sum
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'PARALLEL'
      include 'INPUT'           ! if3d
      include 'MAP2D'
      include 'STATD'

      ! global variables
      integer mid,mp,nekcomm,nekgroup,nekreal
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      ! local variables
      integer gs_handle         ! gather-scatter handle
      integer*8 unodes(lx1*lz1*lelt) ! unique local nodes
      integer il, jl
      integer itmp1, itmp2
!-----------------------------------------------------------------------
      ! if no space averaging return
      if (stat_rdim.eq.0) return
      
      ! stamp logs
      call mntr_log(stat_id,lp_vrb,'Global statistics summation.')

      ! set up communicator
      itmp1 = stat_nm2*stat_nm3
      do il = 1, map2d_lnum
         itmp2 = map2d_gmap(il) - 1
         do jl=1,itmp1
            unodes(itmp1*(il-1) + jl) = int(itmp1,8)*int(itmp2,8) + jl
         enddo
      enddo
      itmp2 = itmp1*map2d_lnum
      call fgslib_gs_setup(gs_handle,unodes,itmp2,nekcomm,mp)

      ! sum variables
      do il=1,stat_lvar
         call fgslib_gs_op(gs_handle,stat_ruavg(1,1,il),1,1,0)
      enddo

      ! destroy communicator
      call fgslib_gs_free (gs_handle)

      ! divide data by arc length
      if (if3d) then
         itmp1=stat_nm2*stat_nm3
         do il=1, map2d_lnum
            if (map2d_own(il).eq.nid) then
               do jl=1, stat_lvar
                  call invcol2(stat_ruavg(1,il,jl),
     $                 stat_abm1d(1,1,il),itmp1)
               enddo
            endif
         enddo
      endif
      
      return
      end subroutine
!=======================================================================
!> @brief Compute statistics
!! @ingroup stat
!! @remark This routine uses global scratch space \a SCRMG, \a SCRUZ, \a SCRNS, \a SCRSF
      subroutine stat_compute()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'SOLN'
      include 'TSTEP'
      include 'STATD'           ! Variables from the statistics
      include 'INPUT'           ! if3d

      ! global variables
      ! work arrays
      real slvel(LX1,LY1,LZ1,LELT,3), slp(LX1,LY1,LZ1,LELT)
      common /SCRMG/ slvel, slp
      real tmpvel(LX1,LY1,LZ1,LELT,3), tmppr(LX1,LY1,LZ1,LELT)
      common /SCRUZ/ tmpvel, tmppr
      real dudx(LX1,LY1,LZ1,LELT,3) ! du/dx, du/dy and du/dz
      real dvdx(LX1,LY1,LZ1,LELT,3) ! dv/dx, dv/dy and dv/dz
      real dwdx(LX1,LY1,LZ1,LELT,3) ! dw/dx, dw/dy and dw/dz
      common /SCRNS/ dudx, dvdx
      common /SCRSF/ dwdx

      ! local variables
      integer npos              ! position in STAT_RUAVG
      real alpha, beta,dtime    ! time averaging parameters
      integer lnvar             ! count number of variables
      integer i                 ! loop index
      integer itmp              ! dummy variable
      real rtmp                 ! dummy variable
      integer ntot

!-----------------------------------------------------------------------
      ! stamp logs
      call mntr_log(stat_id,lp_vrb,'Average fields.')
      
      ! Calculate time span of current statistical sample
      dtime=time-stat_atime-stat_tstart

      ! Update total time over which the current stat file is averaged
      stat_atime=time-stat_tstart

      ! Time average is compuated as:
      ! Accumulated=alpha*Accumulated+beta*New
      ! Calculate alpha and beta
      beta=dtime/STAT_ATIME
      alpha=1.0-beta
      
      ! Map pressure to velocity mesh
      call mappr(tmppr,PR,tmpvel(1,1,1,1,2),tmpvel(1,1,1,1,3))

      ! Compute derivative tensor
      call user_stat_trnsv(tmpvel,dudx,dvdx,dwdx,slvel)

      ! call time series
      ! adding time series here
      ! notice I use tmpvel, so the mean pressure is subtracted from
      ! pressure
      if (if3d) then
!          call stat_pts_compute(tmpvel,slvel,tmppr)
      endif

      ! reset varaible counter
      lnvar = 0

      ! reshuffle arrays
      ! velocity
      call stat_reshufflev(slvel(1,1,1,1,1),tmpvel(1,1,1,1,1),NELV)
      call stat_reshufflev(slvel(1,1,1,1,2),tmpvel(1,1,1,1,2),NELV)
      if (if3d) call stat_reshufflev(slvel(1,1,1,1,3),
     $     tmpvel(1,1,1,1,3),NELV)

      ! pressure
      call stat_reshufflev(slp,tmppr,NELV)

      ! reshuffle velocity derivatives
      ! VX
      call stat_reshufflev(tmpvel(1,1,1,1,1),dudx(1,1,1,1,1),NELV)
      call stat_reshufflev(tmpvel(1,1,1,1,2),dudx(1,1,1,1,2),NELV)
      if (if3d) call stat_reshufflev(tmpvel(1,1,1,1,3),
     $     dudx(1,1,1,1,3),NELV)
      ! copy
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call copy(dudx,tmpvel,itmp)

      ! VY
      call stat_reshufflev(tmpvel(1,1,1,1,1),dvdx(1,1,1,1,1),NELV)
      call stat_reshufflev(tmpvel(1,1,1,1,2),dvdx(1,1,1,1,2),NELV)
      if (if3d) call stat_reshufflev(tmpvel(1,1,1,1,3),
     $     dvdx(1,1,1,1,3),NELV)
      ! copy
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call copy(dvdx,tmpvel,itmp)

      ! VZ
      if (if3d) then
         call stat_reshufflev(tmpvel(1,1,1,1,1),dwdx(1,1,1,1,1),NELV)
         call stat_reshufflev(tmpvel(1,1,1,1,2),dwdx(1,1,1,1,2),NELV)
         call stat_reshufflev(tmpvel(1,1,1,1,3),dwdx(1,1,1,1,3),NELV)
      ! copy
         itmp = LX1*LY1*LZ1*LELT*LDIM
         call copy(dwdx,tmpvel,itmp)
      endif

!=======================================================================
      ! Computation of statistics
      
      ! <u>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(slvel(1,1,1,1,1),npos,alpha,beta)

      ! <v>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(slvel(1,1,1,1,2),npos,alpha,beta)

      ! <w>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(slvel(1,1,1,1,3),npos,alpha,beta)

      ! <p>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(slp(1,1,1,1),npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <uu>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,1),slvel(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <vv>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,2),slvel(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <ww>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,3),slvel(1,1,1,1,3),
     $     npos,alpha,beta)

      ! <pp>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),slp(1,1,1,1),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <uv>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,1),slvel(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <vw>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,2),slvel(1,1,1,1,3),
     $     npos,alpha,beta)

      ! <uw>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,1),slvel(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <pu>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),slvel(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <pv>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),slvel(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <pw>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),slvel(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <pdudx>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dudx(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <pdudy>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dudx(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <pdudz>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dudx(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <pdvdx>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dvdx(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <pdvdy>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dvdx(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <pdvdz>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dvdx(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <pdwdx>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dwdx(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <pdwdy>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dwdx(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <pdwdz>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slp(1,1,1,1),dwdx(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! UU, VV, WW
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call col3(tmpvel(1,1,1,1,1),slvel(1,1,1,1,1),slvel(1,1,1,1,1),
     $     itmp)

      ! <uuu>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,1),tmpvel(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <vvv>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,2),tmpvel(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <www>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(slvel(1,1,1,1,3),tmpvel(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <uuv>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,1),slvel(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <uuw>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,1),slvel(1,1,1,1,3),
     $     npos,alpha,beta)

      ! <vvu>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,2),slvel(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <vvw>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,2),slvel(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <wwu>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,3),slvel(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <wwv>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,3),slvel(1,1,1,1,2),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <ppp>t
      lnvar = lnvar + 1
      npos = lnvar
      itmp = LX1*LY1*LZ1*LELT
      call col3(tmppr(1,1,1,1),slp(1,1,1,1),slp(1,1,1,1),
     $     itmp) 
      call stat_compute_1Dav2(tmppr(1,1,1,1),slp(1,1,1,1),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <pppp>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmppr(1,1,1,1),tmppr(1,1,1,1),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <uvw>t
      lnvar = lnvar + 1
      npos = lnvar
      ! copy uv to tmppr (do not need pp anymore)
      itmp = LX1*LY1*LZ1*LELT
      call col3(tmppr(1,1,1,1),slvel(1,1,1,1,1),slvel(1,1,1,1,2),
     $     itmp) 
      call stat_compute_1Dav2(tmppr(1,1,1,1),slvel(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <uuuu>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,1),
     $     npos,alpha,beta)

      ! <vvvv>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,2),tmpvel(1,1,1,1,2),
     $     npos,alpha,beta)

      ! <wwww>t
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav2(tmpvel(1,1,1,1,3),tmpvel(1,1,1,1,3),
     $     npos,alpha,beta)

!-----------------------------------------------------------------------
      ! <e11>t : (du/dx)^2 + (du/dy)^2 + (du/dz)^2
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call col3(tmpvel(1,1,1,1,1),dudx(1,1,1,1,1),dudx(1,1,1,1,1),
     $     itmp)
      itmp = LX1*LY1*LZ1*LELT
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,2),itmp)
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,3),itmp)
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(tmpvel(1,1,1,1,1),npos,alpha,beta)

      ! <e22>t: (dv/dx)^2 + (dv/dy)^2 + (dv/dz)^2
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call col3(tmpvel(1,1,1,1,1),dvdx(1,1,1,1,1),dvdx(1,1,1,1,1),
     $     itmp)
      itmp = LX1*LY1*LZ1*LELT
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,2),itmp)
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,3),itmp)
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(tmpvel(1,1,1,1,1),npos,alpha,beta)
      
      ! <e33>t: (dw/dx)^2 + (dw/dy)^2 + (dw/dz)^2
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call col3(tmpvel(1,1,1,1,1),dwdx(1,1,1,1,1),dwdx(1,1,1,1,1),
     $     itmp)
      itmp = LX1*LY1*LZ1*LELT
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,2),itmp)
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,3),itmp)
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(tmpvel(1,1,1,1,1),npos,alpha,beta)
      
!-----------------------------------------------------------------------
      ! <e12>t: (du/dx)*(dv/dx) + (du/dy)*(dv/dy) + (du/dz)*(dv/dz)
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call col3(tmpvel(1,1,1,1,1),dudx(1,1,1,1,1),dvdx(1,1,1,1,1),
     $     itmp)
      itmp = LX1*LY1*LZ1*LELT
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,2),itmp)
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,3),itmp)
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(tmpvel(1,1,1,1,1),npos,alpha,beta)

      ! <e13>t: (du/dx)*(dw/dx) + (du/dy)*(dw/dy) + (du/dz)*(dw/dz)
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call col3(tmpvel(1,1,1,1,1),dudx(1,1,1,1,1),dwdx(1,1,1,1,1),
     $     itmp)
      itmp = LX1*LY1*LZ1*LELT
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,2),itmp)
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,3),itmp)
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(tmpvel(1,1,1,1,1),npos,alpha,beta)
      
      ! <e23>t: (dv/dx)*(dw/dx) + (dv/dy)*(dw/dy) + (dv/dz)*(dw/dz)
      itmp = LX1*LY1*LZ1*LELT*LDIM
      call col3(tmpvel(1,1,1,1,1),dvdx(1,1,1,1,1),dwdx(1,1,1,1,1),
     $     itmp)
      itmp = LX1*LY1*LZ1*LELT
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,2),itmp)
      call add2(tmpvel(1,1,1,1,1),tmpvel(1,1,1,1,3),itmp)
      lnvar = lnvar + 1
      npos = lnvar
      call stat_compute_1Dav1(tmpvel(1,1,1,1,1),npos,alpha,beta)
      
!=======================================================================
      !End of local compute

      ! save number of variables
      stat_nvar = lnvar

      return
      end subroutine
!=======================================================================

!> @file frame.f
!! @ingroup frame
!! @brief Set of routines for framework operation
!! @author Adam Peplinski
!! @date 13 Oct 2017
!=======================================================================
!> @brief Start framework
!! @ingroup frame
!! @note This routine requires \a frame_usr_register and
!!    \a frame_usr_init to be defined in \a setup.usr
      subroutine frame_start
      implicit none

      include 'SIZE'
      include 'PARALLEL'
      include 'FRAMELP'

      ! local variables
      integer log_thr, slen, ierr
      character*18 log_cval
!-----------------------------------------------------------------------
      ! check logging threshold
      if (nid.eq.0) then
         call getenv('FRAMELOGL',log_cval)
         slen = len_trim(log_cval)
         if (slen.gt.0) then
            read(log_cval,'(I2)',iostat=ierr) log_thr
            if (ierr.gt.0) log_thr = lp_inf
         else
            log_thr = lp_inf
         endif
      endif

      call bcast(log_thr,isize)

      ! register backbone modules na runtime parameters
      call mntr_register_mod(log_thr)
      call rprm_register
      call mntr_register_par

      ! regisred user specified moduels
      call frame_usr_register

      ! get runtime parameters from Nek5000 dictionary
      call rprm_dict_get
      call mntr_init
      call rprm_init

      ! initialise user specified modules
      call frame_usr_init

      return
      end subroutine
!=======================================================================
!> @brief Simulataion monitoring
!! @ingroup frame
      subroutine frame_monitor
      implicit none

      include 'SIZE'
      include 'FRAMELP'

!-----------------------------------------------------------------------
      ! monitor simulation wall clock
      call mntr_wclock

      ! place for other monitoring operations

      return
      end subroutine
!=======================================================================
!> @brief Finalise framework
!! @ingroup frame
      subroutine frame_end
      implicit none

      include 'SIZE'
      include 'FRAMELP'

!-----------------------------------------------------------------------
      ! finalilse user specified modules
      call frame_usr_end

      ! close all opened files
      call io_file_close

      ! place for timers summary
      call mntr_tmr_summary_print()

      return
      end subroutine
!=======================================================================
!> @brief Specify master node id
!! @ingroup frame
!! @return frame_get_master
!! @note This routine requires \a frame_usr_end to be defined in
!!    \a setup.usr
      integer function frame_get_master()
      implicit none
!-----------------------------------------------------------------------
      frame_get_master = 0

      return
      end function
!=======================================================================

!> @file stat_IO.f
!! @ingroup stat
!! @brief IO routines for 2D/3D statistics module
!! @details This is a set of routines to write 2D statistics to 
!!  the file. They are modiffication of the existing nek5000 routines
!! @note This code works for extruded meshes only
!! @author Prabal Negi, Adam Peplinski
!! @date Aug 15, 2018
!=======================================================================
!> @brief Main interface for saving statistics
!! @ingroup stat
      subroutine stat_mfo()
      implicit none
      
      include 'SIZE'
      include 'STATD'

      if (stat_rdim.eq.1) then
         call stat_mfo_outfld2D()
      else
         call stat_mfo_outfld3D()
      endif

      return
      end subroutine
!=======================================================================
!> @brief Statistics muti-file output of 3D data
!! @ingroup stat
      subroutine stat_mfo_outfld3D()
      implicit none

      include 'SIZE'
      include 'INPUT'           ! ifpo
      include 'SOLN'            ! pr
      include 'STATD'           ! 

      ! local variables
      logical ifpo_tmp
!----------------------------------------------------------------------
      ifpo_tmp = ifpo
      ifpo=.FALSE.

      ! Fields to outpost: <u>t, <v>t, <w>t, <p>t
      call outpost(stat_ruavg(1,1,1),stat_ruavg(1,1,2),
     $     stat_ruavg(1,1,3),pr,stat_ruavg(1,1,4),'s01')

      ! Fields to outpost: <uu>t, <vv>t, <ww>t, <pp>t
      call outpost(stat_ruavg(1,1,5),stat_ruavg(1,1,6),
     $     stat_ruavg(1,1,7),pr,stat_ruavg(1,1,8),'s02')

      ! Fields to outpost: <uv>t, <vw>t,<uw>t, <pu>t
      call outpost(stat_ruavg(1,1,9),stat_ruavg(1,1,10),
     $     stat_ruavg(1,1,11),pr,stat_ruavg(1,1,12),'s03')

      ! Fields to outpost: <pv>t, <pw>t, <pdudx>t, <pdudy>t
      call outpost(stat_ruavg(1,1,13),stat_ruavg(1,1,14),
     $     stat_ruavg(1,1,15),pr,stat_ruavg(1,1,16),'s04')

      ! Fields to outpost: <pdudz>t, <pdvdx>t, <pdvdy>t, <pdvdz>t
      call outpost(stat_ruavg(1,1,17),stat_ruavg(1,1,18),
     $     stat_ruavg(1,1,19),pr,stat_ruavg(1,1,20),'s05')

      !Fields to outpost: <pdwdx>t, <pdwdy>t, <pdwdz>t, <uuu>t
      call outpost(stat_ruavg(1,1,21),stat_ruavg(1,1,22),
     $     stat_ruavg(1,1,23),pr,stat_ruavg(1,1,24),'s06')

      ! Fields to outpost:  <vvv>t, <www>t, <uuv>t, <uuw>t
      call outpost(stat_ruavg(1,1,25),stat_ruavg(1,1,26),
     $     stat_ruavg(1,1,27),pr,stat_ruavg(1,1,28),'s07')

      ! Fields to outpost: <vvu>t, <vvw>t,  <wwu>t, <wwv>t
      call outpost(stat_ruavg(1,1,29),stat_ruavg(1,1,30),
     $     stat_ruavg(1,1,31),pr,stat_ruavg(1,1,32),'s08')
      
      ! Fields to outpost:  <ppp>t, <pppp>t, <uvw>t, <uuuu>t
      call outpost(stat_ruavg(1,1,33),stat_ruavg(1,1,34),
     $     stat_ruavg(1,1,35),pr,stat_ruavg(1,1,36),'s09')

      ! Fields to outpost: <vvvv>t, <wwww>t, <e11>t, <e22>t
      call outpost(stat_ruavg(1,1,37),stat_ruavg(1,1,38),
     $     stat_ruavg(1,1,39),pr,stat_ruavg(1,1,40),'s10')
      
      ! Fields to outpost: <e33>t, <e12>t, <e13>t, <e23>t
      call outpost(stat_ruavg(1,1,41),stat_ruavg(1,1,42),
     $     stat_ruavg(1,1,43),pr,stat_ruavg(1,1,44),'s11')

      ifpo=ifpo_tmp

      return
      end subroutine      
!=======================================================================
!> @brief Statistics muti-file output of 2D data
!! @ingroup stat
!! @details This routine is just modification of mfo_outfld
!! @remark This routine uses global scratch space \a SCRUZ
      subroutine stat_mfo_outfld2D()
      implicit none

      include 'SIZE'
      include 'RESTART'
      include 'PARALLEL'
      include 'INPUT'
      include 'TSTEP'
      include 'MAP2D'
      include 'STATD'

      ! global variablse
      ! dummy arrays
      real ur1(lx1,lz1,2*LELT)
      common /SCRUZ/  ur1

      ! local variables
      ! temporary variables to overwrite global values
      logical ifreguol          ! uniform mesh
      logical ifxyol            ! write down mesh
      integer wdsizol           ! store global wdsizo
      integer nel2DB            ! running sum for owned 2D elements
      integer nelBl             ! store global nelB

      integer il, jl, kl        ! loop index
      integer itmp              ! dummy integer
      integer ierr              ! error mark
      integer nxyzo             ! element size

      character*3 prefix        ! file prefix

      integer*8 offs0, offs     ! offset      
      integer*8 stride,strideB  ! stride

      integer ioflds            ! fields count

      real dnbyte               ! byte sum
      real tiostart, tio        ! simple timing

      ! functions
      integer igl_running_sum
      real dnekclock_sync, glsum
!----------------------------------------------------------------------
      ! simple timing
      tiostart=dnekclock_sync()

      ! intialise I/O
      ifdiro = .false.

      ifmpiio = .false.
      if(abs(param(65)).eq.1 .and. abs(param(66)).eq.6) ifmpiio=.true.
#ifdef NOMPIIO
      ifmpiio = .false.
#endif

      if(ifmpiio) then
        nfileo  = np
        nproc_o = 1
        fid0    = 0
        pid0    = nid
        pid1    = 0
      else
        if(param(65).lt.0) ifdiro = .true. !  p65 < 0 --> multi subdirectories
        nfileo  = abs(param(65))
        if(nfileo.eq.0) nfileo = 1
        if(np.lt.nfileo) nfileo=np   
        nproc_o = np / nfileo              !  # processors pointing to pid0
        fid0    = nid/nproc_o              !  file id
        pid0    = nproc_o*fid0             !  my parent i/o node
        pid1    = min(np-1,pid0+nproc_o-1) !  range of sending procs
      endif

      ! save and set global IO variables
      ! no uniform mesh
      ifreguol = IFREGUO
      IFREGUO = .FALSE.

      ! save mesh
      ifxyol = IFXYO
      IFXYO = .TRUE.

      ! force double precission
      wdsizol = WDSIZO
      ! for testing
      WDSIZO = WDSIZE

      nrg = lxo

      ! get number of 2D elements owned by proceesor with smaller nid
      itmp = map2d_lown
      nel2DB = igl_running_sum(itmp)
      nel2DB = nel2DB - map2d_lown
      ! replace value
      nelBl = NELB
      NELB = nel2DB

      ! set element size
      NXO   = stat_nm2
      NYO   = stat_nm3
      NZO   = 1
      nxyzo = NXO*NYO*NZO

      ! if this is AMR run, one has to cast 3D mesh to 2D nonconforming counterpart
      call stat_mfo_crd2D

      ! open files on i/o nodes
      prefix='sts'
      ierr=0
      if (nid.eq.pid0) call mfo_open_files(prefix,ierr)

      call mntr_check_abort(stat_id,ierr,
     $     'Error opening file in stat_mfo_outfld2D.')

      ! write header, byte key, global ordering
      call stat_mfo_write_hdr2D

      ! initial offset: header, test pattern, global ordering
      offs0 = iHeaderSize + 4 + isize*int(map2d_gnum,8)
      offs = offs0

      ! stride
      strideB = int(nelb,8)*nxyzo*wdsizo
      stride  = int(map2d_gnum,8)*nxyzo*wdsizo

      ! count fields
      ioflds = 0

      ! write coordinates
      kl = 0
      ! copy vector
      do il=1,map2d_lnum
         if(map2d_own(il).eq.nid) then
            call copy(ur1(1,1,2*kl+1),map2d_xm1(1,1,il),nxyzo)
            call copy(ur1(1,1,2*kl+2),map2d_ym1(1,1,il),nxyzo)
            kl = kl +1
         endif
      enddo

      ! check consistency
      ierr = 0
      if (kl.ne.map2d_lown) ierr=1
      call mntr_check_abort(stat_id,ierr,'inconsistent map2d_lown 1')
      
      ! offset
      kl = 2*kl
      offs = offs0 + stride*ioflds + 2*strideB
      call byte_set_view(offs,ifh_mbyte)
      call mfo_outs(ur1,kl,nxo,nyo,nzo)
      ioflds = ioflds + 2

      ! write fields
      do jl=1,stat_nvar
         kl = 0
         ! copy vector
         do il=1,map2d_lnum
            if(map2d_own(il).eq.nid) then
               kl = kl +1
               call copy(ur1(1,1,kl),stat_ruavg(1,il,jl),nxyzo)
            endif
         enddo

         ! check consistency
         ierr = 0
         if (kl.ne.map2d_lown) ierr=1
         call mntr_check_abort(stat_id,ierr,'inconsistent map2d_lown 2')

         ! offset
         offs = offs0 + stride*ioflds + strideB
         call byte_set_view(offs,ifh_mbyte)
         call mfo_outs(ur1,kl,nxo,nyo,nzo)
         ioflds = ioflds + 1
      enddo

      ! write averaging data
      call stat_mfo_write_stat2d

      ! count bytes
      dnbyte = 1.*ioflds*map2d_lown*wdsizo*nxyzo

      ierr = 0
      if (nid.eq.pid0) then
         if(ifmpiio) then
            call byte_close_mpi(ifh_mbyte,ierr)
         else
            call byte_close(ierr)
         endif
      endif
      call mntr_check_abort(stat_id,ierr,
     $     'Error closing file in stat_mfo_outfld2D.')

      tio = dnekclock_sync()-tiostart
      if (tio.le.0) tio=1.

      dnbyte = glsum(dnbyte,1)
      dnbyte = dnbyte + iHeaderSize + 4 + isize*map2d_gnum
      dnbyte = dnbyte/1024/1024
      if(NIO.eq.0) write(6,7) ISTEP,TIME,dnbyte,dnbyte/tio,
     &     NFILEO
    7 format(/,i9,1pe12.4,' done :: Write checkpoint',/,
     &     30X,'file size = ',3pG12.2,'MB',/,
     &     30X,'avg data-throughput = ',0pf7.1,'MB/s',/,
     &     30X,'io-nodes = ',i5,/)

      ! set global IO variables back
      IFREGUO = ifreguol
      IFXYO = ifxyol
      WDSIZO = wdsizol
      NELB = nelBl

      return
      end subroutine
!=======================================================================
!> @brief Write hdr, byte key, global ordering of 2D data
!! @ingroup stat
!! @details This routine is just modification of mfo_write_hdr
!! @remark This routine uses global scratch space \a CTMP0
      subroutine stat_mfo_write_hdr2D
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'RESTART'
      include 'PARALLEL'
      include 'TSTEP'
      include 'SOLN'
      include 'MAP2D'
      include 'STATD'

      ! global variable
      integer lglist(0:LELT)    ! dummy array
      common /ctmp0/ lglist

      ! local variables
      real*4 test_pattern       ! byte key
      integer idum, inelp
      integer nelo              ! number of elements to write
      integer nfileoo           ! number of files to create
      
      integer il, jl, kl        ! loop index
      integer mtype             ! tag

      integer ierr              ! error mark
      integer ibsw_out, len
      integer*8 ioff            ! offset
      logical if_press_mesh     ! pessure mesh mark

      character*132 hdr         ! header
!-----------------------------------------------------------------------
      if(ifmpiio) then
         nfileoo = 1            ! all data into one file
         nelo = map2d_gnum
      else
         nfileoo = nfileo
         if(nid.eq.pid0) then   ! how many elements to dump
            nelo = map2d_lown
            do jl = pid0+1,pid1
               mtype = jl
               call csend(mtype,idum,isize,jl,0) ! handshake
               call crecv(mtype,inelp,isize)
               nelo = nelo + inelp
            enddo
         else
            mtype = nid
            call crecv(mtype,idum,isize) ! hand-shake
            call csend(mtype,map2d_lown,isize,pid0,0) ! u4 :=: u8
         endif 
      endif

      ! write header
      ierr = 0
      if(nid.eq.pid0) then
         call blank(hdr,132)

         ! varialbe set
         call blank(rdcode1,10)

         ! we save coordinates
         rdcode1(1)='X'
         ! and set of fields marked as passive scalars
         rdcode1(2) = 'S'
         write(rdcode1(3),'(i1)') stat_nvar/10
         write(rdcode1(4),'(i1)') stat_nvar-(stat_nvar/10)*10

         ! no pressure written so pressure format set to false
         if_press_mesh = .false.
         
         write(hdr,1) wdsizo,nxo,nyo,nzo,nelo,map2d_gnum,time,istep,
     $        fid0, nfileoo, (rdcode1(il),il=1,10),p0th,if_press_mesh
 1       format('#std',1x,i1,1x,i2,1x,i2,1x,i2,1x,i10,1x,i10,1x,
     $        e20.13,1x,i9,1x,i6,1x,i6,1x,10a,1pe15.7,1x,l1) 

         ! write test pattern for byte swap
         test_pattern = 6.54321 

         if(ifmpiio) then
            ! only rank0 (pid00) will write hdr + test_pattern + time list
            call byte_write_mpi(hdr,iHeaderSize/4,pid00,ifh_mbyte,ierr)
            call byte_write_mpi(test_pattern,1,pid00,ifh_mbyte,ierr)
         else
            call byte_write(hdr,iHeaderSize/4,ierr)
            call byte_write(test_pattern,1,ierr)
         endif

      endif

      call mntr_check_abort(stat_id,ierr,
     $     'Error writing header in stat_mfo_write_hdr2D.')

      ! write global 2D elements numbering for this group
      ! copy data
      lglist(0) = map2d_lown
      kl = 0
      do il=1,map2d_lnum
         if(map2d_own(il).eq.nid) then
            kl = kl +1
            lglist(kl) = map2d_gmap(il)
         endif
      enddo
      ! check consistency
      ierr = 0
      if (kl.ne.map2d_lown) ierr=1

      call mntr_check_abort(stat_id,ierr,'inconsistent map2d_lown 3')

      if(nid.eq.pid0) then
         if(ifmpiio) then
            ioff = iHeaderSize + 4 + int(nelb,8)*isize
            call byte_set_view (ioff,ifh_mbyte)
            call byte_write_mpi (lglist(1),lglist(0),-1,ifh_mbyte,ierr)
         else
            call byte_write(lglist(1),lglist(0),ierr)
         endif

         do jl = pid0+1,pid1
            mtype = jl
            call csend(mtype,idum,isize,jl,0) ! handshake
            len = isize*(lelt+1)
            call crecv(mtype,lglist,len)
            if(ierr.eq.0) then
               if(ifmpiio) then
                  call byte_write_mpi
     $                 (lglist(1),lglist(0),-1,ifh_mbyte,ierr)
               else
                  call byte_write(lglist(1),lglist(0),ierr)
               endif
            endif
         enddo
      else
         mtype = nid
         call crecv(mtype,idum,isize) ! hand-shake

         len = isize*(map2d_lown+1)
         call csend(mtype,lglist,len,pid0,0)  
      endif 

      call mntr_check_abort(stat_id,ierr,
     $     'Error writing global nums in stat_mfo_write_hdr2D')

      return
      end subroutine
!=======================================================================
!> @brief Write additional data at the end of the file
!! @ingroup stat
      subroutine stat_mfo_write_stat2D
      implicit none

      include 'SIZE'
      include 'RESTART'
      include 'MAP2D'
      include 'STATD'
!-----------------------------------------------------------------------
      ! to be added
      if(NID.eq.PID0) then


      endif

      return
      end subroutine
!=======================================================================
!> @brief Write element centres to the file (in case of AMR level as well)
!! @ingroup stat
      subroutine stat_mfo_crd2D
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'RESTART'
      include 'PARALLEL'
      include 'TSTEP'
      include 'WZ'
      include 'MAP2D'
      include 'STATD'
#ifdef AMR
      include 'AMR'
#endif

      ! local variables
      character*3 prefix        ! file prefix

      real*4 test_pattern       ! byte key
      integer lglist(0:LELT), itmp(LELT)    ! dummy array
      integer nxl               ! number of grid points for interpolation operator
      parameter (nxl=3)
      real zgml(nxl), wgtl(nxl) ! gll points and weights for interpolation mesh
      real iresl(nxl,lx1), itresl(lx1,nxl) ! interpolation operators
      real rtmp1(nxl,lx1), rtmp2(nxl,nxl)  ! temporary arrays for interpolation
      real rglist(2,0:LELT)
      integer noutl             ! number of bytes to write
      integer idum, inelp
      integer nelo              ! number of elements to write
      integer nfileoo           ! number of files to create

      integer il, jl, kl        ! loop index
      integer mtype             ! tag

      integer ierr              ! error mark
      integer ibsw_out, len
      integer*8 ioff            ! offset

      character*132 hdr         ! header
!-----------------------------------------------------------------------
      ! open files on i/o nodes
      prefix='c2D'
      ierr=0
      if (nid.eq.pid0) call mfo_open_files(prefix,ierr)

      call mntr_check_abort(stat_id,ierr,
     $     'Error opening file in stat_mfo_AMRd2D.')

      ! master-slave communication
      if(ifmpiio) then
         nfileoo = 1            ! all data into one file
         nelo = map2d_gnum
      else
         nfileoo = nfileo
         if(nid.eq.pid0) then   ! how many elements to dump
            nelo = map2d_lown
            do jl = pid0+1,pid1
               mtype = jl
               call csend(mtype,idum,isize,jl,0) ! handshake
               call crecv(mtype,inelp,isize)
               nelo = nelo + inelp
            enddo
         else
            mtype = nid
            call crecv(mtype,idum,isize) ! hand-shake
            call csend(mtype,map2d_lown,isize,pid0,0) ! u4 :=: u8
         endif
      endif

      ! write header
      ierr = 0
      if(nid.eq.pid0) then
         call blank(hdr,132)

         call blank(rdcode1,10)

           write(hdr,1) wdsizo,nelo,map2d_gnum,time,istep,
     $        fid0, nfileoo
 1       format('#amr',1x,i2,1x,i10,1x,i10,1x,
     $        e20.13,1x,i9,1x,i6,1x,i6)

         ! write test pattern for byte swap
         test_pattern = 6.54321

         if(ifmpiio) then
            ! only rank0 (pid00) will write hdr + test_pattern + time list
            call byte_write_mpi(hdr,iHeaderSize/4,pid00,ifh_mbyte,ierr)
            call byte_write_mpi(test_pattern,1,pid00,ifh_mbyte,ierr)
         else
            call byte_write(hdr,iHeaderSize/4,ierr)
            call byte_write(test_pattern,1,ierr)
         endif
      endif

      call mntr_check_abort(stat_id,ierr,
     $     'Error writing header in stat_mfo_crd2D.')

      ! write global 2D elements numbering for this group
      ! copy data
      lglist(0) = map2d_lown
      kl = 0
      do il=1,map2d_lnum
         if(map2d_own(il).eq.nid) then
            kl = kl +1
            lglist(kl) = map2d_gmap(il)
         endif
      enddo
      ! check consistency
      ierr = 0
      if (kl.ne.map2d_lown) ierr=1

      call mntr_check_abort(stat_id,ierr,'inconsistent map2d_lown 4')

      if(nid.eq.pid0) then
         noutl = lglist(0)*isize/4
         if(ifmpiio) then
            ioff = iHeaderSize + 4 + int(nelb,8)*isize
            call byte_set_view (ioff,ifh_mbyte)
            call byte_write_mpi (lglist(1),noutl,-1,ifh_mbyte,ierr)
         else
            call byte_write(lglist(1),noutl,ierr)
         endif

         do jl = pid0+1,pid1
            mtype = jl
            call csend(mtype,idum,isize,jl,0) ! handshake
            len = isize*(lelt+1)
            call crecv(mtype,lglist,len)
            if(ierr.eq.0) then
               noutl = lglist(0)*isize/4
               if(ifmpiio) then
                  call byte_write_mpi(lglist(1),noutl,-1,ifh_mbyte,ierr)
               else
                  call byte_write(lglist(1),noutl,ierr)
               endif
            endif
         enddo
      else
         mtype = nid
         call crecv(mtype,idum,isize) ! hand-shake

         len = isize*(map2d_lown+1)
         call csend(mtype,lglist,len,pid0,0)
      endif

      call mntr_check_abort(stat_id,ierr,
     $     'Error writing global nums in stat_mfo_crd2D')

#ifdef AMR
      ! write refinement level; this code is not optimal, but I don't do it often
      do il = 1,NELV
         itmp(map2d_lmap(il)) = AMR_LEVEL(il)
      enddo
#else
      do il = 1,NELT
         itmp(il) = 0
      enddo
#endif
      ! copy data
      lglist(0) = map2d_lown
      kl = 0
      do il=1,map2d_lnum
         if(map2d_own(il).eq.nid) then
            kl = kl +1
            lglist(kl) = itmp(il)
         endif
      enddo

      if(nid.eq.pid0) then
         noutl = lglist(0)*isize/4
         if(ifmpiio) then
            ioff = iHeaderSize + 4 + (int(map2d_gnum,8) + int(nelb,8))
     $             *isize
            call byte_set_view (ioff,ifh_mbyte)
            call byte_write_mpi (lglist(1),noutl,-1,ifh_mbyte,ierr)
         else
            call byte_write(lglist(1),noutl,ierr)
         endif

         do jl = pid0+1,pid1
            mtype = jl
            call csend(mtype,idum,isize,jl,0) ! handshake
            len = isize*(lelt+1)
            call crecv(mtype,lglist,len)
            if(ierr.eq.0) then
               noutl = lglist(0)*isize/4
               if(ifmpiio) then
                  call byte_write_mpi(lglist(1),noutl,-1,ifh_mbyte,ierr)
               else
                  call byte_write(lglist(1),noutl,ierr)
               endif
            endif
         enddo
      else
         mtype = nid
         call crecv(mtype,idum,isize) ! hand-shake

         len = isize*(map2d_lown+1)
         call csend(mtype,lglist,len,pid0,0)
      endif

      call mntr_check_abort(stat_id,ierr,
     $     'Error writing refinement level in stat_mfo_crd2D')

      ! get 2D elements cell centres
      ! get interpolation operators
      call zwgll(zgml,wgtl,nxl)
      call igllm(iresl,itresl,zgm1,zgml,lx1,nxl,lx1,nxl)

      ! interpolate mesh and extract element centre
      rglist(1,0) = real(map2d_lown)
      kl = 0
      do il=1,map2d_lnum
         if(map2d_own(il).eq.nid) then
            kl = kl +1
            call mxm(iresl,nxl,map2d_xm1(1,1,il),lx1,rtmp1,lx1)
            call mxm (rtmp1,nxl,itresl,lx1,rtmp2,nxl)
            rglist(1,kl) = rtmp2(2,2)
            call mxm(iresl,nxl,map2d_ym1(1,1,il),lx1,rtmp1,lx1)
            call mxm (rtmp1,nxl,itresl,lx1,rtmp2,nxl)
            rglist(2,kl) = rtmp2(2,2)
         endif
      enddo

      ! write down cell centres
      if(nid.eq.pid0) then
         noutl = 2*int(rglist(1,0))*wdsizo/4
         if(ifmpiio) then
            ioff = iHeaderSize + 4 + int(map2d_gnum,8)*2*isize
     $             + int(nelb,8)*2*wdsizo
            call byte_set_view (ioff,ifh_mbyte)
            call byte_write_mpi (rglist(1,1),noutl,-1,ifh_mbyte,ierr)
         else
            call byte_write(rglist(1,1),noutl,ierr)
         endif

         do jl = pid0+1,pid1
            mtype = jl
            call csend(mtype,idum,isize,jl,0) ! handshake
            len = 2*wdsize*(lelt+1)
            call crecv(mtype,rglist,len)
            if(ierr.eq.0) then
               noutl = 2*int(rglist(1,0))*wdsizo/4
               if(ifmpiio) then
                  call byte_write_mpi
     $                 (rglist(1,1),noutl,-1,ifh_mbyte,ierr)
               else
                  call byte_write(rglist(1,1),noutl,ierr)
               endif
            endif
         enddo
      else
         mtype = nid
         call crecv(mtype,idum,isize) ! hand-shake

         len = 2*wdsize*(map2d_lown+1)
         call csend(mtype,rglist,len,pid0,0)
      endif

      call mntr_check_abort(stat_id,ierr,
     $     'Error writing element centres in stat_mfo_crd2D')

      ierr = 0
      if (nid.eq.pid0) then
         if(ifmpiio) then
            call byte_close_mpi(ifh_mbyte,ierr)
         else
            call byte_close(ierr)
         endif
      endif
      call mntr_check_abort(stat_id,ierr,
     $     'Error closing file in stat_mfo_crd2D.')

      return
      end subroutine
!=======================================================================

!> @file mntrtmr_block.f
!! @ingroup monitor
!! @brief Block data to initialise common blocks in MNTRTMRD
!! @details Following Nek5000 standard I keep block data in seaprate file.
!! @author Adam Peplinski
!! @date Oct 13, 2017
!=======================================================================
      block data mntr_tmr_common_init
      include 'MNTRLOGD'
      include 'MNTRTMRD'

      data mntr_tmr_num /0/
      data mntr_tmr_mpos /0/
      data mntr_tmr_id /mntr_tmr_id_size*-1/
      data mntr_tmr_sum /mntr_tmr_id_max*.false./
      data mntr_tmr_name /mntr_tmr_id_max*mntr_blname/
      data mntr_tmrv_timer /mntr_tmr_id_size*0.0/

      end

!> @file io_tools_block.f
!! @ingroup io_tools
!! @brief Block data to initialise common block for I/O routines
!! @details Following Nek5000 standard I keep block data in seaprate file.
!! The minimal unit id has been choosen to not interact with file ids
!! hard-coded in Nek5000.
!! @author Adam Peplinski
!! @date Mar 7, 2016
!=======================================================================
      block data io_common_init
      include 'IOTOOLD'

      data io_iunit_min/200/
      data io_iunit_max/200/
      end

!> @file chkpoint.f
!! @ingroup chkpoint
!! @brief Set of checkpoint routines
!! @details This is a main interface reading/writing runtime parameters
!! and calling proper submodule.
!=======================================================================
!> @brief Register checkpointing module
!! @ingroup chkpoint
!! @note This routine should be called in frame_usr_register
      subroutine chkpt_register()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'CHKPOINTD'

      ! local variables
      integer lpmid
      real ltim

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      ! timing
      ltim = dnekclock()

      ! check if the current module was already registered
      call mntr_mod_is_name_reg(lpmid,chpt_name)
      if (lpmid.gt.0) then
         call mntr_warn(lpmid,
     $        'module ['//trim(chpt_name)//'] already registered')
         return
      endif

      ! find parent module
      call mntr_mod_is_name_reg(lpmid,'FRAME')
      if (lpmid.le.0) then
         lpmid = 1
         call mntr_abort(lpmid,
     $        'Parent module ['//'FRAME'//'] not registered')
      endif

      ! register module
      call mntr_mod_reg(chpt_id,lpmid,chpt_name,'Checkpointing I/O')

      ! register timer
      call mntr_tmr_is_name_reg(lpmid,'FRM_TOT')
      call mntr_tmr_reg(chpt_ttot_id,lpmid,chpt_id,
     $      'CHP_TOT','Checkpointing total time',.false.)

      call mntr_tmr_reg(chpt_tini_id,chpt_ttot_id,chpt_id,
     $      'CHP_INI','Checkpointing initialisation time',.true.)

      ! register and set active section
      call rprm_sec_reg(chpt_sec_id,chpt_id,'_'//adjustl(chpt_name),
     $     'Runtime paramere section for checkpoint module')
      call rprm_sec_set_act(.true.,chpt_sec_id)

      ! register parameters
      call rprm_rp_reg(chpt_ifrst_id,chpt_sec_id,'READCHKPT',
     $     'Restat from checkpoint',rpar_log,0,0.0,.false.,' ')

      call rprm_rp_reg(chpt_fnum_id,chpt_sec_id,'CHKPFNUMBER',
     $     'Restart file number',rpar_int,1,0.0,.false.,' ')

      call rprm_rp_reg(chpt_step_id,chpt_sec_id,'CHKPINTERVAL',
     $     'Checkpiont saving frequency (number of time steps)',
     $      rpar_int,500,0.0,.false.,' ')

      ! set initial step delay
      call mntr_set_step_delay(1)

      ! call submodule registration
      call chkpts_register

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(chpt_tini_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Initilise checkpointing module
!! @ingroup chkpoint
!! @note This routine should be called in frame_usr_init
      subroutine chkpt_init()
      implicit none

      include 'SIZE'
      include 'TSTEP'
      include 'FRAMELP'
      include 'CHKPOINTD'

      ! local variables
      integer itmp, lstdl
      real rtmp, ltim
      logical ltmp
      character*20 ctmp
      character*2 str
      character*200 lstring

      ! functions
      logical chkpts_is_initialised
      real dnekclock
!-----------------------------------------------------------------------
      ! check if the module was already initialised
      if (chpt_ifinit) then
         call mntr_warn(chpt_id,
     $        'module ['//trim(chpt_name)//'] already initiaised.')
         ! check submodule intialisation
         if (.not.chkpts_is_initialised()) then
            call mntr_abort(chpt_id,
     $        'required submodule module not initiaised.')
         endif
         return
      endif

      ! timing
      ltim = dnekclock()

      ! get runtime parameters
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,chpt_ifrst_id,rpar_log)
      chpt_ifrst = ltmp
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,chpt_fnum_id,rpar_int)
      chpt_fnum = itmp
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,chpt_step_id,rpar_int)
      chpt_step = itmp

      if (chpt_ifrst) then
      ! get input set number
         chpt_set_i = chpt_fnum - 1
         if (chpt_set_i.ge.chpt_nset) then
            write(str,'(I2)') chpt_nset + 1
            lstring = 'chpt_fnum must be in the range: 1-'//trim(str)
            call mntr_abort(chpt_id,lstring)
         endif

         chpt_set_o = mod(chpt_set_i+1,chpt_nset)
      else
         chpt_set_o = 0
      endif

      ! set reset flag
      chpt_reset = -1

      ! check number of steps
      call mntr_get_step_delay(lstdl)
      if (NSTEPS.lt.3*lstdl) then
         call mntr_abort(chpt_id,'too short run for multi-file restart')
      endif

      ! check checkpoint frequency
      if (chpt_step.lt.2*lstdl.or.chpt_step.gt.NSTEPS) then
         chpt_step = NSTEPS
         call mntr_warn(chpt_id,'wrong chpt_step; resetting to NSTEPS')
      endif

      ! set min and max ISTEP for cyclic checkpoint writning
      ! timesteps outside this bouds require special treatment
      chpt_istep = lstdl
      chpt_nstep = NSTEPS - lstdl - 1
      ! check if chpt_nstep is in the middle of writing cycle
      itmp = chpt_nstep + chpt_step -1
      if (mod(itmp,chpt_step).ge.(chpt_step-lstdl)) then
         itmp = lstdl + mod(itmp,chpt_step) + 1 - chpt_step
         chpt_nstep = chpt_nstep - itmp
      endif

      ! call submodule initialisation
      call chkpts_init

      ! is everything initialised
      if (chkpts_is_initialised()) chpt_ifinit=.true.

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(chpt_tini_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Check if module was initialised
!! @ingroup chkpoint
!! @return chkpt_is_initialised
      logical function chkpt_is_initialised()
      implicit none

      include 'SIZE'
      include 'CHKPOINTD'
!-----------------------------------------------------------------------
      chkpt_is_initialised = chpt_ifinit

      return
      end function
!=======================================================================
!> @brief Main checkpoint interface
!! @ingroup chkpoint
!! @note This routine should be called in userchk as a first framework call
!     after frame_monitor
      subroutine chkpt_main
      implicit none

      include 'SIZE'
      include 'TSTEP'
      include 'CHKPOINTD'

      ! local variables
      integer itmp, lstdl
!-----------------------------------------------------------------------
      if(chpt_ifrst.and.ISTEP.le.chpt_istep) then
         call chkpts_read
      elseif (ISTEP.gt.chpt_istep) then

      ! adjust max ISTEP for cyclic checkpoint writning
         call mntr_get_step_delay(lstdl)
         chpt_nstep = NSTEPS - lstdl -1
      ! check if chpt_nstep is in the middle of writing cycle
         itmp = chpt_nstep + chpt_step -1
         if (mod(itmp,chpt_step).ge.(chpt_step-lstdl)) then
            itmp = lstdl + mod(itmp,chpt_step) + 1 - chpt_step
            chpt_nstep = chpt_nstep - itmp
         endif

      ! count steps to the end of wrting stage
         itmp = ISTEP + chpt_step -1
         if (ISTEP.gt.(NSTEPS-lstdl)) then
            chpt_stepc = NSTEPS-ISTEP+1
         elseif (ISTEP.lt.chpt_nstep.and.
     $    mod(itmp,chpt_step).ge.(chpt_step-lstdl)) then
            chpt_stepc = chpt_step - mod(itmp,chpt_step)
         else
            chpt_stepc = -1
         endif

      ! get the checkpoint set number
      ! to avoid conflicts with dependent packages I reset chpt_set_o
      ! during the step after checkpointing
         if (ISTEP.lt.chpt_nstep.and.mod(ISTEP,chpt_step).eq.0) then
            chpt_reset = mod(chpt_set_o+1,chpt_nset)
         elseif (chpt_reset.ge.0) then
            chpt_set_o = chpt_reset
            chpt_reset = -1
         endif

         call chkpts_write
      endif

      return
      end subroutine
!=======================================================================
!> @brief Get step count to the checkpoint and a set number
!! @ingroup chkpoint
!! @param[out] step_cnt   decreasing step count in checkpoint writinh phase (otherwise -1)
!! @param[out] set_out    set number
      subroutine chkpt_get_fset(step_cnt, set_out)
      implicit none

      include 'SIZE'
      include 'CHKPOINTD'

      ! argument list
      integer step_cnt, set_out
!-----------------------------------------------------------------------
      step_cnt = chpt_stepc
      set_out  = chpt_set_o

      return
      end subroutine
!=======================================================================

!> @file sfd.f
!! @ingroup sfd
!! @brief Selective frequency damping (SFD) in nekton
!! @author Adam Peplinski
!! @date Feb 6, 2017
!=======================================================================
!> @brief Register SFD module
!! @ingroup sfd
!! @note This routine should be called in frame_usr_register
      subroutine sfd_register()
      implicit none

      include 'SIZE'
      include 'FRAMELP'
      include 'SFDD'

      ! local variables
      integer lpmid
      real ltim

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      ! timing
      ltim = dnekclock()

      ! check if the current module was already registered
      call mntr_mod_is_name_reg(lpmid,sfd_name)
      if (lpmid.gt.0) then
         call mntr_warn(lpmid,
     $        'module ['//trim(sfd_name)//'] already registered')
         return
      endif

      ! find parent module
      call mntr_mod_is_name_reg(lpmid,'FRAME')
      if (lpmid.le.0) then
         lpmid = 1
         call mntr_abort(lpmid,
     $        'Parent module ['//'FRAME'//'] not registered')
      endif

      ! register module
      call mntr_mod_reg(sfd_id,lpmid,sfd_name,
     $    'Selective Frequency Damping')

      ! register timer
      call mntr_tmr_is_name_reg(lpmid,'FRM_TOT')
      call mntr_tmr_reg(sfd_ttot_id,lpmid,sfd_id,
     $      'SFD_TOT','SFD total time',.false.)

      call mntr_tmr_reg(sfd_tini_id,sfd_ttot_id,sfd_id,
     $      'SFD_INI','SFD initialisation time',.true.)

      call mntr_tmr_reg(sfd_tevl_id,sfd_ttot_id,sfd_id,
     $      'SFD_EVL','SFD evolution time',.true.)

      call mntr_tmr_reg(sfd_tchp_id,sfd_ttot_id,sfd_id,
     $      'SFD_CHP','SFD checkpoint saving time',.true.)

      call mntr_tmr_reg(sfd_tend_id,sfd_ttot_id,sfd_id,
     $      'SFD_END','SFD finalilsation time',.true.)

      ! register and set active section
      call rprm_sec_reg(sfd_sec_id,sfd_id,'_'//adjustl(sfd_name),
     $     'Runtime paramere section for SFD module')
      call rprm_sec_set_act(.true.,sfd_sec_id)

      ! register parameters
      call rprm_rp_reg(sfd_dlt_id,sfd_sec_id,'FILTERWDTH',
     $     'SFD filter width',rpar_real,0,1.0,.false.,' ')

      call rprm_rp_reg(sfd_chi_id,sfd_sec_id,'CONTROLCFF',
     $     'SFD control coefficient',rpar_real,0,1.0,.false.,' ')

      call rprm_rp_reg(sfd_tol_id,sfd_sec_id,'RESIDUALTOL',
     $     'SFD tolerance for residual',rpar_real,0,1.0,.false.,' ')

      call rprm_rp_reg(sfd_cnv_id,sfd_sec_id,'LOGINTERVAL',
     $     'SFD frequency for logging convegence data',
     $      rpar_int,0,1.0,.false.,' ')

      call rprm_rp_reg(sfd_ifrst_id,sfd_sec_id,'SFDREADCHKPT',
     $     'SFD; restat from checkpoint',
     $      rpar_log,0,1.0,.false.,' ')

      ! initialisation flag
      sfd_ifinit = .false.

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(sfd_tini_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Initialise SFD module
!! @ingroup sfd
!! @note This routine should be called in frame_usr_init
      subroutine sfd_init()
      implicit none

      include 'SIZE'
      include 'SOLN'
      include 'INPUT'
      include 'TSTEP'
      include 'FRAMELP'
      include 'SFDD'

      ! local variables
      integer itmp, il
      real rtmp, ltim
      logical ltmp
      character*20 ctmp
      character*2 str
      character*200 lstring

      ! to get checkpoint runtime parameters
      integer ierr, lmid, lsid, lrpid

      ! functions
      integer frame_get_master
      real dnekclock
!-----------------------------------------------------------------------
      ! check if the module was already initialised
      if (sfd_ifinit) then
         call mntr_warn(sfd_id,
     $        'module ['//trim(sfd_name)//'] already initiaised.')
         return
      endif

      ! timing
      ltim = dnekclock()

      ! get runtime parameters
      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,sfd_dlt_id,rpar_real)
      sfd_dlt = abs(rtmp)
      if (sfd_dlt.gt.0.0) then
         sfd_dlt = 1.0/sfd_dlt
      else
         call mntr_abort(sfd_id,
     $            'sfd_init; Filter width must be positive.')
      endif

      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,sfd_chi_id,rpar_real)
      sfd_chi = abs(rtmp)
      if (sfd_chi.le.0.0) call mntr_abort(sfd_id,
     $            'sfd_init; Forcing control must be positive.')

      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,sfd_tol_id,rpar_real)
      sfd_tol = abs(rtmp)
      if (sfd_tol.le.0.0) call mntr_abort(sfd_id,
     $            'sfd_init; Residual tolerance must be positive.')

      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,sfd_cnv_id,rpar_int)
      sfd_cnv = abs(itmp)

      call rprm_rp_get(itmp,rtmp,ltmp,ctmp,sfd_ifrst_id,rpar_log)
      sfd_ifrst = ltmp

      ! check if checkpointing module was registered and take parameters
      ierr = 0
      call mntr_mod_is_name_reg(lmid,'CHKPOINT')
      if (lmid.gt.0) then
         call rprm_sec_is_name_reg(lsid,lmid,'_CHKPOINT')
         if (lsid.gt.0) then
            ! restart flag
            call rprm_rp_is_name_reg(lrpid,lsid,'READCHKPT',rpar_log)
            if (lrpid.gt.0) then
               call rprm_rp_get(itmp,rtmp,ltmp,ctmp,lrpid,rpar_log)
               sfd_chifrst = ltmp
            else
               ierr = 1
               goto 30
            endif
            if (sfd_chifrst) then
               ! checkpoint set number
               call rprm_rp_is_name_reg(lrpid,lsid,'CHKPFNUMBER',
     $              rpar_int)
               if (lrpid.gt.0) then
                  call rprm_rp_get(itmp,rtmp,ltmp,ctmp,lrpid,rpar_int)
                  sfd_fnum = itmp
               else
                  ierr = 1
                  goto 30
               endif
            endif
         else
            ierr = 1
         endif
      else
         ierr = 1
      endif

 30   continue

      ! check for errors
      call mntr_check_abort(sfd_id,ierr,
     $            'Error reading checkpoint parameters')

      ! check restart flags
      if (sfd_ifrst.and.(.not.sfd_chifrst)) call mntr_abort(sfd_id,
     $            'sfd_init; Restart flagg missmatch.')

      ! check simulation parameters
      if (.not.IFTRAN) call mntr_abort(sfd_id,
     $            'sfd_init; SFD requres transient equations')

      if (IFPERT) call mntr_abort(sfd_id,
     $            'sfd_init; SFD cannot be run in perturbation mode')

      ! get number of snapshots in a set
      if (PARAM(27).lt.0) then
         sfd_nsnap = NBDINP
      else
         sfd_nsnap = 3
      endif

      ! initialise module arrays
      if (sfd_ifrst) then
         ! read checkpoint
         call sfd_rst_read
      else
         itmp = nx1*ny1*nz1*nelv
         do il=1,3
            call rzero(sfd_vxlag(1,1,1,1,il),itmp)
            call rzero(sfd_vylag(1,1,1,1,il),itmp)
            if (if3d )call rzero(sfd_vzlag(1,1,1,1,il),itmp)
         enddo

         call opcopy (sfd_vx,sfd_vy,sfd_vz,vx,vy,vz)
      endif

      ! get the forcing (difference between v? and sfd_v?)
      call opsub3(sfd_bfx,sfd_bfy,sfd_bfz,vx,vy,vz,sfd_vx,sfd_vy,sfd_vz)

      ! open the file for convergence history
      ierr = 0
      if (nid.eq.frame_get_master()) then
         call io_file_freeid(sfd_fid, ierr)
         if (ierr.eq.0) then
            open (unit=sfd_fid,file='SFDconv.out',status='new',
     $           action='write',iostat=ierr)
         endif
      endif

      ! check for errors
      call mntr_check_abort(sfd_id,ierr,
     $            'Error opening convergence file.')

      ! initialise storage arrays
      call rzero(sfd_abx1,itmp)
      call rzero(sfd_abx2,itmp)
      call rzero(sfd_aby1,itmp)
      call rzero(sfd_aby2,itmp)
      call rzero(sfd_abz1,itmp)
      call rzero(sfd_abz2,itmp)

      ! initialisation flag
      sfd_ifinit = .true.

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(sfd_tini_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Check if module was initialised
!! @ingroup sfd
!! @return sfd_is_initialised
      logical function sfd_is_initialised()
      implicit none

      include 'SIZE'
      include 'SFDD'
!-----------------------------------------------------------------------
      sfd_is_initialised = sfd_ifinit

      return
      end function
!=======================================================================
!> @brief Finalise SFD
!! @ingroup sfd
!! @note This routine should be called in frame_usr_end
      subroutine sfd_end
      implicit none

      include 'SIZE'            ! NID, NDIM, NPERT
      include 'INPUT'           ! IF3D
      include 'RESTART'
      include 'SOLN'
      include 'FRAMELP'
      include 'SFDD'

      ! local variables
      integer ntot1, il
      real ltim
      real ab0, ab1, ab2

      logical lifxyo, lifpo, lifvo, lifto, lifreguo, lifpso(LDIMT1)

      ! functions
      integer frame_get_master
      real dnekclock, gl2norm
!-----------------------------------------------------------------------
      ! timing
      ltim = dnekclock()

      ! final convergence
      ntot1 = nx1*ny1*nz1*nelv

      ! calculate L2 norms
      ab0 = gl2norm(sfd_bfx,ntot1)
      ab1 = gl2norm(sfd_bfy,ntot1)
      if (if3d) ab2 = gl2norm(sfd_bfz,ntot1)

      ! stamp the log
      call mntr_log(sfd_id,lp_prd,
     $              'Final convergence (L2 norm per grid point):')
      call mntr_logr(sfd_id,lp_prd,'DVX = ',ab0)
      call mntr_logr(sfd_id,lp_prd,'DVY = ',ab1)
      if (if3d) call mntr_logr(sfd_id,lp_prd,'DVZ = ',ab2)
      call mntr_log(sfd_id,lp_prd,'Saving velocity difference')

      ! save the velocity difference for inspection
      lifxyo= ifxyo
      ifxyo = .true.
      lifpo= ifpo
      ifpo = .false.
      lifvo= ifvo
      ifvo = .true.
      lifto= ifto
      ifto = .false.
      do il=1,ldimt1
         lifpso(il)= ifpso(il)
         ifpso(il) = .false.
      enddo

      call outpost2(sfd_bfx,sfd_bfy,sfd_bfz,pr,t,0,'vdf')

      ifxyo = lifxyo
      ifpo = lifpo
      ifvo = lifvo
      ifto = lifto
      do il=1,ldimt1
         ifpso(il) = lifpso(il)
      enddo

      ! close file with convergence history
      if (nid.eq.frame_get_master()) close(sfd_fid)

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(sfd_tend_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Main SFD interface
!! @ingroup sfd
      subroutine sfd_main
      implicit none
!-----------------------------------------------------------------------
      call sfd_solve
      call sfd_rst_write

      return
      end subroutine
!=======================================================================
!> @brief Calcualte SFD forcing
!! @ingroup sfd
!! @param[inout] ffx,ffy,ffz     forcing; x,y,z component
!! @param[in]    ix,iy,iz        GLL point index
!! @param[in]    ieg             global element number
      subroutine sfd_forcing(ffx,ffy,ffz,ix,iy,iz,ieg)
      implicit none

      include 'SIZE'            !
      include 'INPUT'           ! IF3D
      include 'PARALLEL'        ! GLLEL
      include 'SFDD'

      ! argument list
      real ffx, ffy, ffz
      integer ix,iy,iz,ieg

      ! local variables
      integer iel
!-----------------------------------------------------------------------
      iel=GLLEL(ieg)
      ffx = ffx - sfd_chi*sfd_bfx(ix,iy,iz,iel)
      ffy = ffy - sfd_chi*sfd_bfy(ix,iy,iz,iel)
      if (if3d) ffz = ffz - sfd_chi*sfd_bfz(ix,iy,iz,iel)

      return
      end subroutine
!=======================================================================
!> @brief Update filtered velocity field.
!! @ingroup sfd
!! @details Sum up contributions to kth order extrapolation scheme and
!!   get new filtered velocity field.
!!   This subroutine is based on @ref makeabf and  @ref makebdf
!! @remark This routine uses global scratch space \a SCRUZ.
      subroutine sfd_solve
      implicit none

      include 'SIZE'
      include 'SOLN'
      include 'TSTEP'           ! ISTEP, TIME, NSTEPS, LASTEP
      include 'INPUT'           ! IF3D
      include 'FRAMELP'
      include 'SFDD'

      ! temporary storage
      real  TA1 (LX1,LY1,LZ1,LELV), TA2 (LX1,LY1,LZ1,LELV),
     $      TA3 (LX1,LY1,LZ1,LELV)
      COMMON /SCRUZ/ TA1, TA2, TA3

      ! local variables
      integer ntot1, ilag
      real ltim
      real ab0, ab1, ab2

      ! functions
      integer frame_get_master
      real dnekclock, gl2norm
!-----------------------------------------------------------------------
      if (istep.eq.0) return

      ! timing
      ltim = dnekclock()

      ! active array length
      ntot1 = NX1*NY1*NZ1*NELV

      ! A-B part
      ! current rhs
      ! I use BFS? vectors generated during the convergence tests so skip this step
!          call opsub3(sfd_bfx,sfd_bfy,sfd_bfz,vxlag,vylag,vzlag,
!     $                sfd_vx,sfd_vy,sfd_vz)
      ! finish rhs
      call opcmult(sfd_bfx,sfd_bfy,sfd_bfz,sfd_dlt)

      ! old time steps
      ab0 = AB(1)
      ab1 = AB(2)
      ab2 = AB(3)
      call add3s2(ta1,sfd_abx1,sfd_abx2,ab1,ab2,ntot1)
      call add3s2(ta2,sfd_aby1,sfd_aby2,ab1,ab2,ntot1)
      ! save rhs
      call copy(sfd_abx2,sfd_abx1,ntot1)
      call copy(sfd_aby2,sfd_aby1,ntot1)
      call copy(sfd_abx1,sfd_bfx,ntot1)
      call copy(sfd_aby1,sfd_bfy,ntot1)
      ! current
      call add2s1 (sfd_bfx,ta1,ab0,ntot1)
      call add2s1 (sfd_bfy,ta2,ab0,ntot1)
      if (if3d) then
         call add3s2 (ta3,sfd_abz1,sfd_abz2,ab1,ab2,ntot1)
         call copy   (sfd_abz2,sfd_abz1,ntot1)
         call copy   (sfd_abz1,sfd_bfz,ntot1)
         call add2s1 (sfd_bfz,ta3,ab0,ntot1)
      endif

      ! multiplication by time step
      call opcmult(sfd_bfx,sfd_bfy,sfd_bfz,dt)

      ! BD part
      ab0 = bd(2)
      call opadd2cm(sfd_bfx,sfd_bfy,sfd_bfz,sfd_vx,sfd_vy,sfd_vz,ab0)

      do ilag=2,nbd
         ab0 = bd(ilag+1)
         call opadd2cm(sfd_bfx,sfd_bfy,sfd_bfz,
     $           sfd_vxlag (1,1,1,1,ilag-1),sfd_vylag (1,1,1,1,ilag-1),
     $           sfd_vzlag (1,1,1,1,ilag-1),ab0)
      enddo

      ! take into account restart option
      if (sfd_ifrst.and.(istep.lt.sfd_nsnap))
     $   call opcopy (ta1,ta2,ta3,sfd_vxlag(1,1,1,1,sfd_nsnap-1),
     $   sfd_vylag(1,1,1,1,sfd_nsnap-1),sfd_vzlag(1,1,1,1,sfd_nsnap-1))

      ! keep old filtered velocity fields
      do ilag=3,2,-1
         call opcopy(sfd_vxlag(1,1,1,1,ilag),sfd_vylag(1,1,1,1,ilag),
     $        sfd_vzlag(1,1,1,1,ilag),sfd_vxlag(1,1,1,1,ilag-1),
     $        sfd_vylag(1,1,1,1,ilag-1),sfd_vzlag(1,1,1,1,ilag-1))
      enddo

      call opcopy (sfd_vxlag,sfd_vylag,sfd_vzlag,sfd_vx,sfd_vy,sfd_vz)

      ! calculate new filtered velocity field
      ! take into account restart option
      if (sfd_ifrst.and.(istep.lt.sfd_nsnap)) then
         call opcopy (sfd_vx,sfd_vy,sfd_vz,ta1,ta2,ta3)
      else
         ab0 = 1.0/bd(1)
         call opcopy (sfd_vx,sfd_vy,sfd_vz,sfd_bfx,sfd_bfy,sfd_bfz)
         call opcmult(sfd_vx,sfd_vy,sfd_vz,ab0)
      endif

      ! convergence test
      ! find the difference between V? and VS?
      call opsub3(sfd_bfx,sfd_bfy,sfd_bfz,vx,vy,vz,sfd_vx,sfd_vy,sfd_vz)

      ! calculate L2 norms
      ab0 = gl2norm(sfd_bfx,ntot1)
      ab1 = gl2norm(sfd_bfy,ntot1)
      if (if3d) ab2 = gl2norm(sfd_bfz,ntot1)

      ! for tracking convergence
      if (mod(istep,sfd_cnv).eq.0) then
         if (nid.eq.frame_get_master()) then
            if (if3d) then
               write(sfd_fid,'(4e13.5)') time, ab0, ab1, ab2
            else
               write(sfd_fid,'(3e13.5)') time, ab0, ab1
            endif
         endif

         ! stamp the log
         call mntr_log(sfd_id,lp_prd,
     $              'Convergence (L2 norm per grid point):')
         call mntr_logr(sfd_id,lp_prd,'DVX = ',ab0)
         call mntr_logr(sfd_id,lp_prd,'DVY = ',ab1)
         if (if3d) call mntr_logr(sfd_id,lp_prd,'DVZ = ',ab2)
      endif

      ! check stopping criteria
      if (istep.gt.sfd_nsnap) then ! to ensure proper restart
         ab0 = max(ab0,ab1)
         if (if3d) ab0 = max(ab0,ab2)
         if (ab0.lt.sfd_tol) then
            call mntr_log(sfd_id,lp_ess,'Stopping criteria reached')
            call mntr_set_conv(.TRUE.)
         endif
      endif

      ! timing
      ltim = dnekclock() - ltim
      call mntr_tmr_add(sfd_tevl_id,1,ltim)

      return
      end subroutine
!=======================================================================
!> @brief Create checkpoint
!! @ingroup sfd
      subroutine sfd_rst_write
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'RESTART'
      include 'TSTEP'
      include 'FRAMELP'
      include 'SFDD'

      ! local variables
      integer step_cnt, set_out
      real ltim
      integer lwdsizo
      integer ipert, il, ierr
      logical lif_full_pres, lifxyo, lifpo, lifvo, lifto,
     $        lifpsco(LDIMT1), ifreguol

      character*132 fname, bname
      character*3 prefix
      character*6  str

      ! functions
      real dnekclock
!-----------------------------------------------------------------------
      ! avoid writing during possible restart reading
      call mntr_get_step_delay(step_cnt)
      if (istep.le.step_cnt) return

      ! get step count and file set number
      call chkpt_get_fset(step_cnt, set_out)

      ! we write everything in single step
      if (step_cnt.eq.1) then
         ltim = dnekclock()

         call mntr_log(sfd_id,lp_inf,'Writing checkpoint snapshot')

         ! adjust I/O parameters
         lwdsizo = WDSIZO
         WDSIZO  = 8
         lif_full_pres = IF_FULL_PRES
         IF_FULL_PRES = .false.
         lifxyo = IFXYO
         IFXYO = .false.
         lifpo= IFPO
         IFPO = .false.
         lifvo= IFVO
         IFVO = .true.
         lifto= IFTO
         IFTO = .false.
         do il=1,NPSCAL
            lifpsco(il)= IFPSCO(il)
            IFPSCO(il) = .TRUE.
         enddo
         ifreguol= IFREGUO
         IFREGUO = .false.

         ! initialise I/O data
         call io_init

         ! get file name
         prefix = 'SFD'
         bname = trim(adjustl(SESSION))
         call io_mfo_fname(fname,bname,prefix,ierr)
         call mntr_check_abort(sfd_id,ierr,
     $       'sfd_rst_write; file name error')
         write(str,'(i5.5)') set_out + 1
         fname=trim(fname)//trim(str(1:5))

         ! save filtered valocity field
         call sfd_mfo(fname)

         ! put parameters back
         WDSIZO = lwdsizo
         IF_FULL_PRES = lif_full_pres
         IFXYO = lifxyo
         IFPO = lifpo
         IFVO = lifvo
         IFTO = lifto
         do il=1,NPSCAL
            IFPSCO(il) = lifpsco(il)
         enddo
         IFREGUO = ifreguol

         ! timing
         ltim = dnekclock() - ltim
         call mntr_tmr_add(sfd_tchp_id,1,ltim)
      endif

      return
      end subroutine
!=======================================================================
!> @brief Read from checkpoint
!! @ingroup sfd
!! @remark This routine uses global scratch space \a SCRUZ.
      subroutine sfd_rst_read
      implicit none

      include 'SIZE'            ! NID, NDIM, NPERT
      include 'INPUT'
      include 'FRAMELP'
      include 'SFDD'

      ! temporary storage
      real TA1 (LX1,LY1,LZ1,LELV), TA2 (LX1,LY1,LZ1,LELV),
     $     TA3 (LX1,LY1,LZ1,LELV)
      COMMON /SCRUZ/ TA1, TA2, TA3

      ! local variables
      integer ilag, ierr
      logical ifreguol

      character*132 fname, bname
      character*3 prefix
      character*6  str
!-----------------------------------------------------------------------
      ! stamp logs
      call mntr_log(sfd_id,lp_inf,'Reading checkpoint')

      ! no regular mesh
      ifreguol= ifreguo
      ifreguo = .false.

      ! initialise I/O data
      call io_init

      ! create file name
      prefix = 'SFD'
      bname = trim(adjustl(SESSION))
      call io_mfo_fname(fname,bname,prefix,ierr)
      call mntr_check_abort(sfd_id,ierr,'sfd_rst_read; file name error')
      write(str,'(i5.5)') sfd_fnum
      fname=trim(fname)//trim(str(1:5))

      ! read filtered velocity field
      call sfd_mfi(fname)

      ! put parameters back
      ifreguo = ifreguol

      ! move velcity fields to sotre oldest one in VS?
      call opcopy (ta1,ta2,ta3,sfd_vxlag(1,1,1,1,sfd_nsnap-1),
     $   sfd_vylag(1,1,1,1,sfd_nsnap-1),sfd_vzlag(1,1,1,1,sfd_nsnap-1))

      do ilag=sfd_nsnap-1,2,-1
         call opcopy(sfd_vxlag(1,1,1,1,ilag),sfd_vylag(1,1,1,1,ilag),
     $        sfd_vzlag(1,1,1,1,ilag),sfd_vxlag(1,1,1,1,ilag-1),
     $        sfd_vylag(1,1,1,1,ilag-1),sfd_vzlag(1,1,1,1,ilag-1))
      enddo

      call opcopy (sfd_vxlag,sfd_vylag,sfd_vzlag,sfd_vx,sfd_vy,sfd_vz)
      call opcopy (sfd_vx,sfd_vy,sfd_vz,ta1,ta2,ta3)

      return
      end subroutine
!=======================================================================
!> @brief Store SFD restart file
!! @ingroup sfd
!! @details This rouotine is version of @ref mfo_outfld adjusted for SFD restart.
!! @param[in]   fname      file name
!! @note This routine uses standard header wirter so cannot pass additional
!!    information in the file header. That is why I save whole lag spce
!!    irrespective of  chpm_nsnap value.
      subroutine sfd_mfo(fname)
      implicit none

      include 'SIZE'
      include 'RESTART'
      include 'PARALLEL'
      include 'INPUT'
      include 'FRAMELP'
      INCLUDE 'SFDD'

      ! argument list
      character*132 fname

      ! local variables
      integer il, ierr, ioflds, nout
      integer*8 offs

      real tiostart, tio, dnbyte

      ! functions
      real dnekclock_sync, glsum
!-----------------------------------------------------------------------
      ! simple timing
      tiostart=dnekclock_sync()

      nout = NELT
      NXO  = NX1
      NYO  = NY1
      NZO  = NZ1

      ! open file
      ierr = 0
      call io_mbyte_open(fname,ierr)
      call mntr_check_abort(sfd_id,ierr,'sfd_mfo; file not opened.')

      ! write a header and create element mapping
      call mfo_write_hdr

      ! set offset
      offs = iHeaderSize + 4 + isize*nelgt
      ioflds = 0

      ! write fields
      ! current filtered velocity field
      call io_mfov(offs,sfd_vx,sfd_vy,sfd_vz,nx1,ny1,nz1,nelt,
     $      nelgt,ndim)
      ioflds = ioflds + ndim

      ! history
      do il=1,3
         call io_mfov(offs,sfd_vxlag(1,1,1,1,il),sfd_vylag(1,1,1,1,il),
     $           sfd_vzlag(1,1,1,1,il),nx1,ny1,nz1,nelt,nelgt,ndim)
         ioflds = ioflds + ndim
      enddo

      dnbyte = 1.*ioflds*nelt*wdsizo*nx1*ny1*nz1

      ! close file
      call io_mbyte_close(ierr)
      call mntr_check_abort(sfd_id,ierr,'sfd_mfo; file not closed.')

      ! stamp the log
      tio = dnekclock_sync()-tiostart
      if (tio.le.0) tio=1.

      dnbyte = glsum(dnbyte,1)
      dnbyte = dnbyte + iHeaderSize + 4. +ISIZE*NELGT
      dnbyte = dnbyte/1024/1024

      call mntr_log(sfd_id,lp_prd,'Checkpoint written:')
      call mntr_logr(sfd_id,lp_vrb,'file size (MB) = ',dnbyte)
      call mntr_logr(sfd_id,lp_vrb,'avg data-throughput (MB/s) = ',
     $     dnbyte/tio)
      call mntr_logi(sfd_id,lp_vrb,'io-nodes = ',nfileo)

      return
      end subroutine
!=======================================================================
!> @brief Load SFD restart file
!! @ingroup sfd
!! @details This rouotine is version of @ref mfi adjusted ofr SFD restart.
!! @param[in]   fname      file name
!! @note This routine uses standard header reader and cannot pass additiona
!!    information in the file. That is why I read whole lag spce irrespective
!!    of  sfd_nsnap value.
!! @remark This routine uses global scratch space \a SCRUZ.
      subroutine sfd_mfi(fname)
      implicit none

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'RESTART'
      include 'FRAMELP'
      include 'SFDD'

      ! argument lilst
      character*132 fname

      ! local variables
      integer il, ioflds, ierr
      integer*8 offs
      real tiostart, tio, dnbyte
      logical ifskip

      !     scratch arrays
      integer lwkv
      parameter (lwkv = lx1*ly1*lz1*lelt)
      real wkv1(lwkv),wkv2(lwkv),wkv3(lwkv)
      common /scruz/ wkv1,wkv2,wkv3

      ! functions
      real dnekclock_sync, glsum
!-----------------------------------------------------------------------
      ! simple timing
      tiostart=dnekclock_sync()

      ! open file, get header information and read mesh data
      call mfi_prepare(fname)

      ! set header offset
      offs = iHeaderSize + 4 + isize*nelgr
      ioflds = 0
      ifskip = .FALSE.

      ! read arrays
      ! filtered velocity
      if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
         ! unchanged resolution
         ! read field directly to the variables
         call io_mfiv(offs,sfd_vx,sfd_vy,sfd_vz,lx1,ly1,lz1,lelv,ifskip)
      else
         ! modified resolution
         ! read field to tmp array
         call io_mfiv(offs,wkv1,wkv2,wkv3,nxr,nyr,nzr,lelt,ifskip)

         ! interpolate
         call chkpt_map_gll(sfd_vx,wkv1,nxr,nzr,nelv)
         call chkpt_map_gll(sfd_vy,wkv2,nxr,nzr,nelv)
         if (if3d) call chkpt_map_gll(sfd_vz,wkv3,nxr,nzr,nelv)
      endif
      ioflds = ioflds + ndim

      ! history
      do il=1,3
         if ((nxr.eq.lx1).and.(nyr.eq.ly1).and.(nzr.eq.lz1)) then
            ! unchanged resolution
            ! read field directly to the variables
            call io_mfiv(offs,sfd_vxlag(1,1,1,1,il),
     $           sfd_vylag(1,1,1,1,il),sfd_vzlag(1,1,1,1,il),
     $           lx1,ly1,lz1,lelv,ifskip)
         else
            ! modified resolution
            ! read field to tmp array
            call io_mfiv(offs,wkv1,wkv2,wkv3,nxr,nyr,nzr,lelt,ifskip)

            ! interpolate
            call chkpt_map_gll(sfd_vxlag(1,1,1,1,il),wkv1,nxr,nzr,nelv)
            call chkpt_map_gll(sfd_vylag(1,1,1,1,il),wkv2,nxr,nzr,nelv)
            if (if3d) call chkpt_map_gll(sfd_vzlag(1,1,1,1,il),wkv3,
     $                     nxr,nzr,nelv)
         endif
         ioflds = ioflds + ndim
      enddo

      ! close file
      call io_mbyte_close(ierr)
      call mntr_check_abort(sfd_id,ierr,'sfd_mfi; file not closed.')

      ! stamp the log
      tio = dnekclock_sync()-tiostart
      if (tio.le.0.0) tio=1.

      if(nid.eq.pid0r) then
         dnbyte = 1.*ioflds*nelr*wdsizr*nxr*nyr*nzr
      else
         dnbyte = 0.0
      endif

      dnbyte = glsum(dnbyte,1)
      dnbyte = dnbyte + iHeaderSize + 4. + isize*nelgt
      dnbyte = dnbyte/1024/1024

      call mntr_log(sfd_id,lp_prd,'Checkpoint read:')
      call mntr_logr(sfd_id,lp_vrb,'avg data-throughput (MB/s) = ',
     $     dnbyte/tio)
      call mntr_logi(sfd_id,lp_vrb,'io-nodes = ',nfileo)

      if (ifaxis) call mntr_abort(sfd_id,
     $                 'sfd_mfi; axisymmetric case not supported')

      return
      end subroutine
!=======================================================================
